package com.xxh.cloud.dw.healthy.data.engine.manager.controller;


import cn.hutool.core.date.DateUtil;
import cn.hutool.core.lang.Console;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.dw.healthy.engine.modules.biz.service.DataPatientEventRuleRunService;
import com.xxh.cloud.dw.healthy.engine.modules.data.bean.bos.DwdPatientDataBO;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.PatientDataLabel2EventService;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.RuleEngineDataService;
import com.xxh.cloud.dw.healthy.engine.modules.exe.service.DwdDataExecuteLabelService;
import com.xxh.cloud.dw.healthy.engine.modules.exe.service.DwdDataExecuteRuleFlowService;
import com.xxh.cloud.dw.healthy.engine.modules.exe.service.DwdDataExecuteRuleTriggerService;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.WorkFlowExecuteResultBO;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Log4j2
@RestController
@RequestMapping("/dw/data/demo")
public class DwdDataDemoQueryController {

    @Autowired
    private DwdDataExecuteLabelService dwdDataExecuteLabelService;

    @Autowired
    private PatientDataLabel2EventService patientDataLabel2EventService;


    @Autowired
    private DataPatientEventRuleRunService dataPatientEventRuleRunService;



    @Autowired
    private DwdDataExecuteRuleFlowService dwdDataExecuteRuleFlowService;

    @Autowired
    private RuleEngineDataService ruleEngineDataService;

    @Autowired
    private DwdDataExecuteRuleTriggerService dwdDataExecuteRuleTriggerService;




    //执行标签,某个患者的全部标签 不限制范围
    @GetMapping("/ruleLableByPatient")
    public Result<String> ruleLableByPatient(@RequestParam("patientId") String patientId ) {
        System.out.println("===============ruleLableTest=====================");
        dwdDataExecuteLabelService.executeLabelRuleByPatientId2RuleAll(patientId,DateUtil.now(),YN.NO.getCode(),null,"test");
        return new Result<String>().ok("执行标签(某个患者的全部标签;不限制范围) ok");
    }

    //执行标签,某个患者的全部标签,限制范围
    @GetMapping("/ruleLableByPatient2")
    public Result<String> ruleLableByPatient2(@RequestParam("patientId") String patientId ,@RequestParam("ds") String ds) {
        System.out.println("===============ruleLableTest=====================");
        dwdDataExecuteLabelService.executeLabelRuleByPatientId2RuleAll(patientId,DateUtil.now(),YN.YES.getCode(),ds,"test");
        return new Result<String>().ok("执行标签(某个患者的全部标签;限制范围) ok");
    }


    //执行标签,某个患者某个规则，不限制范围
    @GetMapping("/ruleLableByRule")
    public Result<String> ruleLableByRule(@RequestParam("patientId") String patientId ,@RequestParam("ruleId") String ruleId) {
        if(StrUtil.isEmpty(patientId) || StrUtil.isEmpty(ruleId)){
            return new Result<String>().ok("----- ruleLableTestByRule param is null");
        }
        dwdDataExecuteLabelService.executeLabelRuleByPatientId2RuleId(patientId,ruleId, DateUtil.now(), YN.NO.getCode(),null,"test",true);
        return new Result<String>().ok("执行标签(某个患者某个规则,不限制范围) ok");
    }


    //执行标签,某个患者某个规则，限制范围
    @GetMapping("/ruleLableByRule2")
    public Result<String> ruleLableByRule2(@RequestParam("patientId") String patientId ,@RequestParam("ruleId") String ruleId,@RequestParam("ds") String ds) {

        if(StrUtil.isEmpty(patientId) || StrUtil.isEmpty(ruleId)){
            return new Result<String>().ok("----- ruleLableTestByRule param is null");
        }
        dwdDataExecuteLabelService.executeLabelRuleByPatientId2RuleId(patientId,ruleId, DateUtil.now(), YN.YES.getCode(),ds,"test",true);
        return new Result<String>().ok("执行标签(某个患者某个规则;限制范围) : 执行成功");
    }


    //执行事件,返回结果不调用业务
    @GetMapping("/ruleEventTest")
    public Result<List<WorkFlowExecuteResultBO>> ruleEventTest(@RequestParam("patientId") String patientId,@RequestParam("eventId") String eventId) {
        System.out.println("--------ruleEventTest:执行事件,返回结果不调用业务");
        List<WorkFlowExecuteResultBO> data= dataPatientEventRuleRunService.processByPatient2NotCallBiz(patientId,eventId);
        return new Result<List<WorkFlowExecuteResultBO>>().ok(data);
    }



//    //执行流程
//    @GetMapping("/ruleFlowTest")
//    public Result<String> ruleFlowTest(@RequestParam("patientId") String patientId) {
//        List<String> ids=new ArrayList<>();
//        if(StrUtil.isNotEmpty(patientId)){
//            ids.add(patientId);
//        }
//        List<DwdPatientDataBO> patientDataList=ruleEngineDataService.getDwdPatientDataList(ids);
//        Map<String, XXRuleRoam> patientDataMap= ruleEngineDataService.getRuleRoamMapByData(patientDataList);
//        Map<String, Map<String, Date>> patientEventData= patientDataLabel2EventService.getPatientEvent(ids);
//        System.out.println("=================ruleFlowTest===================");
//        dwdDataExecuteRuleFlowService.executeAll(patientDataMap,patientEventData);
//
//        return new Result<String>().ok("ruleFlowTest");
//    }
//
//
    @GetMapping("/startFlow")
    public Result<List<WorkFlowExecuteResultBO>> startFlow(@RequestParam("patientId") String patientId ,@RequestParam("ruleId")  String ruleId) {
        if(StrUtil.isEmpty(patientId) || StrUtil.isEmpty(ruleId)){
            return new Result<List<WorkFlowExecuteResultBO>>().ok(null);
        }
        List<WorkFlowExecuteResultBO> data= dwdDataExecuteRuleFlowService.start2RuleNotExeBiz(patientId,ruleId);
        return new Result<List<WorkFlowExecuteResultBO>>().ok(data);
    }




    @GetMapping("/taskProcess")
    public Result<String> taskProcess(@RequestParam("nodeTaskId") String nodeTaskId ,@RequestParam("patientId") String patientId,
                                      @RequestParam("handleStatus")  String handleStatus,@RequestParam("userId")  String userId) {

        if(StrUtil.isEmpty(nodeTaskId) || StrUtil.isEmpty(patientId) || StrUtil.isEmpty(handleStatus) || StrUtil.isEmpty(userId)){
            return new Result<String>().ok("参数错误!");
        }
        dwdDataExecuteRuleFlowService.process(nodeTaskId,patientId,handleStatus,"test",userId);
        return new Result<String>().ok("taskProcess");
    }


    @GetMapping("/triggerProcess")
    public Result<String> triggerProcess(@RequestParam("nodeTaskId") String nodeTaskId,@RequestParam("patientId") String patientId,
                                         @RequestParam("exeDate") String exeDate) {
        if(StrUtil.isEmpty(nodeTaskId) || StrUtil.isEmpty(patientId) || StrUtil.isEmpty(exeDate)){
            return new Result<String>().ok("参数错误!");
        }
        dwdDataExecuteRuleFlowService.executeTrigger(nodeTaskId,exeDate,patientId);
        return new Result<String>().ok("triggerProcess");
    }


}
