package com.xxh.cloud.dw.healthy.engine.modules.cache.service;

import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.*;

import java.util.List;
import java.util.Map;

public interface DwdPatientDataCacheService {



    /**
     * 患者ID
     * */
    public Map<String, Object> getPatientDataById(String patientId);


    /**
     * 患者ID
     * */
    public Object getPatientDataById(String patientId,String fieldKey);


    /**
     * 基本信息更新 [患者ID]
     * */
    public void add2EditPatientBaseInfo(String patientId, DwdPatientInfo entity);





    //--------------------------------报告结果-----------------------------

    /**
     *  报告-结果 : 检验报告 [患者ID]
     * */
    public void add2EditLaboratoryReport(String patientId, List<DwdLaboratoryReportInfo> mainList, List<DwdLaboratoryReportItemInfo> detailList);


    /**
     *  报告-结果 : 检查报告 [患者ID]
     * */
    public void add2EditExamineReport(String patientId, List<DwdExamineReportInfo> entity);




//    /**
//     *  报告-结果 : 病理报告 [患者ID]
//     * */
//    public void add2EditPathologyReport(String patientId, List<DwdRecipePathologyReportInfo> entity);




    /**
     *  报告-结果 : 体检报告 [患者ID]
     * */
    //todo:待实现

    //--------------------------------就诊-----------------------------

    /**
     * 就诊记录数据 [患者ID]
     * */
    public void add2EditVisitRecord(String patientId,List<DwdVisitRecordInfo> entity);


    /**
     * 诊断数据 [患者ID]
     * */
    public void add2EditDiagnosisReport(String patientId,List<DwdDiagnosisReportInfo> entity);




    /**
     * 预约住院信息 [患者ID]
     * */
    public void add2EditInpatientReserve(String patientId,List<DwdInpatientReserveInfo> entity);


    /**
     *  住院记录 [患者ID]
     * */
    public void add2EditInpatientRecord(String patientId,List<DwdInpatientRecordInfo> entity);



    /**
     * 出院记录 [患者ID]
     * */
    public void add2EditDischargeRecord(String patientId,List<DwdDischargeRecordInfo> entity);




    /**
     * 挂号记录 [患者ID]
     * */
    public void add2EditRegisterRecord(String patientId,List<DwdRegisterRecordInfo> entity);




    /**
     *  检查预约记录 [患者ID]
     * */
    public void add2EditExamineReserve(String patientId,List<DwdExamineReserveInfo> entity);



    /**
     * 检查申请单 [患者ID]
     * */
    public void add2EditExamineApply(String patientId,List<DwdExamineApplyInfo> entity);




    /**
     * 病理申请单 [患者ID]
     * */
    public void add2EditRecipePathologyApply(String patientId,List<DwdRecipePathologyApplyInfo> mainList ,List<DwdRecipePathologyApplyProjectInfo> items);




    /**
     * 检验申请单 [患者ID]
     * */
    public void add2EditLaboratoryApply(String patientId,List<DwdLaboratoryApplyInfo> mainList,List<DwdLaboratoryApplyProjectInfo> items);




    /**
     *  医嘱用药数据 [患者ID]
     * */
    public void add2EditRecipeMedicine(String patientId,List<DwdRecipeMedicineInfo> mainList,List<DwdRecipeMedicineItemInfo> items);





    /**
     * 医嘱治疗 [患者ID]
     * */
    public void add2EditRecipeTherapy(String patientId,List<DwdRecipeTherapyInfo> entity);





    /**
     * 手术申请单 [患者ID]
     * */
    public void add2EditOperationApply(String patientId,List<DwdOperationApplyInfo> mainList,List<DwdOperationApplyItemInfo> items);




    /**
     * 手术记录数据 [患者ID]
     * */
    public void add2EditOperationRecord(String patientId,List<DwdOperationRecordInfo> mainList,List<DwdOperationRecordItemInfo> items);





    /**
     * 收费记录信息 [患者ID]
     * */
    public void add2EditCollectFeeRecord(String patientId,List<DwdCollectFeeRecordInfo> entity);




    /**
     *
     * */

    /**
     *
     * */







}
