package com.xxh.cloud.dw.healthy.engine.modules.cache.service.impl;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.*;
import com.xxh.cloud.dw.healthy.engine.modules.cache.bean.bos.*;
import com.xxh.cloud.dw.healthy.engine.modules.cache.keys.PatientDataKeys;
import com.xxh.cloud.dw.healthy.engine.modules.cache.service.DwdPatientDataCacheService;
import com.xxh.cloud.framework.common.redis.RedisUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class DwdPatientDataCacheServiceImpl implements DwdPatientDataCacheService {

    @Autowired
    private RedisUtils redisUtils;


    @Override
    public Map<String, Object> getPatientDataById(String patientId) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        Map<String, Object> data = redisUtils.hGetAll(key);
        return data;
    }

    @Override
    public Object getPatientDataById(String patientId, String fieldKey) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        return redisUtils.hGet(key,fieldKey);
    }


    @Override
    public void add2EditPatientBaseInfo(String patientId, DwdPatientInfo entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getPatientBase();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditLaboratoryReport(String patientId, List<DwdLaboratoryReportInfo> mainList, List<DwdLaboratoryReportItemInfo> detailList) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getLaboratoryReport();
        DwdLaboratoryReportCacheBO entity=new DwdLaboratoryReportCacheBO();
        entity.setMainList(mainList);
        entity.setDetailList(detailList);
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditExamineReport(String patientId, List<DwdExamineReportInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getExamineReport();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }


//    @Override
//    public void add2EditPathologyReport(String patientId, List<DwdRecipePathologyReportInfo> entity) {
//        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
//        String fieldKey= PatientDataKeys.getPathologyReport();
//        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
//    }



    @Override
    public void add2EditVisitRecord(String patientId, List<DwdVisitRecordInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getVisitRecord();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditDiagnosisReport(String patientId, List<DwdDiagnosisReportInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getDiagnosis();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditInpatientReserve(String patientId, List<DwdInpatientReserveInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getReserveInpatient();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }


    @Override
    public void add2EditInpatientRecord(String patientId, List<DwdInpatientRecordInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getInpatient();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditDischargeRecord(String patientId, List<DwdDischargeRecordInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getDischarge();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditRegisterRecord(String patientId, List<DwdRegisterRecordInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getRegisterRecord();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditExamineReserve(String patientId, List<DwdExamineReserveInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getReserveExamine();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditExamineApply(String patientId, List<DwdExamineApplyInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getApplyExamine();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditRecipePathologyApply(String patientId, List<DwdRecipePathologyApplyInfo> mainList, List<DwdRecipePathologyApplyProjectInfo> items) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getApply_Pathology();
        DwdRecipePathologyApplyCacheBO entity=new DwdRecipePathologyApplyCacheBO();
        entity.setMainList(mainList);
        entity.setItemList(items);
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditLaboratoryApply(String patientId, List<DwdLaboratoryApplyInfo> mainList, List<DwdLaboratoryApplyProjectInfo> items) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getApply_Laboratory_Project();
        DwdLaboratoryApplyCacheBO entity=new DwdLaboratoryApplyCacheBO();
        entity.setMainList(mainList);
        entity.setItemList(items);
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditRecipeMedicine(String patientId, List<DwdRecipeMedicineInfo> mainList, List<DwdRecipeMedicineItemInfo> items) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getMedicine();
        DwdRecipeMedicineCacheBO entity=new DwdRecipeMedicineCacheBO();
        entity.setMainList(mainList);
        entity.setItemList(items);
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditRecipeTherapy(String patientId, List<DwdRecipeTherapyInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getTherapy();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditOperationApply(String patientId, List<DwdOperationApplyInfo> mainList, List<DwdOperationApplyItemInfo> items) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getApply_Operation();
        DwdOperationApplyCacheBO entity=new DwdOperationApplyCacheBO();
        entity.setMainList(mainList);
        entity.setItemList(items);
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditOperationRecord(String patientId, List<DwdOperationRecordInfo> mainList, List<DwdOperationRecordItemInfo> items) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getOperationRecord();
        DwdOperationRecordCacheBO entity=new DwdOperationRecordCacheBO();
        entity.setMainList(mainList);
        entity.setItemList(items);
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



    @Override
    public void add2EditCollectFeeRecord(String patientId, List<DwdCollectFeeRecordInfo> entity) {
        String key= PatientDataKeys.getPatientDataCacheKey(patientId);
        String fieldKey= PatientDataKeys.getCollectFeeRecord();
        redisUtils.hSet(key,fieldKey, JSON.toJSONString(entity));
    }



}
