package com.xxh.cloud.dw.healthy.engine.modules.data.bean.bos;

import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.*;
//import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelBO;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleResultBO;
import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelBO;
import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelHistoryBO;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

/**
 * 患者数据信息
 * */
@Getter
@Setter
public class DwdPatientDataBO {



    /**
     * --------------------------------------------
     * --------------------------------------------
     * --------------------------------------------
     * */


    /**
     * 基本信息
     * */
    private DwdPatientInfo patientInfo;

    /**
     * 挂号记录
     * */
    private List<DwdRegisterRecordInfo> dwdRegisterRecordList;

    public void addDwdRegisterRecord(DwdRegisterRecordInfo item){
        if(this.dwdRegisterRecordList==null){
            this.dwdRegisterRecordList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdRegisterRecordList.add(item);
        }
    }



    /**
     *  就诊记录数据
     * */
    private List<DwdVisitRecordInfo> dwdVisitRecordList;

    public void addDwdVisitRecord(DwdVisitRecordInfo item){
        if(this.dwdVisitRecordList==null){
            this.dwdVisitRecordList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdVisitRecordList.add(item);
        }
    }


    /**
     * 诊断数据
     * */
    private List<DwdDiagnosisReportInfo> dwdDiagnosisReportList;

    public void addDwdDiagnosisReport(DwdDiagnosisReportInfo item){
        if(this.dwdDiagnosisReportList==null){
            this.dwdDiagnosisReportList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdDiagnosisReportList.add(item);
        }
    }



    /**
     * 预约住院信息记录
     * */
    private List<DwdInpatientReserveInfo> dwdInpatientReserveList;

    public void addDwdInpatientReserve(DwdInpatientReserveInfo item){
        if(this.dwdInpatientReserveList==null){
            this.dwdInpatientReserveList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdInpatientReserveList.add(item);
        }
    }


    /**
     * 住院记录
     * */
    private List<DwdInpatientRecordInfo> dwdInpatientRecordList;

    public void addDwdInpatientRecord(DwdInpatientRecordInfo item){
        if(this.dwdInpatientRecordList==null){
            this.dwdInpatientRecordList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdInpatientRecordList.add(item);
        }
    }

    /**
     * 出院记录
     * */
    private List<DwdDischargeRecordInfo> dwdDischargeRecordList;




    public void addDwdDischargeRecord(DwdDischargeRecordInfo item){
        if(this.dwdDischargeRecordList==null){
            this.dwdDischargeRecordList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdDischargeRecordList.add(item);
        }
    }




    /**
     * 住院变更记录
     * */
    private List<DwdInpatientChangeInfo>  dwdInpatientChangeList;


    public void addDwdInpatientChange(DwdInpatientChangeInfo item){
        if(this.dwdInpatientChangeList==null){
            this.dwdInpatientChangeList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdInpatientChangeList.add(item);
        }
    }


    //检查
    /**
     * 检查申请单
     * */
    private List<DwdExamineApplyInfo> dwdExamineApplyList;
    /**
     * 检查申请单明细
     * */
    private  List<DwdExamineApplyItemInfo> dwdExamineApplyItemList;


    public void addDwdExamineApply(DwdExamineApplyInfo item){
        if(this.dwdExamineApplyList==null){
            this.dwdExamineApplyList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdExamineApplyList.add(item);
        }
    }

    public void addDwdExamineApplyItem(DwdExamineApplyItemInfo item){
        if(this.dwdExamineApplyItemList==null){
            this.dwdExamineApplyItemList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdExamineApplyItemList.add(item);
        }
    }


    /**
     * 检查预约记录
     * */
    private List<DwdExamineReserveInfo> dwdExamineReserveList;

    public void addDwdExamineReserve(DwdExamineReserveInfo item){
        if(this.dwdExamineReserveList==null){
            this.dwdExamineReserveList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdExamineReserveList.add(item);
        }
    }

    /**
     * 检查报告单
     * */
    private List<DwdExamineReportInfo> dwdExamineReportList;

    public void addDwdExamineReport(DwdExamineReportInfo item){
        if(this.dwdExamineReportList==null){
            this.dwdExamineReportList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdExamineReportList.add(item);
        }
    }


    //病理
    /**
     * 病理申请单
     * */
    private List<DwdExamineApplyInfo> dwdRecipePathologyApplyList;

    /**
     * 病理报告单
     * */
    private List<DwdExamineReportInfo> dwdRecipePathologyReportList;



//    /**
//     * 病理申请单
//     * */
//    private List<DwdRecipePathologyApplyInfo> dwdRecipePathologyApplyList;
//
//    /**
//     * 病理申请单项目
//     * */
//    private List<DwdRecipePathologyApplyProjectInfo> dwdRecipePathologyApplyProjectList;
//
//    /**
//     * 病理报告单
//     * */
//    private List<DwdRecipePathologyReportInfo> dwdRecipePathologyReportList;

    //检验申请单
    /**
     *  检验申请单数据
     * */
    private List<DwdLaboratoryApplyInfo> dwdLaboratoryApplyList;

    public void addDwdLaboratoryApply(DwdLaboratoryApplyInfo item){
        if(this.dwdLaboratoryApplyList==null){
            this.dwdLaboratoryApplyList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdLaboratoryApplyList.add(item);
        }
    }

    /**
     * 检验申请单项目数据
     * */
    private List<DwdLaboratoryApplyProjectInfo> dwdLaboratoryApplyProjectList;


    public void addDwdLaboratoryApplyProject(DwdLaboratoryApplyProjectInfo item){
        if(this.dwdLaboratoryApplyProjectList==null){
            this.dwdLaboratoryApplyProjectList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdLaboratoryApplyProjectList.add(item);
        }
    }


    //检验报告
    /**
     * 检验报告单数据
     * */
    private List<DwdLaboratoryReportInfo> dwdLaboratoryReportList;

    public void addDwdLaboratoryReport(DwdLaboratoryReportInfo item){
        if(this.dwdLaboratoryReportList==null){
            this.dwdLaboratoryReportList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdLaboratoryReportList.add(item);
        }
    }

    /**
     * 检验报告单明细数据
     * */
    private List<DwdLaboratoryReportItemInfo> dwdLaboratoryReportItemList;

    public void addDwdLaboratoryReportItem(DwdLaboratoryReportItemInfo item){
        if(this.dwdLaboratoryReportItemList==null){
            this.dwdLaboratoryReportItemList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdLaboratoryReportItemList.add(item);
        }
    }


    //医嘱用药
    /**
     *  医嘱用药数据
     * */
    private List<DwdRecipeMedicineInfo> dwdRecipeMedicineList;


    public void addDwdRecipeMedicine(DwdRecipeMedicineInfo item){
        if(this.dwdRecipeMedicineList==null){
            this.dwdRecipeMedicineList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdRecipeMedicineList.add(item);
        }
    }

    /**
     * 医嘱用药明细数据
     * */
    private List<DwdRecipeMedicineItemInfo> dwdRecipeMedicineItemList;

    public void addDwdRecipeMedicineItem(DwdRecipeMedicineItemInfo item){
        if(this.dwdRecipeMedicineItemList==null){
            this.dwdRecipeMedicineItemList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdRecipeMedicineItemList.add(item);
        }
    }



    //医嘱治疗
    /**
     * 医嘱治疗数据
     * */
    private List<DwdRecipeTherapyInfo> dwdRecipeTherapyList;

    public void addDwdRecipeTherapy(DwdRecipeTherapyInfo item){
        if(this.dwdRecipeTherapyList==null){
            this.dwdRecipeTherapyList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdRecipeTherapyList.add(item);
        }
    }


    /**医嘱治疗明细数据*/
    private List<DwdRecipeTherapyItemInfo> dwdRecipeTherapyItemList;



    public void addDwdRecipeTherapyItem(DwdRecipeTherapyItemInfo item){
        if(this.dwdRecipeTherapyItemList==null){
            this.dwdRecipeTherapyItemList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdRecipeTherapyItemList.add(item);
        }
    }

    //手术申请
    /**
     * 手术申请数据
     * */
    private List<DwdOperationApplyInfo> dwdOperationApplyList;

    public void addDwdOperationApply(DwdOperationApplyInfo item){
        if(this.dwdOperationApplyList==null){
            this.dwdOperationApplyList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdOperationApplyList.add(item);
        }
    }

    /**
     * 手术申请明细数据
     * */
    private List<DwdOperationApplyItemInfo> dwdOperationApplyItemList;


    public void addDwdOperationApplyItem(DwdOperationApplyItemInfo item){
        if(this.dwdOperationApplyItemList==null){
            this.dwdOperationApplyItemList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdOperationApplyItemList.add(item);
        }
    }


    //手术记录
    /**
     * 手术记录数据
     * */
    private List<DwdOperationRecordInfo> dwdOperationRecordList;

    public void addDwdOperationRecord(DwdOperationRecordInfo item){
        if(this.dwdOperationRecordList==null){
            this.dwdOperationRecordList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdOperationRecordList.add(item);
        }
    }


    /**
     * 手术记录明细数据
     * */
    private List<DwdOperationRecordItemInfo> dwdOperationRecordItemList;


    public void addDwdOperationRecordItem(DwdOperationRecordItemInfo item){
        if(this.dwdOperationRecordItemList==null){
            this.dwdOperationRecordItemList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdOperationRecordItemList.add(item);
        }
    }


    /**
     *
     * */
    private  List<DwdPatientMedicalRecordInfo> dwdEmrList;

    private List<DwdPatientEmrSymptomInfo>  dwdEmrSymptomList;

    private List<DwdPatientEmrBodyCheckBasicInfo> dwdEmrCheckBasicList;

    public void addDwdEmrItem(DwdPatientMedicalRecordInfo item){
        if(this.dwdEmrList==null){
            this.dwdEmrList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdEmrList.add(item);
        }
    }


    public void addDwdEmrSysptom(DwdPatientEmrSymptomInfo item){
        if(this.dwdEmrSymptomList==null){
            this.dwdEmrSymptomList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdEmrSymptomList.add(item);
        }
    }

    public void addDwdEmrCheckBasic(DwdPatientEmrBodyCheckBasicInfo item){
        if(this.dwdEmrCheckBasicList==null){
            this.dwdEmrCheckBasicList=new ArrayList<>();
        }
        if(item!=null){
            this.dwdEmrCheckBasicList.add(item);
        }
    }





//    /**
//     * 体检总报告数据
//     * */
//    private List<DwdMedicalGeneralReportInfo> dwdMedicalGeneralReportList;
//
//    /**
//     * 体检登记数据
//     * */
//    private List<DwdMedicalRegisterInfo> dwdMedicalRegisterList;
//
//    /**
//     * 体检阳性问题数据
//     * */
//    //todo:
//
//    /**
//     * 收费记录数据
//     * */
//    private List<DwdCollectFeeRecordInfo> dwdCollectFeeRecordList;



    /**
     * 标签数据
     * */
    private List<PatientLabelBO> labelList;


    /**
     * 历史标签数据
     * */
    private List<PatientLabelHistoryBO> historyLabelList;


    public void addHistoryLabel(PatientLabelHistoryBO item){
        //todo:
    }


    /**
     * 量表结果
     * */
    private List<ScaleResultBO> scaleList;



}
