package com.xxh.cloud.dw.healthy.engine.modules.data.convert;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.IdcardUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdPatientInfo;
import com.xxh.cloud.dw.healthy.engine.modules.data.bean.bos.DwdPatientDataBO;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;

import java.util.*;

public class DwdPatientDataConvert {


    @Deprecated
    public static XXRuleRoam getXXRuleRoam(DwdPatientDataBO entity){
        XXRuleRoam data=new XXRuleRoam();
        return data;
    }

    /**
     * DWD患者基本信息表
     * */
    public static Map<String, XXRuleRoamHealthItem> getDwdPatientBasicData(DwdPatientInfo patientInfo){
        Map<String, XXRuleRoamHealthItem> data=new HashMap<>();

        XXRuleRoamHealthItem patient_id = new XXRuleRoamHealthItem(RuleCondtionDataTypeEnum.MDT_Patient.getCode(),"patient_id",patientInfo.getPatientId());
        data.put(patient_id.getMdc(),patient_id);

        if(StrUtil.isNotEmpty(patientInfo.getPatientName())){
            XXRuleRoamHealthItem patient_name =  new XXRuleRoamHealthItem(RuleCondtionDataTypeEnum.MDT_Patient.getCode(),"patient_name",patientInfo.getPatientName());
            data.put(patient_name.getMdc(),patient_name);
        }

        if(StrUtil.isNotEmpty(patientInfo.getPhone())){
            XXRuleRoamHealthItem phone =  new XXRuleRoamHealthItem(RuleCondtionDataTypeEnum.MDT_Patient.getCode(),"phone",patientInfo.getPhone());
            data.put(phone.getMdc(),phone);
        }

        if(StrUtil.isNotEmpty(patientInfo.getPatientGenderStandard())){
            XXRuleRoamHealthItem patient_gender =  new XXRuleRoamHealthItem(RuleCondtionDataTypeEnum.MDT_Patient.getCode(),"patient_gender",patientInfo.getPatientGenderStandard());
            data.put(patient_gender.getMdc(),patient_gender);
        }


        if(StrUtil.isNotEmpty(patientInfo.getCardNoTypeStandard())){
            XXRuleRoamHealthItem card_no_type =  new XXRuleRoamHealthItem(RuleCondtionDataTypeEnum.MDT_Patient.getCode(),"card_no_type",patientInfo.getCardNoTypeStandard());
            data.put(card_no_type.getMdc(),card_no_type);
        }


        if(StrUtil.isNotEmpty(patientInfo.getCardNo())){
            XXRuleRoamHealthItem card_no =  new XXRuleRoamHealthItem(RuleCondtionDataTypeEnum.MDT_Patient.getCode(),"card_no",patientInfo.getCardNo());
            data.put(card_no.getMdc(),card_no);
        }


        if(StrUtil.isNotEmpty(patientInfo.getBirthday())){
            XXRuleRoamHealthItem birthday = new XXRuleRoamHealthItem(RuleCondtionDataTypeEnum.MDT_Patient.getCode(),"birthday",patientInfo.getBirthday());
            data.put(birthday.getMdc(),birthday);
        }

        Integer age=getAge(patientInfo.getCardNo(),patientInfo.getBirthday());
        if(age!=null){
            XXRuleRoamHealthItem ageItem = new XXRuleRoamHealthItem(RuleCondtionDataTypeEnum.MDT_Patient.getCode(),"age",age);
            data.put("age",ageItem);
        }

        return data;
    }


    private  static Integer getAge(String idCardNo,String birthday){
        if(StrUtil.isNotEmpty(idCardNo)){
            try {
                Integer age = IdcardUtil.getAgeByIdCard(idCardNo);
                return age;
            }catch (Exception e){
               e.printStackTrace();
            }
        }

        if(StrUtil.isNotEmpty(birthday)){
            try {
                Integer age =DateUtil.ageOfNow(birthday);
                return age;
            }catch (Exception e){
                e.printStackTrace();
            }
        }

        return null;
    }


    public static void main(String[] args) {
//        String b="1982-01-07";
//        System.out.println(DateUtil.ageOfNow(b));

        String d="1982年8月25号";
        Date d2 = Convert.toDate(d);
        System.out.println(DateUtil.formatDateTime(d2));

      // Integer age = getAge("320683199001011524","1982年8月25号");

//        Integer age = getAge("","1982-1-2");
//        System.out.println(age);
    }









}
