package com.xxh.cloud.dw.healthy.engine.modules.data.convert;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.lang.Dict;
import cn.hutool.core.util.StrUtil;

public class EmrValueUtils {


    public static Float getBodyCheckHeight(String val){
        if(StrUtil.isEmpty(val)){
            return null;
        }
        if("未见".equals(val)){
            return null;
        }
        if("-cm".equals(val)){
            return null;
        }
        String val2 = val.replaceAll("cm","");
        String val3= val2.trim();
        return Convert.toFloat(val3);
    }

    public static  Float getBodyCheckWeight(String val){
        if(StrUtil.isEmpty(val)){
            return null;
        }
        if("未见".equals(val)){
            return null;
        }
        if("-kg".equals(val)){
            return null;
        }
        String val2 = val.replaceAll("kg","");
        String val3= val2.trim();
        return Convert.toFloat(val3);
    }

    public static String getBodyCheckBloodPressure(String val){
        if(StrUtil.isEmpty(val)){
            return null;
        }
        if("未见".equals(val)){
            return null;
        }
        if("-/-mmHg".equals(val)){
            return null;
        }
        String val2 = val.replaceAll("mmHg","");
        String val3= val2.trim();
        return val3;
    }

    public static Integer getBodyCheckHeartRat(String val){
        if(StrUtil.isEmpty(val)){
            return null;
        }
        if("未见".equals(val)){
            return null;
        }
        String val2 = val.replaceAll("次/分","");
        String val3= val2.trim();
        return Convert.toInt(val3);
    }

    public static Float getBodyCheckTemperature(String val){
        if(StrUtil.isEmpty(val)){
            return null;
        }
        if("未见".equals(val)){
            return null;
        }
        String val2 = val.replaceAll("T","");
        String val3 = val2.replaceAll("℃","");
        String val4 = val3.trim();
        return Convert.toFloat(val4);
    }

    public static Float getBodyCheckBmi(String val){
        if(StrUtil.isEmpty(val)){
            return null;
        }
        if("未见".equals(val)){
            return null;
        }
        if("暂无".equals(val)){
            return null;
        }
        if("-".equals(val)){
            return null;
        }
        String val1 = val.trim();
        return Convert.toFloat(val1);
    }

    public static String getSymptom_BodyPart(String val){
        if(StrUtil.isEmpty(val)){
            return null;
        }
        String val1 = val.trim();
        if("未见".equals(val1)){
            return null;
        }
        return val1;
    }
    public static Dict getSymptom_Duration(String val){
        if(StrUtil.isEmpty(val)){
            return null;
        }
        if("未见".equals(val)){
            return null;
        }
        Dict dict=Dict.create();

        if("3min".equals(val)){
            dict.set("val",3);
            dict.set("unit","分钟");
        }else if("10余分钟".equals(val)){
            dict.set("val",10);
            dict.set("unit","分钟");
        }else if("10分钟".equals(val)){
            dict.set("val",10);
            dict.set("unit","分钟");
        }else if("十分钟".equals(val)){
            dict.set("val",10);
            dict.set("unit","分钟");
        }
        else if("2分钟".equals(val)){
            dict.set("val",2);
            dict.set("unit","分钟");
        }
        else if("数分钟到数小时不等".equals(val)){
            dict.set("val",60);
            dict.set("unit","分钟");
        }else if("37分钟".equals(val)){
            dict.set("val",37);
            dict.set("unit","分钟");
        }else if("3-5分钟".equals(val)){
            dict.set("val",3);
            dict.set("unit","分钟");
        }
        else if("3小时".equals(val)){
            dict.set("val",3);
            dict.set("unit","小时");
        }
        else if("数小时".equals(val)){
            dict.set("val",3);
            dict.set("unit","小时");
        }
        return dict;
    }
    public static Dict getSymptom_OneTime(String val){
        if(StrUtil.isEmpty(val)){
            return null;
        }
        if("未见".equals(val)){
            return null;
        }
        Dict dict=Dict.create();

        if("半月前至今".equals(val)){
            dict.set("val",15);
            dict.set("unit","天");
        }
        else if("5年".equals(val)){
            dict.set("val",5);
            dict.set("unit","年");
        }
        else if("近半天".equals(val)){
            dict.set("val",6);
            dict.set("unit","小时");
        }
        else if("约 2 月前".equals(val)){
            dict.set("val",2);
            dict.set("unit","月");
        }
        else if("约4小时".equals(val)){
            dict.set("val",4);
            dict.set("unit","小时");
        }
        else if("12个月".equals(val)){
            dict.set("val",12);
            dict.set("unit","月");
        }
        else if("近半年".equals(val)){
            dict.set("val",6);
            dict.set("unit","月");
        }
        else if("六月".equals(val)){
            dict.set("val",6);
            dict.set("unit","月");
        }
        else if("6年余".equals(val)){
            dict.set("val",6);
            dict.set("unit","年");
        }
        else if("2、3分钟".equals(val)){
            dict.set("val",2);
            dict.set("unit","分钟");
        }
        else if("84月".equals(val)){
            dict.set("val",84);
            dict.set("unit","月");
        }
        return dict;
    }


    public static void main(String[] args) {
//        Float f1 = EmrValueUtils.getBodyCheckTemperature("T36.6℃");
//        System.out.println(f1);
    }


}
