package com.xxh.cloud.dw.healthy.engine.modules.data.service;

import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.*;

import java.util.List;

public interface DwdPatientDataBusiService {





    /**
     * 1 - 患者基本信息
     * */
    public DwdPatientInfo getPatientBaseInfo(String id);

    /**
     * 1 - 患者基本信息
     * */
    public List<DwdPatientInfo> getPatientBaseInfo(List<String> ids);


    /**
     * 2 - 挂号记录信息
     * */
    public List<DwdRegisterRecordInfo> getRegisterRecordList(String patientId);

    /**
     * 2 - 挂号记录信息
     * */
    public List<DwdRegisterRecordInfo> getRegisterRecordList(List<String> patientIds);



    /**
     * 3 - 就诊记录数据
     * */
    public List<DwdVisitRecordInfo> getVisitRecordList(String patientId);

    /**
     * 3 - 就诊记录数据
     * */
    public List<DwdVisitRecordInfo> getVisitRecordList(List<String> patientIds);




    /**
     * 4 - 预约住院信息记录信息
     * */
    public List<DwdInpatientReserveInfo> getInpatientReserveList(String patientId);
    /**
     * 4 - 预约住院信息记录信息
     * */
    public List<DwdInpatientReserveInfo> getInpatientReserveList(List<String> patientIds);



    /**
     * 5 - 住院记录信息
     * */
    public List<DwdInpatientRecordInfo> getInpatientRecordList(String patientId);
    /**
     * 5 - 住院记录信息
     * */
    public List<DwdInpatientRecordInfo> getInpatientRecordList(List<String> patientIds);


    /**
     * 5.1 - 住院变更记录信息
     * */
    public List<DwdInpatientChangeInfo> getInpatientChangeList(String patientId);
    /**
     * 5.1 - 住院变更记录信息
     * */
    public List<DwdInpatientChangeInfo> getInpatientChangeList(List<String> patientIds);



    /**
     * 5.1 - 住院变更记录信息
     * */
    public List<DwdInpatientChangeInfo> getInpatientChangeList(String patientId,List<String> typeList);
    /**
     * 5.1 - 住院变更记录信息
     * */
    public List<DwdInpatientChangeInfo> getInpatientChangeList(List<String> patientIds,List<String> typeList);




    /**
     * 6 - 出院记录信息
     * */
    public List<DwdDischargeRecordInfo> getDischargeRecordList(String patientId);

    /**
     * 6 - 出院记录信息
     * */
    public List<DwdDischargeRecordInfo> getDischargeRecordList(List<String> patientIds);



    /**
     *  7 - 医嘱用药
     * */
    public List<DwdRecipeMedicineInfo> getRecipeMedicineList(String patientId);

    /**
     *  7 - 医嘱用药
     * */
    public List<DwdRecipeMedicineInfo> getRecipeMedicineList(List<String> patientIds);

    /**
     *  8 - 医嘱用药明细
     * */
    public List<DwdRecipeMedicineItemInfo> getRecipeMedicineItemList(String patientId);

    /**
     *  8 - 医嘱用药明细
     * */
    public List<DwdRecipeMedicineItemInfo> getRecipeMedicineItemList(List<String> patientIds);



    /**
     *  22 - 治疗数据
     * */
    public List<DwdRecipeTherapyInfo> getRecipeTherapyList(String patientId);

    /**
     *  22 - 治疗数据
     * */
    public List<DwdRecipeTherapyInfo> getRecipeTherapyList(List<String> patientIds);

    /**
     *  22 - 治疗明细数据
     * */
    public List<DwdRecipeTherapyItemInfo> getRecipeTherapyItemList(String patientId);

    /**
     *  22 - 治疗明细数据
     * */
    public List<DwdRecipeTherapyItemInfo> getRecipeTherapyItemList(List<String> patientIds);







    /**
     * 14 - 手术申请数据
     * */
    public List<DwdOperationApplyInfo> getOperationApplyList(String patientId);

    /**
     * 14 - 手术申请数据
     * */
    public List<DwdOperationApplyInfo> getOperationApplyList(List<String> patientIds);

    /**
     * 15 - 手术申请明细数据
     * */
    public List<DwdOperationApplyItemInfo> getOperationApplyItemList(String patientId);

    /**
     * 15 - 手术申请明细数据
     * */
    public List<DwdOperationApplyItemInfo> getOperationApplyItemList(List<String> patientIds);



    /**
     * 16 - 手术记录数据
     * */
    public List<DwdOperationRecordInfo> getOperationRecordList(String patientId);

    /**
     * 16 - 手术记录数据
     * */
    public List<DwdOperationRecordInfo> getOperationRecordList(List<String> patientIds);

    /**
     * 17 - 手术记录明细数据
     * */
    public List<DwdOperationRecordItemInfo> getOperationRecordItemList(String patientId);

    /**
     * 17 - 手术记录明细数据
     * */
    public List<DwdOperationRecordItemInfo> getOperationRecordItemList(List<String> patientIds);




    /**
     * 3 - 诊断数据
     * */
    public List<DwdDiagnosisReportInfo> getDiagnosisReportList(String patientId);

    /**
     * 3 - 诊断数据
     * */
    public List<DwdDiagnosisReportInfo> getDiagnosisReportList(List<String> patientIds);





//
//
//    /**
//     * 18 - 体检总报告数据
//     * */
//
//    /**
//     * 19 - 体检登记
//     * */
//
//    /**
//     * 20 - 体检阳性问题
//     * */
//
//    /**
//     * 21 - 收费记录信息
//     * */
//    public List<DwdCollectFeeRecordInfo> getCollectFeeRecordList(String patientId);
//
//    /**
//     * 21 - 收费记录信息
//     * */
//    public List<DwdCollectFeeRecordInfo> getCollectFeeRecordList(List<String>  patientIds);





}
