package com.xxh.cloud.dw.healthy.engine.modules.data.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.*;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdInpatientChangeQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.*;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.DwdPatientDataBusiService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
@Log4j2
@DS("wd")
@Service
public class DwdPatientDataBusiServiceImpl implements DwdPatientDataBusiService {

    @Autowired
    private DwdPatientBizService dwdPatientBizService;
    @Autowired
    private DwdRegisterRecordBizService dwdRegisterRecordBizService;

    @Autowired
    private DwdVisitRecordBizService dwdVisitRecordBizService;

    @Autowired
    private DwdDiagnosisReportBizService dwdDiagnosisReportBizService;
    @Autowired
    private DwdInpatientReserveBizService dwdInpatientReserveBizService;
    @Autowired
    private DwdInpatientRecordBizService dwdInpatientRecordBizService;
    @Autowired
    private DwdDischargeRecordBizService dwdDischargeRecordBizService;




    @Autowired
    private DwdRecipePathologyApplyBizService dwdRecipePathologyApplyBizService;

    @Autowired
    private DwdRecipePathologyApplyProjectBizService dwdRecipePathologyApplyProjectBizService;
    @Autowired
    private DwdLaboratoryApplyBizService dwdLaboratoryApplyBizService;

    @Autowired
    private DwdOperationApplyBizService dwdOperationApplyBizService;
    @Autowired
    private DwdOperationApplyItemBizService dwdOperationApplyItemBizService;
    @Autowired
    private DwdOperationRecordBizService dwdOperationRecordBizService;


    @Autowired
    private DwdLaboratoryApplyProjectBizService dwdLaboratoryApplyProjectBizService;

    @Autowired
    private DwdOperationRecordItemBizService dwdOperationRecordItemBizService;

    @Autowired
    private DwdRecipeMedicineBizService dwdRecipeMedicineBizService;
    @Autowired
    private DwdRecipeMedicineItemBizService dwdRecipeMedicineItemBizService;

    @Autowired
    private DwdRecipeTherapyBizService dwdRecipeTherapyBizService;
    @Autowired
    private DwdRecipeTherapyItemBizService dwdRecipeTherapyItemBizService;

    @Autowired
    private DwdInpatientChangeBizService dwdInpatientChangeBizService;



    /**
     * 1 - 患者基本信息
     * */
    @Override
    public DwdPatientInfo getPatientBaseInfo(String id){
        return dwdPatientBizService.getById(id);
    }
    /**
     * 1 - 患者基本信息
     * */
    @Override
    public List<DwdPatientInfo> getPatientBaseInfo(List<String> ids){
        return dwdPatientBizService.listByIds(ids);
    }

    /**
     * 2 - 挂号记录信息
     * */
    @Override
    public List<DwdRegisterRecordInfo> getRegisterRecordList(String patientId){
        return dwdRegisterRecordBizService.listBeanByPatientId(patientId);
    }
    /**
     * 2 - 挂号记录信息
     * */
    @Override
    public List<DwdRegisterRecordInfo> getRegisterRecordList(List<String> patientIds){
        return dwdRegisterRecordBizService.listBeanByPatientId(patientIds);
    }


    /**
     * 3 - 就诊记录数据
     * */
    @Override
    public List<DwdVisitRecordInfo> getVisitRecordList(String patientId){
        return dwdVisitRecordBizService.listBeanByPatient(patientId);
    }
    /**
     * 3 - 就诊记录数据
     * */
    @Override
    public List<DwdVisitRecordInfo> getVisitRecordList(List<String> patientIds){
        return dwdVisitRecordBizService.listBeanByPatient(patientIds);
    }


    /**
     * 4 - 预约住院信息记录信息
     * */
    @Override
    public List<DwdInpatientReserveInfo> getInpatientReserveList(String patientId){
        return dwdInpatientReserveBizService.listBeanByPatient(patientId);
    }
    /**
     * 4 - 预约住院信息记录信息
     * */
    @Override
    public List<DwdInpatientReserveInfo> getInpatientReserveList(List<String> patientIds){
        return dwdInpatientReserveBizService.listBeanByPatient(patientIds);
    }


    /**
     * 5 - 住院记录信息
     * */
    @Override
    public List<DwdInpatientRecordInfo> getInpatientRecordList(String patientId){
        return dwdInpatientRecordBizService.listBeanByPatient(patientId);
    }
    /**
     * 5 - 住院记录信息
     * */
    @Override
    public List<DwdInpatientRecordInfo> getInpatientRecordList(List<String> patientIds){
        return dwdInpatientRecordBizService.listBeanByPatient(patientIds);
    }


    /**
     * 5.1 - 住院变更记录信息
     * */
    public List<DwdInpatientChangeInfo> getInpatientChangeList(String patientId){
        return dwdInpatientChangeBizService.listBeanByPatient(patientId);
    }
    /**
     * 5.1 - 住院变更记录信息
     * */
    public List<DwdInpatientChangeInfo> getInpatientChangeList(List<String> patientIds){
        return dwdInpatientChangeBizService.listBeanByPatient(patientIds);
    }

    @Override
    public List<DwdInpatientChangeInfo> getInpatientChangeList(String patientId, List<String> typeList) {
        return dwdInpatientChangeBizService.listBeanByPatient(patientId,typeList);
    }

    @Override
    public List<DwdInpatientChangeInfo> getInpatientChangeList(List<String> patientIds, List<String> typeList) {
        return dwdInpatientChangeBizService.listBeanByPatient(patientIds,typeList);
    }


    /**
     * 6 - 出院记录信息
     * */
    @Override
    public List<DwdDischargeRecordInfo> getDischargeRecordList(String patientId){
        return dwdDischargeRecordBizService.listBeanByPatient(patientId);
    }
    /**
     * 6 - 出院记录信息
     * */
    @Override
    public List<DwdDischargeRecordInfo> getDischargeRecordList(List<String> patientIds){
        return dwdDischargeRecordBizService.listBeanByPatient(patientIds);
    }



    /**
     *  7 - 医嘱用药
     * */
    @Override
    public List<DwdRecipeMedicineInfo> getRecipeMedicineList(String patientId) {
        return dwdRecipeMedicineBizService.listBeanByPatient(patientId);
    }
    /**
     *  7 - 医嘱用药
     * */
    @Override
    public List<DwdRecipeMedicineInfo> getRecipeMedicineList(List<String> patientIds) {
        return dwdRecipeMedicineBizService.listBeanByPatient(patientIds);
    }

    /**
     * 8 - 医嘱用药明细
     * */
    @Override
    public List<DwdRecipeMedicineItemInfo> getRecipeMedicineItemList(String patientId) {
        return dwdRecipeMedicineItemBizService.listBeanByPatient(patientId);
    }
    /**
     * 8 - 医嘱用药明细
     * */
    @Override
    public List<DwdRecipeMedicineItemInfo> getRecipeMedicineItemList(List<String> patientIds) {
        return dwdRecipeMedicineItemBizService.listBeanByPatient(patientIds);
    }




    /**
     * 治疗数据
     * */
    @Override
    public List<DwdRecipeTherapyInfo> getRecipeTherapyList(String patientId) {
        return dwdRecipeTherapyBizService.listBeanByPatient(patientId);
    }

    /**
     * 治疗数据
     * */
    @Override
    public List<DwdRecipeTherapyInfo> getRecipeTherapyList(List<String> patientIds) {
        return dwdRecipeTherapyBizService.listBeanByPatient(patientIds);
    }

    /**
     * 治疗明细
     * */
    @Override
    public List<DwdRecipeTherapyItemInfo> getRecipeTherapyItemList(String patientId) {
        return dwdRecipeTherapyItemBizService.listBeanByPatient(patientId);
    }
    /**
     * 治疗明细
     * */
    @Override
    public List<DwdRecipeTherapyItemInfo> getRecipeTherapyItemList(List<String> patientIds) {
        return dwdRecipeTherapyItemBizService.listBeanByPatient(patientIds);
    }


    /**
     *  手术申请数据
     * */
    @Override
    public List<DwdOperationApplyInfo> getOperationApplyList(String patientId){
        return dwdOperationApplyBizService.listBeanByPatient(patientId);
    }

    /**
     *  手术申请数据
     * */
    @Override
    public List<DwdOperationApplyInfo> getOperationApplyList(List<String> patientIds){
        return dwdOperationApplyBizService.listBeanByPatient(patientIds);
    }

    /**
     *  手术申请明细数据
     * */
    @Override
    public List<DwdOperationApplyItemInfo> getOperationApplyItemList(String patientId){
        return dwdOperationApplyItemBizService.listBeanByPatient(patientId);
    }
    /**
     *  手术申请明细数据
     * */
    @Override
    public List<DwdOperationApplyItemInfo> getOperationApplyItemList(List<String> patientIds){
        return dwdOperationApplyItemBizService.listBeanByPatient(patientIds);
    }

    /**
     * 手术记录数据
     * */
    @Override
    public List<DwdOperationRecordInfo> getOperationRecordList(String patientId){
        return dwdOperationRecordBizService.listBeanByPatient(patientId);
    }
    /**
     * 手术记录数据
     * */
    @Override
    public List<DwdOperationRecordInfo> getOperationRecordList(List<String> patientIds){
        return dwdOperationRecordBizService.listBeanByPatient(patientIds);
    }


    /**
     * 17 - 手术记录明细数据
     * */
    @Override
    public List<DwdOperationRecordItemInfo> getOperationRecordItemList(String patientId){
        return dwdOperationRecordItemBizService.listBeanByPatient(patientId);
    }
    /**
     * 17 - 手术记录明细数据
     * */
    @Override
    public List<DwdOperationRecordItemInfo> getOperationRecordItemList(List<String> patientIds){
        return dwdOperationRecordItemBizService.listBeanByPatient(patientIds);
    }

    /**
     * 3 - 诊断数据
     * */
    @Override
    public List<DwdDiagnosisReportInfo> getDiagnosisReportList(String patientId){
        return dwdDiagnosisReportBizService.listBeanByPatient(patientId);
    }

    /**
     * 3 - 诊断数据
     * */
    @Override
    public List<DwdDiagnosisReportInfo> getDiagnosisReportList(List<String> patientIds){
        return dwdDiagnosisReportBizService.listBeanByPatient(patientIds);
    }


//
//
//    /**
//     * 18 - 体检总报告数据
//     * */
//
//    /**
//     * 19 - 体检登记
//     * */
//
//    /**
//     * 20 - 体检阳性问题
//     * */
//
//    @Autowired
//    private DwdCollectFeeRecordBizService dwdCollectFeeRecordBizService;
//
//    /**
//     * 21 - 收费记录信息
//     * */
//    @Override
//    public List<DwdCollectFeeRecordInfo> getCollectFeeRecordList(String patientId){
//        return dwdCollectFeeRecordBizService.listByPatientId(patientId);
//    }
//
//    /**
//     * 21 - 收费记录信息
//     * */
//    @Override
//    public List<DwdCollectFeeRecordInfo> getCollectFeeRecordList(List<String>  patientIds){
//        return dwdCollectFeeRecordBizService.listByPatientId(patientIds);
//    }




}
