package com.xxh.cloud.dw.healthy.engine.modules.data.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdPatientEmrBodyCheckBasicInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdPatientEmrSymptomInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdPatientMedicalRecordInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdPatientMedicalRecordBizService;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.DwdPatientDataEmrBusiService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Log4j2
@DS("wd")
@Service
public class DwdPatientDataEmrBusiServiceImpl implements DwdPatientDataEmrBusiService {


    @Autowired
    private DwdPatientMedicalRecordBizService dwdPatientMedicalRecordBizService;


    @Override
    public List<DwdPatientMedicalRecordInfo> getEmrListById(String patientId) {
        return dwdPatientMedicalRecordBizService.listMedical2ByPatient(patientId);
    }

    @Override
    public List<DwdPatientEmrSymptomInfo> getEmrSymptomListById(String patientId) {
        return dwdPatientMedicalRecordBizService.listSymptom2ByPatient(patientId);
    }

    @Override
    public List<DwdPatientEmrBodyCheckBasicInfo> getEmrCheckBasicListById(String patientId) {
        return dwdPatientMedicalRecordBizService.listCheckBasic2ByPatient(patientId);
    }

    @Override
    public List<DwdPatientMedicalRecordInfo> getEmrListByIds(List<String> patientIds) {
        return dwdPatientMedicalRecordBizService.listMedical2ByPatients(patientIds);
    }

    @Override
    public List<DwdPatientEmrSymptomInfo> getEmrSymptomListByIds(List<String> patientIds) {
        return dwdPatientMedicalRecordBizService.listSymptom2ByPatients(patientIds);
    }

    @Override
    public List<DwdPatientEmrBodyCheckBasicInfo> getEmrCheckBasicListByIds(List<String> patientIds) {
        return dwdPatientMedicalRecordBizService.listCheckBasic2ByPatients(patientIds);
    }



}
