package com.xxh.cloud.dw.healthy.engine.modules.data.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.*;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.*;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.DwdPatientDataReportBusiService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Log4j2
@DS("wd")
@Service
public class DwdPatientDataReportBusiServiceImpl implements DwdPatientDataReportBusiService {



    @Autowired
    private DwdExamineApplyBizService dwdExamineApplyBizService;

    @Autowired
    private DwdExamineApplyItemBizService dwdExamineApplyItemBizService;

    @Autowired
    private DwdExamineReserveBizService dwdExamineReserveBizService;

    @Autowired
    private DwdExamineReportBizService dwdExamineReportBizService;


    @Autowired
    private DwdLaboratoryApplyBizService dwdLaboratoryApplyBizService;
    @Autowired
    private DwdLaboratoryApplyProjectBizService dwdLaboratoryApplyProjectBizService;
    @Autowired
    private DwdLaboratoryReportBizService dwdLaboratoryReportBizService;
    @Autowired
    private DwdLaboratoryReportItemBizService dwdLaboratoryReportItemBizService;



    //病理
//    @Autowired
//    private DwdRecipePathologyReportBizService dwdRecipePathologyReportBizService;




    //------------------  检查 -----------------------
    /**
     * 检查申请
     * */
    @Override
    public List<DwdExamineApplyInfo> getExamineApplyList(String patientId){
        return dwdExamineApplyBizService.listBeanByPatient(patientId);
    }

    @Override
    public List<DwdExamineApplyItemInfo> getExamineApplyItemList(String patientId) {
        return dwdExamineApplyItemBizService.listBeanByPatient(patientId);
    }

    /**
     * 检查申请
     * */
    @Override
    public List<DwdExamineApplyInfo> getExamineApplyList(List<String> patientIds){
        return dwdExamineApplyBizService.listBeanByPatient(patientIds);
    }

    @Override
    public List<DwdExamineApplyItemInfo> getExamineApplyItemList(List<String> patientIds) {
        return dwdExamineApplyItemBizService.listBeanByPatient(patientIds);
    }


    /**
     * 检查预约
     * */
    @Override
    public List<DwdExamineReserveInfo> getExamineReserveList(String patientId){
        return dwdExamineReserveBizService.listBeanByPatient(patientId);
    }
    /**
     * 检查预约
     * */
    @Override
    public List<DwdExamineReserveInfo> getExamineReserveList(List<String> patientIds){
        return dwdExamineReserveBizService.listBeanByPatient(patientIds);
    }

    /**
     * 检查报告
     * */
    @Override
    public List<DwdExamineReportInfo> getDwdExamineReportList(String patientId) {
        return dwdExamineReportBizService.listBeanByPatient(patientId);
    }
    /**
     * 检查报告
     * */
    @Override
    public List<DwdExamineReportInfo> getDwdExamineReportList(List<String> patientIds) {
        return dwdExamineReportBizService.listBeanByPatient(patientIds);
    }


    //------------------  检验 -----------------------
    @Override
    public List<DwdLaboratoryApplyInfo> getLaboratoryApplyList(String patientId) {
        return dwdLaboratoryApplyBizService.listBeanByPatient(patientId);
    }

    @Override
    public List<DwdLaboratoryApplyInfo> getLaboratoryApplyList(List<String> patientIds) {
        return dwdLaboratoryApplyBizService.listBeanByPatient(patientIds);
    }

    @Override
    public List<DwdLaboratoryApplyProjectInfo> getLaboratoryApplyProjectList(String patientId) {
        return dwdLaboratoryApplyProjectBizService.listBeanByPatient(patientId);
    }

    @Override
    public List<DwdLaboratoryApplyProjectInfo> getLaboratoryApplyProjectList(List<String> patientIds) {
        return dwdLaboratoryApplyProjectBizService.listBeanByPatient(patientIds);
    }

    @Override
    public List<DwdLaboratoryReportInfo> getDwdLaboratoryReportList(String patientId) {
        return dwdLaboratoryReportBizService.listBeanByPatient(patientId);
    }

    @Override
    public List<DwdLaboratoryReportInfo> getDwdLaboratoryReportList(List<String> patientIds) {
        return dwdLaboratoryReportBizService.listBeanByPatient(patientIds);
    }

    @Override
    public List<DwdLaboratoryReportItemInfo> getDwdLaboratoryReportItemList(String patientId) {
        return dwdLaboratoryReportItemBizService.listBeanByPatient(patientId);
    }

    @Override
    public List<DwdLaboratoryReportItemInfo> getDwdLaboratoryReportItemList(List<String> patientIds) {
        return dwdLaboratoryReportItemBizService.listBeanByPatient(patientIds);
    }






    //------------------  病理 -----------------------

//
//    @Override
//    public List<DwdRecipePathologyReportInfo> getDwdRecipePathologyReportList(String patientId) {
//        return dwdRecipePathologyReportBizService.listByPatientId(patientId);
//    }
//
//    @Override
//    public List<DwdRecipePathologyReportInfo> getDwdRecipePathologyReportList(List<String> patientIds) {
//        return dwdRecipePathologyReportBizService.listByPatientIds(patientIds);
//    }
//
//



//
//
//    /**
//     * 10 - 病理申请单数据
//     * */
//    @Override
//    public List<DwdRecipePathologyApplyInfo> getRecipePathologyApplyList(String patientId){
//        return dwdRecipePathologyApplyBizService.listByPatientId(patientId);
//    }
//
//    /**
//     * 10 - 病理申请单数据
//     * */
//    @Override
//    public List<DwdRecipePathologyApplyInfo> getRecipePathologyApplyList(List<String> patientIds){
//        return dwdRecipePathologyApplyBizService.listByPatientId(patientIds);
//    }
//
//
//
//    /**
//     * 11 - 病理申请单项目数据
//     * */
//    @Override
//    public List<DwdRecipePathologyApplyProjectInfo> getRecipePathologyApplyProjectList(String patientId){
//        return dwdRecipePathologyApplyProjectBizService.listByPatientId(patientId);
//    }
//
//    /**
//     * 11 - 病理申请单项目数据
//     * */
//    @Override
//    public List<DwdRecipePathologyApplyProjectInfo> getRecipePathologyApplyProjectList(List<String> patientIds){
//        return dwdRecipePathologyApplyProjectBizService.listByPatientId(patientIds);
//    }




}
