package com.xxh.cloud.dw.healthy.engine.modules.data.service.impl;

//import com.xxh.cloud.dw.healthy.engine.modules.data.bean.dto.PatientEventDTO;
//import com.xxh.cloud.dw.healthy.engine.modules.data.bean.dto.PatientLabelDTO;
//import com.xxh.cloud.dw.healthy.engine.modules.data.bean.dto.PatientScaleDTO;
//import com.xxh.cloud.dw.healthy.engine.modules.data.bean.dto.PatientScaleItemDTO;
import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.dw.healthy.data.dws.framework.modules.base.entity.DwsPatientEventInfo;
import com.xxh.cloud.dw.healthy.data.dws.framework.modules.biz.service.DwsPatientEventMgrBizService;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.PatientDataLabel2EventService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class PatientDataLabel2EventServiceImpl implements PatientDataLabel2EventService {


    @Autowired
    private DwsPatientEventMgrBizService dwsPatientEventMgrBizService;

    @Override
    public Map<String, Date> getPatientEvent(String patientId) {
        Map<String, Date> data=new HashMap<>();
        List<DwsPatientEventInfo> list= dwsPatientEventMgrBizService.listBeanByPatient(patientId);
        if(CollUtil.isEmpty(list)){
            return data;
        }
        list.forEach(item->{
            data.put(item.getEventType(),item.getEventDate());
        });
        return data;
    }

    @Override
    public Map<String, Map<String, Date>> getPatientEvent(List<String> patientIds) {
        Map<String, Map<String, Date>> data=new HashMap<>();
        List<DwsPatientEventInfo> list= dwsPatientEventMgrBizService.listBeanByPatient(patientIds);
        if(CollUtil.isEmpty(list)){
            return data;
        }
        for(DwsPatientEventInfo item:list){
            Map<String, Date> map= data.get(item.getPatientId());
            if(map==null){
                map=new HashMap<>();
                data.put(item.getPatientId(),map);
            }
            map.put(item.getEventType(),item.getEventDate());
        }
        return data;
    }






}
