package com.xxh.cloud.dw.healthy.engine.modules.data.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.IdUtil;
import com.alibaba.fastjson2.JSON;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.*;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdExamineApplyItemBizService;
import com.xxh.cloud.dw.healthy.engine.modules.data.bean.bos.DwdPatientDataBO;
import com.xxh.cloud.dw.healthy.engine.modules.data.convert.DwdPatientDataConvert;
import com.xxh.cloud.dw.healthy.engine.modules.data.convert.RuleRoamHealthDataConvert;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.DwdPatientDataBusiService;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.DwdPatientDataEmrBusiService;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.DwdPatientDataReportBusiService;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.RuleEngineDataService;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;
//import com.xxh.cloud.healthy.serve.label.client.api.PatientLabelClientService;
//import com.xxh.cloud.healthy.serve.label.client.api.PatientLabelQueryClientService;
//import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelBO;
//import com.xxh.cloud.healthy.serve.label.client.api.PatientLabelQueryClientService;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.ScaleResultClientService;
import com.xxh.cloud.healthy.scale.framework.modules.client.api.bean.bos.ScaleResultBO;
import com.xxh.cloud.healthy.serve.label.client.api.PatientLabelQueryClientService;
import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelBO;
import com.xxh.cloud.healthy.serve.label.client.api.bean.bos.PatientLabelHistoryBO;
import com.xxh.cloud.healthy.serve.label.client.api.bean.dto.LabelQueryDTO;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class RuleEngineDataServiceImpl implements RuleEngineDataService {


    @Autowired
    private DwdPatientDataBusiService dwdPatientDataBusiService;


    @Autowired
    private DwdPatientDataReportBusiService dwdPatientDataReportBusiService;

    @Autowired
    private PatientLabelQueryClientService patientLabelQueryClientService;

    @Autowired
    private DwdPatientDataEmrBusiService dwdPatientDataEmrBusiService;

    @Autowired
    private ScaleResultClientService scaleResultClientService;





    @Override
    public XXRuleRoam getRuleRoam(String patientId) {
        DwdPatientDataBO dwdPatientData=this.getDwdPatientData(patientId);
        XXRuleRoam data= this.getXXRuleRoam(dwdPatientData);
        return data;
    }

    @Override
    public DwdPatientDataBO getPatientData(String patientId) {
        DwdPatientDataBO data=this.getDwdPatientData(patientId);
        return data;
    }


    @Override
    public Map<String, XXRuleRoam> getRuleRoamMap(List<String> patientIds) {
        Map<String, XXRuleRoam> data=new HashMap<>();
        List<DwdPatientDataBO> list=getDwdPatientDataList(patientIds);
        if(CollUtil.isEmpty(list)){
            return data;
        }
        list.forEach(item->{
            XXRuleRoam dataitem= this.getXXRuleRoam(item);
            data.put(item.getPatientInfo().getPatientId(),dataitem);
        });
        return data;
    }

    @Override
    public Map<String, XXRuleRoam> getRuleRoamMapByData(List<DwdPatientDataBO> list) {
        Map<String, XXRuleRoam> data=new HashMap<>();
        if(CollUtil.isEmpty(list)){
            return data;
        }
        list.forEach(item->{
            XXRuleRoam dataitem= this.getXXRuleRoam(item);
            data.put(item.getPatientInfo().getPatientId(),dataitem);
        });
        return data;
    }

    @Override
    public List<DwdPatientDataBO> reloadRuleRoamMap(List<String> patientIds,List<DwdPatientDataBO> list) {
        //标签
        Map<String, List<PatientLabelBO>> labelMap= patientLabelQueryClientService.getListByPatientIds(patientIds);
        if(MapUtil.isEmpty(labelMap)){
            return list;
        }

        for(DwdPatientDataBO item:list){
            item.setLabelList(null);
            List<PatientLabelBO> patientLabelList= labelMap.get(item.getPatientInfo().getPatientId());
            item.setLabelList(patientLabelList);
        }
        return list;
    }



    @Override
    public List<DwdPatientDataBO> getDwdPatientDataList(List<String> patientIds2){
        List<DwdPatientDataBO> data=new ArrayList<>();

        //基本信息
        List<DwdPatientInfo> patientList= dwdPatientDataBusiService.getPatientBaseInfo(patientIds2);
        if(CollUtil.isEmpty(patientList)){
            return data;
        }

        List<String> patientIds=new ArrayList<>();
        patientList.forEach(item->{
            patientIds.add(item.getPatientId());
        });


        //检验
        //检验申请单
        List<DwdLaboratoryApplyInfo> laboratoryApplyList =  dwdPatientDataReportBusiService.getLaboratoryApplyList(patientIds);
        List<DwdLaboratoryApplyProjectInfo> laboratoryApplyProjectList = dwdPatientDataReportBusiService.getLaboratoryApplyProjectList(patientIds);

        //检验报告单
        List<DwdLaboratoryReportInfo> laboratoryReportList = dwdPatientDataReportBusiService.getDwdLaboratoryReportList(patientIds);
        List<DwdLaboratoryReportItemInfo> laboratoryReportItemList = dwdPatientDataReportBusiService.getDwdLaboratoryReportItemList(patientIds);

        //检查
        //检查申请单
        List<DwdExamineApplyInfo> examineApplyList= dwdPatientDataReportBusiService.getExamineApplyList(patientIds);
        List<DwdExamineApplyItemInfo> examineApplyItemList = dwdPatientDataReportBusiService.getExamineApplyItemList(patientIds);


        //检查预约记录
        List<DwdExamineReserveInfo> examineReserveList =  dwdPatientDataReportBusiService.getExamineReserveList(patientIds);

        //检查报告单
        List<DwdExamineReportInfo> examineReportList = dwdPatientDataReportBusiService.getDwdExamineReportList(patientIds);

        //挂号
        List<DwdRegisterRecordInfo> registerRecordList = dwdPatientDataBusiService.getRegisterRecordList(patientIds);

        //就诊
        List<DwdVisitRecordInfo> visitRecordList =  dwdPatientDataBusiService.getVisitRecordList(patientIds);

        //诊断
        List<DwdDiagnosisReportInfo> diagnosisReportList= dwdPatientDataBusiService.getDiagnosisReportList(patientIds);


        //-----住院
        //预约住院
        List<DwdInpatientReserveInfo> inpatientReserveList= dwdPatientDataBusiService.getInpatientReserveList(patientIds);

        //住院记录
        List<DwdInpatientRecordInfo> inpatientRecordList= dwdPatientDataBusiService.getInpatientRecordList(patientIds);

        //住院变更记录【科室、病区、床位 变更】
        List<DwdInpatientChangeInfo>  inpatientChangeList = dwdPatientDataBusiService.getInpatientChangeList(patientIds,CollUtil.newArrayList("ZKZCKS","ZKZRKS"));



        //出院记录
        List<DwdDischargeRecordInfo> dischargeRecordList= dwdPatientDataBusiService.getDischargeRecordList(patientIds);

        //医嘱用药
        List<DwdRecipeMedicineInfo> medicineList = dwdPatientDataBusiService.getRecipeMedicineList(patientIds);
        List<DwdRecipeMedicineItemInfo> medicineItemList = dwdPatientDataBusiService.getRecipeMedicineItemList(patientIds);

        //治疗
        List<DwdRecipeTherapyInfo> therapyList= dwdPatientDataBusiService.getRecipeTherapyList(patientIds);
        List<DwdRecipeTherapyItemInfo> therapyItemList= dwdPatientDataBusiService.getRecipeTherapyItemList(patientIds);

        //手术
        //手术申请
        List<DwdOperationApplyInfo> operationApplyList= dwdPatientDataBusiService.getOperationApplyList(patientIds);
        List<DwdOperationApplyItemInfo> operationApplyItemList= dwdPatientDataBusiService.getOperationApplyItemList(patientIds);

        //手术记录
        List<DwdOperationRecordInfo> operationRecordList= dwdPatientDataBusiService.getOperationRecordList(patientIds);
        List<DwdOperationRecordItemInfo> operationRecordItemList= dwdPatientDataBusiService.getOperationRecordItemList(patientIds);

        //电子病例
        List<DwdPatientMedicalRecordInfo> emrList= dwdPatientDataEmrBusiService.getEmrListByIds(patientIds);
        //电子病例症状
        List<DwdPatientEmrSymptomInfo>  emrSymptomList= dwdPatientDataEmrBusiService.getEmrSymptomListByIds(patientIds);
        //电子病例-体格检查-基本信息
        List<DwdPatientEmrBodyCheckBasicInfo> emrCheckBasicList= dwdPatientDataEmrBusiService.getEmrCheckBasicListByIds(patientIds);


        //当前有效标签
        Map<String, List<PatientLabelBO>> labelMap= patientLabelQueryClientService.getListByPatientIds(patientIds);

        //历史标签
        LabelQueryDTO hisLabelDTO=new LabelQueryDTO();
        hisLabelDTO.setOpType("1");
        hisLabelDTO.setPatientIds(patientIds);
        List<PatientLabelHistoryBO> hisLabelList= patientLabelQueryClientService.queryHistory(hisLabelDTO);


        //量表
        Map<String, List<ScaleResultBO>> scaleMap= scaleResultClientService.getScaleResultMapByPids(patientIds);


        for(DwdPatientInfo patientInfo:patientList){

            DwdPatientDataBO dataItem=new DwdPatientDataBO();
            dataItem.setPatientInfo(patientInfo);

            //检验
            //检验申请单
            if(CollUtil.isNotEmpty(laboratoryApplyList)){
                laboratoryApplyList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdLaboratoryApply(item);
                    }
                });
            }

            if(CollUtil.isNotEmpty(laboratoryApplyProjectList)){
                laboratoryApplyProjectList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdLaboratoryApplyProject(item);
                    }
                });
            }

            //检验报告单
            if(CollUtil.isNotEmpty(laboratoryReportList)){
                laboratoryReportList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdLaboratoryReport(item);
                    }
                });
            }

            if(CollUtil.isNotEmpty(laboratoryReportItemList)){
                laboratoryReportItemList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdLaboratoryReportItem(item);
                    }
                });
            }

            //检查
            //检查申请单
            if(CollUtil.isNotEmpty(examineApplyList)){
                examineApplyList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdExamineApply(item);
                    }
                });
            }
            if(CollUtil.isNotEmpty(examineApplyItemList)){
                examineApplyItemList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdExamineApplyItem(item);
                    }
                });
            }

            //检查预约记录
            if(CollUtil.isNotEmpty(examineReserveList)){
                examineReserveList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdExamineReserve(item);
                    }
                });
            }

            //检查报告单
            if(CollUtil.isNotEmpty(examineReportList)){
                examineReportList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdExamineReport(item);
                    }
                });
            }


            //挂号
            if(CollUtil.isNotEmpty(registerRecordList)){
                registerRecordList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdRegisterRecord(item);
                    }
                });
            }


            //就诊
            if(CollUtil.isNotEmpty(visitRecordList)){
                visitRecordList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdVisitRecord(item);
                    }
                });
            }


            //诊断
            if(CollUtil.isNotEmpty(diagnosisReportList)){
                diagnosisReportList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdDiagnosisReport(item);
                    }
                });
            }



            //-----住院
            //预约住院
            if(CollUtil.isNotEmpty(inpatientReserveList)){
                inpatientReserveList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdInpatientReserve(item);
                    }
                });
            }


            //住院记录
            if(CollUtil.isNotEmpty(inpatientRecordList)){
                inpatientRecordList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdInpatientRecord(item);
                    }
                });
            }

            //住院变更记录
            if(CollUtil.isNotEmpty(inpatientChangeList)){
                inpatientChangeList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdInpatientChange(item);
                    }
                });
            }

            //出院记录
            if(CollUtil.isNotEmpty(dischargeRecordList)){
                dischargeRecordList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdDischargeRecord(item);
                    }
                });
            }

            //医嘱用药
            if(CollUtil.isNotEmpty(medicineList)){
                medicineList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdRecipeMedicine(item);
                    }
                });
            }

            if(CollUtil.isNotEmpty(medicineItemList)){
                medicineItemList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdRecipeMedicineItem(item);
                    }
                });
            }


            //治疗
            if(CollUtil.isNotEmpty(therapyList)){
                therapyList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdRecipeTherapy(item);
                    }
                });
            }

            if(CollUtil.isNotEmpty(therapyItemList)){
                therapyItemList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdRecipeTherapyItem(item);
                    }
                });
            }

            //手术
            //手术申请
            if(CollUtil.isNotEmpty(operationApplyList)){
                operationApplyList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdOperationApply(item);
                    }
                });
            }

            if(CollUtil.isNotEmpty(operationApplyItemList)){
                operationApplyItemList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdOperationApplyItem(item);
                    }
                });
            }


            //手术记录
            if(CollUtil.isNotEmpty(operationRecordList)){
                operationRecordList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdOperationRecord(item);
                    }
                });
            }

            if(CollUtil.isNotEmpty(operationRecordItemList)){
                operationRecordItemList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdOperationRecordItem(item);
                    }
                });
            }

            //电子病例
            if(CollUtil.isNotEmpty(emrList)){
                emrList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdEmrItem(item);
                    }
                });
            }

            if(CollUtil.isNotEmpty(emrSymptomList)){
                emrSymptomList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdEmrSysptom(item);
                    }
                });
            }

            if(CollUtil.isNotEmpty(emrCheckBasicList)){
                emrCheckBasicList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addDwdEmrCheckBasic(item);
                    }
                });
            }




            //标签
            if(MapUtil.isNotEmpty(labelMap)){
                labelMap.forEach((patientId,item)->{
                    if(patientInfo.getPatientId().equals(patientId)){
                        dataItem.setLabelList(item);
                    }
                });
            }

            //历史标签
            if(CollUtil.isNotEmpty(hisLabelList)){
                hisLabelList.forEach(item->{
                    if(patientInfo.getPatientId().equals(item.getPatientId())){
                        dataItem.addHistoryLabel(item);
                    }
                });
            }

            //量表
            if(MapUtil.isNotEmpty(scaleMap)){
                scaleMap.forEach((patientId,item)->{
                    if(patientInfo.getPatientId().equals(patientId)){
                        dataItem.setScaleList(item);
                    }
                });
            }



            data.add(dataItem);
        }

        return data;

    }

    private DwdPatientDataBO getDwdPatientData(String patientId){
        DwdPatientInfo patientInfo = dwdPatientDataBusiService.getPatientBaseInfo(patientId);
        if(patientInfo==null){
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }

        //基本信息
        DwdPatientDataBO data= new DwdPatientDataBO();
        data.setPatientInfo(patientInfo);

        //病理申请单
//        List<DwdRecipePathologyApplyInfo> recipePathologyApplyList= dwdPatientDataReportBusiService.getRecipePathologyApplyList(patientId);
//        List<DwdRecipePathologyApplyProjectInfo> recipePathologyApplyProjectList = dwdPatientDataReportBusiService.getRecipePathologyApplyProjectList(patientId);
//        data.setDwdRecipePathologyApplyList(recipePathologyApplyList);
//        data.setDwdRecipePathologyApplyProjectList(recipePathologyApplyProjectList);
//        List<DwdRecipePathologyReportInfo> recipePathologyReportList = dwdPatientDataReportBusiService.getDwdRecipePathologyReportList(patientId);
//        data.setDwdRecipePathologyReportList(recipePathologyReportList);

        //检验
        //检验申请单
        List<DwdLaboratoryApplyInfo> laboratoryApplyList =  dwdPatientDataReportBusiService.getLaboratoryApplyList(patientId);
        List<DwdLaboratoryApplyProjectInfo> laboratoryApplyProjectList = dwdPatientDataReportBusiService.getLaboratoryApplyProjectList(patientId);
        data.setDwdLaboratoryApplyList(laboratoryApplyList);
        data.setDwdLaboratoryApplyProjectList(laboratoryApplyProjectList);

        //检验报告单
        List<DwdLaboratoryReportInfo> laboratoryReportList = dwdPatientDataReportBusiService.getDwdLaboratoryReportList(patientId);
        List<DwdLaboratoryReportItemInfo> laboratoryReportItemList = dwdPatientDataReportBusiService.getDwdLaboratoryReportItemList(patientId);
        data.setDwdLaboratoryReportList(laboratoryReportList);
        data.setDwdLaboratoryReportItemList(laboratoryReportItemList);

        //检查
        //检查申请单
        List<DwdExamineApplyInfo> examineApplyList= dwdPatientDataReportBusiService.getExamineApplyList(patientId);
        data.setDwdExamineApplyList(examineApplyList);
        List<DwdExamineApplyItemInfo> examineApplyItemList = dwdPatientDataReportBusiService.getExamineApplyItemList(patientId);
        data.setDwdExamineApplyItemList(examineApplyItemList);

        //检查预约记录
        List<DwdExamineReserveInfo> examineReserveList =  dwdPatientDataReportBusiService.getExamineReserveList(patientId);
        data.setDwdExamineReserveList(examineReserveList);

        //检查报告单
        List<DwdExamineReportInfo> examineReportList = dwdPatientDataReportBusiService.getDwdExamineReportList(patientId);
        data.setDwdExamineReportList(examineReportList);

        //挂号
        List<DwdRegisterRecordInfo> registerRecordList = dwdPatientDataBusiService.getRegisterRecordList(patientId);
        data.setDwdRegisterRecordList(registerRecordList);

        //就诊
        List<DwdVisitRecordInfo> visitRecordList =  dwdPatientDataBusiService.getVisitRecordList(patientId);
        data.setDwdVisitRecordList(visitRecordList);

        //诊断
        List<DwdDiagnosisReportInfo> diagnosisReportList= dwdPatientDataBusiService.getDiagnosisReportList(patientId);
        data.setDwdDiagnosisReportList(diagnosisReportList);


        //-----住院
        //预约住院
        List<DwdInpatientReserveInfo> inpatientReserveList= dwdPatientDataBusiService.getInpatientReserveList(patientId);
        data.setDwdInpatientReserveList(inpatientReserveList);

        //住院记录
        List<DwdInpatientRecordInfo> inpatientRecordList= dwdPatientDataBusiService.getInpatientRecordList(patientId);
        data.setDwdInpatientRecordList(inpatientRecordList);

        //出院记录
        List<DwdDischargeRecordInfo> dischargeRecordList= dwdPatientDataBusiService.getDischargeRecordList(patientId);
        data.setDwdDischargeRecordList(dischargeRecordList);

        //住院变更记录【科室、病区、床位 变更】
        List<DwdInpatientChangeInfo>  inpatientChangeList = dwdPatientDataBusiService.getInpatientChangeList(patientId, CollUtil.newArrayList("ZKZCKS","ZKZRKS"));
        data.setDwdInpatientChangeList(inpatientChangeList);


        //医嘱用药
        List<DwdRecipeMedicineInfo> medicineList = dwdPatientDataBusiService.getRecipeMedicineList(patientId);
        List<DwdRecipeMedicineItemInfo> medicineItemList = dwdPatientDataBusiService.getRecipeMedicineItemList(patientId);
        data.setDwdRecipeMedicineList(medicineList);
        data.setDwdRecipeMedicineItemList(medicineItemList);


        //治疗
        List<DwdRecipeTherapyInfo> therapyList= dwdPatientDataBusiService.getRecipeTherapyList(patientId);
        List<DwdRecipeTherapyItemInfo> therapyItemList= dwdPatientDataBusiService.getRecipeTherapyItemList(patientId);
        data.setDwdRecipeTherapyList(therapyList);
        data.setDwdRecipeTherapyItemList(therapyItemList);

        //手术
        //手术申请
        List<DwdOperationApplyInfo> operationApplyList= dwdPatientDataBusiService.getOperationApplyList(patientId);
        List<DwdOperationApplyItemInfo> operationApplyItemList= dwdPatientDataBusiService.getOperationApplyItemList(patientId);
        data.setDwdOperationApplyList(operationApplyList);
        data.setDwdOperationApplyItemList(operationApplyItemList);

        //手术记录
        List<DwdOperationRecordInfo> operationRecordList= dwdPatientDataBusiService.getOperationRecordList(patientId);
        List<DwdOperationRecordItemInfo> operationRecordItemList= dwdPatientDataBusiService.getOperationRecordItemList(patientId);
        data.setDwdOperationRecordList(operationRecordList);
        data.setDwdOperationRecordItemList(operationRecordItemList);


        //电子病例
        List<DwdPatientMedicalRecordInfo> emrList= dwdPatientDataEmrBusiService.getEmrListById(patientId);
        //电子病例症状
        List<DwdPatientEmrSymptomInfo>  emrSymptomList= dwdPatientDataEmrBusiService.getEmrSymptomListById(patientId);
        //电子病例-体格检查-基本信息
        List<DwdPatientEmrBodyCheckBasicInfo> emrCheckBasicList= dwdPatientDataEmrBusiService.getEmrCheckBasicListById(patientId);

        data.setDwdEmrList(emrList);
        data.setDwdEmrSymptomList(emrSymptomList);
        data.setDwdEmrCheckBasicList(emrCheckBasicList);



        //当前标签
        List<PatientLabelBO> labelList= patientLabelQueryClientService.getListByPatientId(patientId);
        data.setLabelList(labelList);

        //历史标签
        LabelQueryDTO hisLabelDTO=new LabelQueryDTO();
        hisLabelDTO.setOpType("1");
        hisLabelDTO.setPatientId(patientId);
        List<PatientLabelHistoryBO> hisLabelList= patientLabelQueryClientService.queryHistory(hisLabelDTO);
        data.setHistoryLabelList(hisLabelList);



        //量表
        List<ScaleResultBO> scaleList= scaleResultClientService.getScaleResultListByPid(patientId);
        data.setScaleList(scaleList);

        return data;
    }


    private XXRuleRoam getXXRuleRoam(DwdPatientDataBO patientData){
        XXRuleRoam ruleData=new XXRuleRoam();
        //基础信息
        if(patientData.getPatientInfo()!=null){
            Map<String, XXRuleRoamHealthItem> basicData= DwdPatientDataConvert.getDwdPatientBasicData(patientData.getPatientInfo());
            ruleData.addBasicHealthData(basicData);
        }

        //就诊记录
        if(CollUtil.isNotEmpty(patientData.getDwdVisitRecordList())){
            Map<String, List<XXRuleRoamHealthItem>> visitRecordMap= RuleRoamHealthDataConvert.getVisitRecord(patientData.getDwdVisitRecordList());
            ruleData.addHealthData(visitRecordMap);
        }

        //挂号记录
        if(CollUtil.isNotEmpty(patientData.getDwdRegisterRecordList())){
            Map<String, List<XXRuleRoamHealthItem>> registerRecordMap = RuleRoamHealthDataConvert.getRegisterRecord(patientData.getDwdRegisterRecordList());
            ruleData.addHealthData(registerRecordMap);
        }

        //诊断数据
        if(CollUtil.isNotEmpty(patientData.getDwdDiagnosisReportList())){
            Map<String, List<XXRuleRoamHealthItem>> diagnosisReportMap= RuleRoamHealthDataConvert.getDiagnosisReport(patientData.getDwdDiagnosisReportList());
            ruleData.addHealthData(diagnosisReportMap);
        }

        //预约住院信息
        if(CollUtil.isNotEmpty(patientData.getDwdInpatientReserveList())){
            Map<String, List<XXRuleRoamHealthItem>> inpatientReserveMap= RuleRoamHealthDataConvert.getInpatientReserve(patientData.getDwdInpatientReserveList());
            ruleData.addHealthData(inpatientReserveMap);
        }

        //住院记录
        if(CollUtil.isNotEmpty(patientData.getDwdInpatientRecordList())){
            Map<String, List<XXRuleRoamHealthItem>> inpatientRecordMap= RuleRoamHealthDataConvert.getInpatientRecord(patientData.getDwdInpatientRecordList());
            ruleData.addHealthData(inpatientRecordMap);
        }

        //住院变更记录
        if(CollUtil.isNotEmpty(patientData.getDwdInpatientChangeList())){
            Map<String, List<XXRuleRoamHealthItem>> inpatientRecordMap= RuleRoamHealthDataConvert.getInpatientChange(patientData.getDwdInpatientChangeList());
            ruleData.addHealthData(inpatientRecordMap);
        }

        //出院记录
        if(CollUtil.isNotEmpty(patientData.getDwdDischargeRecordList())){
            Map<String, List<XXRuleRoamHealthItem>> dischargeRecordMap = RuleRoamHealthDataConvert.getDischargeRecord(patientData.getDwdDischargeRecordList());
            ruleData.addHealthData(dischargeRecordMap);
        }


        //检查预约
        if(CollUtil.isNotEmpty(patientData.getDwdExamineReserveList())){
            Map<String, List<XXRuleRoamHealthItem>> examineReserveMap = RuleRoamHealthDataConvert.getExamineReserve(patientData.getDwdExamineReserveList());
            ruleData.addHealthData(examineReserveMap);
        }


        //检查申请
        if(CollUtil.isNotEmpty(patientData.getDwdExamineApplyList()) && CollUtil.isNotEmpty(patientData.getDwdExamineApplyItemList())){
            Map<String, List<XXRuleRoamHealthItem>> examineApplyMap = RuleRoamHealthDataConvert.getExamineApply(patientData.getDwdExamineApplyList(), patientData.getDwdExamineApplyItemList());
            ruleData.addHealthData(examineApplyMap);
        }


        //检查报告单
        if(CollUtil.isNotEmpty(patientData.getDwdExamineReportList())){
            Map<String, List<XXRuleRoamHealthItem>> examineReportMap = RuleRoamHealthDataConvert.getExamineReport(patientData.getDwdExamineReportList());
            ruleData.addHealthData(examineReportMap);

        }
//        //病理申请单
//        if(CollUtil.isNotEmpty(patientData.getDwdRecipePathologyApplyList())){
//            System.out.println("++++++++++++++ 病理申请单");
//            System.out.println(JSON.toJSONString(patientData.getDwdRecipePathologyApplyList()));
//
//            Map<String, List<XXRuleRoamHealthItem>> recipePathologyApplyMap = RuleRoamHealthDataConvert.getExamineApply_Pathology(
//                    patientData.getDwdRecipePathologyApplyList());
//            ruleData.addHealthData(recipePathologyApplyMap);
//        }

//        //病理报告单
//        if(CollUtil.isNotEmpty(patientData.getDwdRecipePathologyReportList())){
//            Map<String, List<XXRuleRoamHealthItem>> examineReportMap = RuleRoamHealthDataConvert.getExamineReport_Pathology(
//                    patientData.getDwdRecipePathologyReportList());
//            ruleData.addHealthData(examineReportMap);
//        }


//        //病理申请单
//        Map<String, List<XXRuleRoamHealthItem>> recipePathologyApplyMap = RuleRoamHealthDataConvert.getRecipePathologyApply(
//                patientData.getDwdRecipePathologyApplyList(),patientData.getDwdRecipePathologyApplyProjectList());
//        ruleData.addHealthData(recipePathologyApplyMap);
//
//        //病理报告单
//        Map<String, List<XXRuleRoamHealthItem>> recipePathologyReportMap = RuleRoamHealthDataConvert.getRecipePathologyReport(patientData.getDwdRecipePathologyReportList());
//        ruleData.addHealthData(recipePathologyReportMap);


        //检验申请单
        if(CollUtil.isNotEmpty(patientData.getDwdLaboratoryApplyList()) && CollUtil.isNotEmpty(patientData.getDwdLaboratoryApplyProjectList())){
            Map<String, List<XXRuleRoamHealthItem>> laboratoryApplyMap = RuleRoamHealthDataConvert.getLaboratoryApply(
                    patientData.getDwdLaboratoryApplyList(),patientData.getDwdLaboratoryApplyProjectList());
            ruleData.addHealthData(laboratoryApplyMap);
        }


        //检验报告单
        if(CollUtil.isNotEmpty(patientData.getDwdLaboratoryReportList()) && CollUtil.isNotEmpty(patientData.getDwdLaboratoryReportItemList())){
            Map<String, List<XXRuleRoamHealthItem>> laboratoryReportMap = RuleRoamHealthDataConvert.getLaboratoryReport(
                    patientData.getDwdLaboratoryReportList(),patientData.getDwdLaboratoryReportItemList());
            ruleData.addHealthData(laboratoryReportMap);
        }


        //医嘱用药
        if(CollUtil.isNotEmpty(patientData.getDwdRecipeMedicineList()) && CollUtil.isNotEmpty(patientData.getDwdRecipeMedicineItemList())){
            Map<String, List<XXRuleRoamHealthItem>> recipeMedicineMap = RuleRoamHealthDataConvert.getRecipeMedicine(
                    patientData.getDwdRecipeMedicineList(),patientData.getDwdRecipeMedicineItemList());
            ruleData.addHealthData(recipeMedicineMap);
        }


        //治疗
        if(CollUtil.isNotEmpty(patientData.getDwdRecipeTherapyList()) && CollUtil.isNotEmpty(patientData.getDwdRecipeTherapyItemList())){
            Map<String, List<XXRuleRoamHealthItem>> recipeTherapyMap = RuleRoamHealthDataConvert.getRecipeTherapy(patientData.getDwdRecipeTherapyList(),
                    patientData.getDwdRecipeTherapyItemList());
            ruleData.addHealthData(recipeTherapyMap);
        }


        //手术申请
        if(CollUtil.isNotEmpty(patientData.getDwdOperationApplyList()) && CollUtil.isNotEmpty(patientData.getDwdOperationApplyItemList())){
            Map<String, List<XXRuleRoamHealthItem>> operationApplyMap = RuleRoamHealthDataConvert.getOperationApply(patientData.getDwdOperationApplyList(),
                    patientData.getDwdOperationApplyItemList());
            ruleData.addHealthData(operationApplyMap);
        }


        //手术记录  同步更改
        if(CollUtil.isNotEmpty(patientData.getDwdOperationRecordList()) && CollUtil.isNotEmpty(patientData.getDwdOperationRecordItemList())){
            Map<String, List<XXRuleRoamHealthItem>> operationRecordMap = RuleRoamHealthDataConvert.getOperationRecord(patientData.getDwdOperationRecordList(),
                    patientData.getDwdOperationRecordItemList());
            ruleData.addHealthData(operationRecordMap);
        }

        Map<String,DwdPatientMedicalRecordInfo> dwdEmrMap =new HashMap<>();
        if(CollUtil.isNotEmpty(patientData.getDwdEmrList())){
            patientData.getDwdEmrList().forEach(item->{
                dwdEmrMap.put(item.getId(),item);
            });
        }

        //电子病例-症状
        if(CollUtil.isNotEmpty(patientData.getDwdEmrList()) && CollUtil.isNotEmpty(patientData.getDwdEmrSymptomList())){
            Map<String,List<XXRuleRoamHealthItem>> zsSymptom= RuleRoamHealthDataConvert.getEmrSymptom(RuleCondtionDataTypeEnum.EMR_SymptomZS,null,patientData.getDwdEmrSymptomList());
            ruleData.addHealthData(zsSymptom);

            Map<String,List<XXRuleRoamHealthItem>> jwsSymptom= RuleRoamHealthDataConvert.getEmrSymptom(RuleCondtionDataTypeEnum.EMR_SymptomJWS,null,patientData.getDwdEmrSymptomList());
            ruleData.addHealthData(jwsSymptom);

            Map<String,List<XXRuleRoamHealthItem>> xbsSymptom= RuleRoamHealthDataConvert.getEmrSymptom(RuleCondtionDataTypeEnum.EMR_SymptomXBS,null,patientData.getDwdEmrSymptomList());
            ruleData.addHealthData(xbsSymptom);
        }


        //电子病例-查体-基本
        if(CollUtil.isNotEmpty(patientData.getDwdEmrList()) && CollUtil.isNotEmpty(patientData.getDwdEmrCheckBasicList())){
            Map<String,List<XXRuleRoamHealthItem>> checkBasic= RuleRoamHealthDataConvert.getPhysicalSign(dwdEmrMap,patientData.getDwdEmrCheckBasicList());
            ruleData.addHealthData(checkBasic);
        }


        //当前标签
        if(CollUtil.isNotEmpty(patientData.getLabelList())){
            Map<String, List<XXRuleRoamHealthItem>> labelRecordMap = RuleRoamHealthDataConvert.getLabel(patientData.getLabelList());
            ruleData.addHealthData(labelRecordMap);
        }

        //历史标签
        if(CollUtil.isNotEmpty(patientData.getHistoryLabelList())){
            Map<String, List<XXRuleRoamHealthItem>> labelRecordMap = RuleRoamHealthDataConvert.getLabelHis(patientData.getHistoryLabelList());
            ruleData.addHealthData(labelRecordMap);
        }

        //量表
        if(CollUtil.isNotEmpty(patientData.getScaleList())){
            Map<String, List<XXRuleRoamHealthItem>> scaleRecordMap = RuleRoamHealthDataConvert.getScale(patientData.getScaleList());
            ruleData.addHealthData(scaleRecordMap);
        }



//        //体检总报告
//        Map<String, List<XXRuleRoamHealthItem>> medicalGeneralReportMap = RuleRoamHealthDataConvert.getMedicalGeneralReport(patientData.getDwdMedicalGeneralReportList());
//        ruleData.addHealthData(medicalGeneralReportMap);
//
//        //收费记录
//        Map<String, List<XXRuleRoamHealthItem>> collectFeeRecordMap = RuleRoamHealthDataConvert.getCollectFeeRecord(patientData.getDwdCollectFeeRecordList());
//        ruleData.addHealthData(collectFeeRecordMap);

        return ruleData;
    }



}
