package com.xxh.cloud.dw.healthy.engine.modules.action.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.xxh.cloud.dw.healthy.engine.modules.action.service.ComXxhActionService;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.ClientActionMethodBO;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.WorkFlowExecuteResultBO;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Log4j2
@Service
public class ComXxhActionServiceImpl implements ComXxhActionService {


    @Autowired
    private ComXxhLabelMethodService comXxhLabelMethodService;

    @Autowired
    private ComXxhPushServMethodService comXxhPushServMethodService;

    @Autowired
    private ComXxhPushTaskMethodService comXxhPushTaskMethodService;

    @Autowired
    private ComXxhRiskMethodService comXxhRiskMethodService;



    @Override
    public void execute(WorkFlowExecuteResultBO params, Map<String, Date> eventData) {
        ClientActionMethodBO method= params.getMethod();
        if("com.xxh.risk".equals(method.getAid())){
            comXxhRiskMethodService.execute(params,eventData);
        }else if("com.xxh.pustTask".equals(method.getAid())){
            comXxhPushTaskMethodService.execute(params,eventData);
        }else if("com.xxh.pushServer".equals(method.getAid())){
            comXxhPushServMethodService.execute(params,eventData);
        }else if("com.xxh.label".equals(method.getAid())){
            comXxhLabelMethodService.execute(params,eventData);
        }else {
            log.error("+++++不支持的动作,动作名称:{}",method.getAid());
        }
    }

    @Override
    public void execute(List<WorkFlowExecuteResultBO> params, Map<String, Date> eventData) {
        if(CollUtil.isEmpty(params)){
            return;
        }
        for(WorkFlowExecuteResultBO item:params){
            this.execute(item,eventData);
        }
    }


}
