package com.xxh.cloud.dw.healthy.engine.modules.action.service.impl;

import cn.hutool.core.convert.Convert;
import com.xxh.cloud.dw.healthy.engine.modules.action.service.ComXxhActionMethodService;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.healthy.serve.pushTask.client.api.DoctorTaskClientService;
import com.xxh.cloud.healthy.serve.pushTask.client.api.bean.dto.UserTaskInfoAddDTO;
import com.xxh.cloud.log.bean.constant.ObjectTypeEnum;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.ClientActionMethodBO;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.ClientActionMethodParamBO;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.WorkFlowExecuteResultBO;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.Map;

/**
 *
 * */
@Log4j2
@Service
public class ComXxhPushTaskMethodService implements ComXxhActionMethodService {

    @Autowired
    private DoctorTaskClientService doctorTaskClientService;



    @Override
    public void execute(WorkFlowExecuteResultBO params, Map<String, Date> eventData) {
        if("Push_Task".equals(params.getMethod().getF())){
            this.addTask(params.getTaskId(),params.getTaskNodeId(),params.getRuleConfigId(),params.getExecuteUserIds(),params.getMethod());
        }else {
            System.out.println("不支持的方法 : "+params.getMethod().getF());
        }
    }


    /**
     * 医生新增任务
     * */
    public void addTask(String taskId,String nodeTaskId,String ruleConfigId,String executeUserIds,ClientActionMethodBO method){
        System.out.println("++++++++ 医生新增任务 +++++++++");

        String param_patientId=null;
        String param_taskId=null;

        for(ClientActionMethodParamBO amp: method.getP()){
            if("userId".equals(amp.getParamCode())){
                if(amp.getVal()!=null){
                    param_patientId = Convert.toStr(amp.getVal());
                }
            }
            if("taskId".equals(amp.getParamCode())){
                if(amp.getVal()!=null){
                    param_taskId = Convert.toStr(amp.getVal());
                }
            }
        }

        UserTaskInfoAddDTO userTaskInfoAddParam=new UserTaskInfoAddDTO();
        userTaskInfoAddParam.setTaskId(param_taskId);
        userTaskInfoAddParam.setDoctorIds(StrJoinSplitUtils.split2List(executeUserIds));
        userTaskInfoAddParam.setRelType(ObjectTypeEnum.OT_FlowNodeTask.getCode());
        userTaskInfoAddParam.setRelOneId(nodeTaskId);
        userTaskInfoAddParam.setRelTwoId(param_patientId);
        userTaskInfoAddParam.setPatientId(param_patientId);

        doctorTaskClientService.add(userTaskInfoAddParam);

    }




}
