package com.xxh.cloud.dw.healthy.engine.modules.exe.helper;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.common.mq.constant.DataSceneType;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.framework.common.utils.XXEnumUtil;
import com.xxh.cloud.metadata.framework.modules.common.constant.enums.RuleCondtionDataTypeEnum;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class DataScopeChangeUtils {

//    public static void main(String[] args) {
//        String data=  DataScopeChangeUtils.getDataScopeChangeValue(StrUtil.format("{},{}",DataSceneType.DS_InChange,DataSceneType.DS_ExamineApply));
//        System.out.println(data);
//    }



    public static String getDataScopeChangeValue(String dataScopes){
        if(StrUtil.isEmpty(dataScopes)){
            return null;
        }
        Set<String> dataScopeSet = StrJoinSplitUtils.split2Set(dataScopes);
        if(CollUtil.isEmpty(dataScopeSet)){
            return null;
        }
        Set<String> dataSet=new HashSet<>();

        for(String dsval:dataScopeSet){
            Set<String>  changeSetNew= DataScopeChangeUtils.change(dsval);
            dataSet.addAll(changeSetNew);
        }
        return StrJoinSplitUtils.join(dataSet);
    }



    private static Set<String> change(String val){
        Set<String> dataScopeSet =new HashSet<>();

        dataScopeSet.add(RuleCondtionDataTypeEnum.MDS_Label.getCode());

        //ALL,默认场景
        if(DataSceneType.DS_All.equals(val) || DataSceneType.DS_Def.equals(val) ){
            List<RuleCondtionDataTypeEnum> list= XXEnumUtil.getEnumList(RuleCondtionDataTypeEnum.class);
            list.forEach(item->{
                dataScopeSet.add(item.getCode());
            });
            return dataScopeSet;
        }

        //患者
        //todo: 2024-10-11 关闭，条件引擎出现先执行情况。排查患者信息更新触发引擎
//        if(DataSceneType.DS_Patient.equals(val)){
//            dataScopeSet.add(RuleCondtionDataTypeEnum.MDT_Patient.getCode());
//            return dataScopeSet;
//        }

        //挂号
        if(DataSceneType.DS_Register.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Reserve_RegisterRecord.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.RegisterRecord.getCode());
            return dataScopeSet;
        }



        //就诊
        if(DataSceneType.DS_Visit.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.VisitRecord.getCode());
            return dataScopeSet;
        }

        //住院预约
        if(DataSceneType.DS_InReserve.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Reserve_Inpatient.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.Reserve_Inpatient_Not.getCode());
            return dataScopeSet;
        }

        //住院
        if(DataSceneType.DS_In.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Inpatient.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.Inpatient_Not.getCode());
            return dataScopeSet;
        }

        //住院变更
        if(DataSceneType.DS_InChange.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Change_Ward.getCode());
            return dataScopeSet;
        }

        //出院
        if(DataSceneType.DS_Out.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Discharge.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.DischargeSummary.getCode());
            return dataScopeSet;
        }

        //出院小结
        if(DataSceneType.DS_OutContent.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.DischargeSummary.getCode());
            return dataScopeSet;
        }

        //检查申请
        if(DataSceneType.DS_ExamineApply.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Apply_Examine.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.Apply_Pathology.getCode());
            return dataScopeSet;
        }

        //检查预约
        if(DataSceneType.DS_ExamineReserve.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Reserve_Examine.getCode());
            return dataScopeSet;
        }

        //检查报告
        if(DataSceneType.DS_ExamineReport.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Report_Examine.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.Report_Pathology.getCode());
            return dataScopeSet;
        }

        //检验申请
        if(DataSceneType.DS_LaboratoryApply.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Apply_Laboratory_Group.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.Apply_Laboratory_Project.getCode());
            return dataScopeSet;
        }

        //检验申请明细
        if(DataSceneType.DS_LaboratoryApplyItem.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Apply_Laboratory_Group.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.Apply_Laboratory_Project.getCode());
            return dataScopeSet;
        }

        //检验报告
        if(DataSceneType.DS_LaboratoryReport.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Report_Laboratory.getCode());
            return dataScopeSet;
        }

        //检验报告明细
        if(DataSceneType.DS_LaboratoryReportItem.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Report_Laboratory.getCode());
            return dataScopeSet;
        }

        //用药
        if(DataSceneType.DS_Medicine.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Medicine_MZ.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.Medicine_JZ.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.Medicine_ZY.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.Medicine_CY.getCode());
            return dataScopeSet;
        }

        //治疗
        if(DataSceneType.DS_Therapy.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Therapy.getCode());
            return dataScopeSet;
        }

        //手术申请
        if(DataSceneType.DS_OpApply.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Apply_Operation.getCode());
            return dataScopeSet;
        }

        //手术记录
        if(DataSceneType.DS_Operation.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.OperationRecord.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.OperationText.getCode());
            return dataScopeSet;
        }

        //手术记录明细
        if(DataSceneType.DS_OperationItem.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.OperationRecord.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.OperationText.getCode());
            return dataScopeSet;
        }

        //量表
        if(DataSceneType.DS_Scale.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.ScaleResult.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.ScaleItemResult.getCode());
            return dataScopeSet;
        }


        //诊断
        if(DataSceneType.DS_Diagnosis.equals(val)){
            dataScopeSet.add(RuleCondtionDataTypeEnum.Diagnosis.getCode());
            dataScopeSet.add(RuleCondtionDataTypeEnum.MDS_Disease.getCode());
            return dataScopeSet;
        }

        return dataScopeSet;
    }





}
