package com.xxh.cloud.dw.healthy.engine.modules.exe.helper;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdLaboratoryReportInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdLaboratoryReportItemInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdPatientInfo;
import com.xxh.cloud.dw.healthy.engine.modules.data.convert.DwdPatientDataConvert;
import com.xxh.cloud.dw.healthy.engine.modules.data.convert.RuleRoamHealthDataConvert;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import com.xxh.cloud.rule.basic.context.XXRuleRoamHealthItem;
import com.xxh.cloud.rule.core.context.XXRuleContext;
import com.xxh.cloud.rule.core.entity.flow.XXFlowNodeBO;
import com.xxh.cloud.rule.core.entity.flow.XXFlowRuleBO;
import com.xxh.cloud.rule.flow.workflow.XXWorkFlowExecutor;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

public class RoamDataTest {

    public DwdPatientInfo getDwdPatientInfo(){
        DwdPatientInfo data=new DwdPatientInfo();
        data.setPatientId("P100");
        data.setPatientName("测试患者");
        data.setCardNoTypeStandard("1");
        data.setCardNo("330");
        data.setPatientGenderStandard("女");
        data.setBirthday("1990-10-10");
        data.setPhone("129");
        data.setOpDate(new Date());
        return data;
    }

    public List<DwdLaboratoryReportInfo> getDwdLaboratoryReportInfoList(){
        List<DwdLaboratoryReportInfo> data=new ArrayList<>();

        DwdLaboratoryReportInfo data1=new DwdLaboratoryReportInfo();
        data1.setId("1");
        data1.setPatientId("P100");
        data1.setDepartmentNameStandard("外科");
        data1.setDepartmentCodeStandard("WK");
        data1.setReportsTime(new Date());
        data1.setCheckTime(new Date());
        data1.setApplyTime(new Date());
//        data1.setTypeStandard("");
        data1.setReportName("测试报告");
        data1.setOpDate(new Date());

        data.add(data1);

        return data;
    }

    public  List<DwdLaboratoryReportItemInfo> getDwdLaboratoryReportItemInfoList(){
        List<DwdLaboratoryReportItemInfo> data=new ArrayList<>();

        DwdLaboratoryReportItemInfo data1=new DwdLaboratoryReportItemInfo();
        data1.setId("1111");
        data1.setLaboratoryReportId("1");
        data1.setProjectGroupCodeStandard("G01");
        data1.setProjectGroupNameStandard("名称G01");
        data1.setProjectIdStandard("lab_item_00007");
        data1.setNameStandard("蛋白[24h尿]");
        data1.setUnitStandard("ml");
        data1.setReferenceStandard("1-20");
//        data1.setInspectResultStandard("8");
        data.add(data1);


        return data;
    }


    public static void main(String[] args) {
        RoamDataTest roamDataTest=new RoamDataTest();


        XXRuleRoam ruleData=new XXRuleRoam();
        //基础信息
        Map<String, XXRuleRoamHealthItem> basicData= DwdPatientDataConvert.getDwdPatientBasicData(roamDataTest.getDwdPatientInfo());
        ruleData.addBasicHealthData(basicData);


        //检验报告单
        Map<String, List<XXRuleRoamHealthItem>> laboratoryReportMap = RuleRoamHealthDataConvert.getLaboratoryReport(
                roamDataTest.getDwdLaboratoryReportInfoList(),roamDataTest.getDwdLaboratoryReportItemInfoList());
        ruleData.addHealthData(laboratoryReportMap);



        //检查报告单
//        Map<String, List<XXRuleRoamHealthItem>> examineReportMap = RuleRoamHealthDataConvert.getExamineReport(patientData.getDwdExamineReportList());
//        ruleData.addHealthData(examineReportMap);





//        String taskId="T0001";
//
//
//        String _config="{\"childNode\":{\"content\":\"新增7日有效期标签\",\"nodeId\":\"324CYg1\",\"prevId\":\"N5laXg1\",\"properties\":{\"action\":{\"actionId\":\"com.xxh.label\",\"actionName\":\"\",\"advanceRatio\":10,\"auto\":\"\",\"checkRatio\":0,\"checkWay\":\"\",\"exeRatio\":0,\"exeType\":\"all\",\"executorIds\":[],\"executorType\":\"none\",\"methodCode\":\"Add_Label\",\"methodName\":\"新增标签\",\"params\":[{\"ovo\":{\"memo\":\"\",\"val\":\"\"},\"ovs\":[],\"ovtwoType\":\"\",\"ovtype\":\"variable\",\"paramCode\":\"userId\",\"paramName\":\"患者ID\",\"paramType\":\"\"},{\"ovo\":{\"memo\":\"\",\"val\":\"\"},\"ovs\":[{\"memo\":\"\",\"val\":\"L1702582071677702144\"},{\"memo\":\"\",\"val\":\"L1702580640056889344\"},{\"memo\":\"\",\"val\":\"L1702580076384374784\"}],\"ovtwoType\":\"\",\"ovtype\":\"fixed\",\"paramCode\":\"labelId\",\"paramName\":\"标签编号\",\"paramType\":\"\"},{\"ovo\":{\"memo\":\"7\",\"val\":\"7\"},\"ovs\":[],\"ovtwoType\":\"\",\"ovtype\":\"fixed\",\"paramCode\":\"limitTime\",\"paramName\":\"有效期(天)\",\"paramType\":\"\"}],\"triggerEndNum\":0,\"triggerLoopNum\":0,\"triggerStartNum\":0},\"ruleType\":\"action\",\"title\":\"动作节点\"},\"type\":\"approver\"},\"content\":\"最近7天，蛋白 1-20的患者\",\"nodeId\":\"N5laXg1\",\"properties\":{\"action\":{\"advanceRatio\":0,\"checkRatio\":0,\"exeRatio\":0,\"exeType\":\"all\",\"triggerEndNum\":0,\"triggerLoopNum\":0,\"triggerStartNum\":0},\"condition\":{\"children\":[{\"id\":\"gTseeg1\",\"property\":{\"dateType\":\"standard\",\"deptCodes\":[],\"dtLimitEnd\":\"0\",\"dtLimitStart\":\"7\",\"dtLimitUnit\":\"D\",\"dtRangeType\":\"relative\",\"lxtjNum\":1,\"mdCode\":\"lab_item_00007\",\"mdName\":\"蛋白[24h尿]\",\"mdType\":\"d\",\"mdTypeCode\":\"laboratory_project\",\"mdTypeName\":\"\",\"op\":\"range\",\"opChild\":\"\",\"oval\":\"1\",\"ovalMany\":[],\"ovalTwo\":\"20\",\"rawType\":\"d\",\"restriction\":\"Y\",\"rytjNum\":1,\"sampleCode\":\"\",\"sampleName\":\"\",\"ynDept\":\"Y\",\"ynType\":\"Y\"},\"relation\":\"\",\"type\":\"property\"}],\"id\":\"dVlaXg1\",\"relation\":\"and\",\"type\":\"relation\"},\"ruleType\":\"condition\",\"title\":\"开始节点\"},\"type\":\"start\"}";
//        XXFlowNodeBO flowNodeBO= JSON.parseObject(_config,XXFlowNodeBO.class);
//
//        XXFlowRuleBO ruleConfig=new XXFlowRuleBO();
//        ruleConfig.setId("1702529692660162560");
//        ruleConfig.setConfig(flowNodeBO);
//
////        String _data="{\"20230918\":{\"laboratory_project__20230918113522\":{\"dataDate\":\"2023-09-18 11:35:22.228\",\"deptCode\":\"WK\",\"mdc\":\"laboratory_project__20230918113522\",\"mdv\":{\"applyTime\":\"2023-09-18 11:35:22.228\",\"checkTime\":\"2023-09-18 11:35:22.228\",\"departmentCodeStandard\":\"WK\",\"departmentNameStandard\":\"外科\",\"id\":\"1\",\"itemMap\":{\"lab_item_00007\":{\"inspectResultStandard\":\"8\",\"nameStandard\":\"蛋白[24h尿]\",\"projectIdStandard\":\"lab_item_00007\",\"referenceStandard\":\"1-20\",\"unitStandard\":\"ml\"}},\"opDate\":\"2023-09-18 11:35:22.228\",\"patientId\":\"P100\",\"reportName\":\"测试报告\",\"reportsTime\":\"2023-09-18 11:35:22.228\",\"typeStandard\":\"\"},\"type\":\"laboratory_project\"}},\"basic\":{\"birthday\":{\"mdc\":\"birthday\",\"mdv\":\"1990-10-10\",\"type\":\"md_patient\"},\"patient_gender\":{\"mdc\":\"patient_gender\",\"mdv\":\"女\",\"type\":\"md_patient\"},\"card_no\":{\"mdc\":\"card_no\",\"mdv\":\"330\",\"type\":\"md_patient\"},\"phone\":{\"mdc\":\"phone\",\"mdv\":\"129\",\"type\":\"md_patient\"},\"patient_id\":{\"mdc\":\"patient_id\",\"mdv\":\"P100\",\"type\":\"md_patient\"},\"patient_name\":{\"mdc\":\"patient_name\",\"mdv\":\"测试患者\",\"type\":\"md_patient\"},\"card_no_type\":{\"mdc\":\"card_no_type\",\"mdv\":\"1\",\"type\":\"md_patient\"}}}";
////        XXRuleRoam data=JSON.parseObject(_data,XXRuleRoam.class);
//
//        System.out.println("======================");
//
//        XXRuleContext context= XXWorkFlowExecutor.start(taskId,ruleConfig,ruleData);
//
//
//        System.out.println(JSON.toJSONString(context.getNodeLogList()));

//        System.out.println(JSON.toJSONString(context));



    }


}
