package com.xxh.cloud.dw.healthy.engine.modules.exe.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.dw.healthy.engine.modules.action.service.ComXxhActionService;
import com.xxh.cloud.dw.healthy.engine.modules.exe.service.DwdDataExecuteRuleEventService;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import com.xxh.cloud.rule.execute.inference.client.api.RuleExecute2EventClientService;
import com.xxh.cloud.rule.execute.inference.client.bean.bos.WorkFlowExecuteResultBO;
import com.xxh.cloud.rule.execute.inference.client.bean.dto.EventFlowExecuteByEventDTO;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Log4j2
@Service
public class DwdDataExecuteRuleEventServiceImpl implements DwdDataExecuteRuleEventService {

    @Autowired
    private RuleExecute2EventClientService ruleExecute2EventClientService;
    @Autowired
    private ComXxhActionService comXxhActionService;


    @Override
    public List<WorkFlowExecuteResultBO> execute(String eventId, String patientId, XXRuleRoam ruleRoam, Map<String, Date> patientEventData) {
        //ConsoleUtils.log("++++++事件引擎:患者数据 = {}",JSON.toJSONString(ruleRoam));
        EventFlowExecuteByEventDTO executeByEventDTO=new EventFlowExecuteByEventDTO();
        executeByEventDTO.setEventId(eventId);
        executeByEventDTO.setData(ruleRoam);
        List<WorkFlowExecuteResultBO> resultList= ruleExecute2EventClientService.startExecute(executeByEventDTO);

        comXxhActionService.execute(resultList,patientEventData);
        return resultList;
    }

    @Override
    public List<WorkFlowExecuteResultBO> executeNotCallBiz(String eventId, String patientId, XXRuleRoam ruleRoam, Map<String, Date> patientEventData) {
        EventFlowExecuteByEventDTO executeByEventDTO=new EventFlowExecuteByEventDTO();
        executeByEventDTO.setEventId(eventId);
        executeByEventDTO.setData(ruleRoam);
        List<WorkFlowExecuteResultBO> resultList= ruleExecute2EventClientService.startExecute(executeByEventDTO);
        return resultList;
    }


}
