package com.xxh.cloud.dw.healthy.engine.modules.biz.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.xxh.cloud.common.mq.bean.qr.RuleLabelRunBO;
import com.xxh.cloud.dw.healthy.engine.modules.data.bean.bos.DwdPatientDataBO;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.PatientDataLabel2EventService;
import com.xxh.cloud.dw.healthy.engine.modules.data.service.RuleEngineDataService;
import com.xxh.cloud.dw.healthy.engine.modules.exe.bean.dto.PatientDataExtendDTO;
import com.xxh.cloud.dw.healthy.engine.modules.exe.service.DwdDataExecuteLabelService;
import com.xxh.cloud.dw.healthy.engine.modules.exe.service.DwdDataExecuteRuleFlowService;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class DataPatientLabelRuleRunService {

    @Autowired
    private DataPatientCacheGetService dataPatientCacheGetService;

    @Autowired
    private PatientDataLabel2EventService patientDataLabel2EventService;

    @Autowired
    private DwdDataExecuteLabelService dwdDataExecuteLabelService;
    @Autowired
    private DwdDataExecuteRuleFlowService dwdDataExecuteRuleFlowService;

    @Autowired
    private RuleEngineDataService ruleEngineDataService;

    @Autowired
    private DataPatientRunExeCallbackService dataPatientRunExeCallbackService;


    public void process(List<RuleLabelRunBO> list,boolean isReal ,String opUser){
        List<String> patientIds=new ArrayList<>();
        List<String> updateIds=new ArrayList<>();

        Map<String, PatientDataExtendDTO> patientDataExtendMap=new HashMap<>();

        list.forEach(item->{
            if(item!=null && StrUtil.isNotEmpty(item.getPid())){
                patientIds.add(item.getPid());
                List<String> _ids= StrJoinSplitUtils.split2List(item.getIds());
                if(CollUtil.isNotEmpty(_ids)){
                    updateIds.addAll(_ids);
                }
                if(isReal){
                    patientDataExtendMap.put(item.getPid(),new PatientDataExtendDTO(item.getDt(), YN.YES.getCode(), item.getScopes()));
                }else {
                    patientDataExtendMap.put(item.getPid(),new PatientDataExtendDTO(item.getDt()));
                }
            }
        });

        if(CollUtil.isEmpty(patientIds)){
            return;
        }

        List<DwdPatientDataBO> patientDataList=ruleEngineDataService.getDwdPatientDataList(patientIds);
        Map<String, XXRuleRoam> patientDataMap= ruleEngineDataService.getRuleRoamMapByData(patientDataList);
        Map<String,Map<String, Date>> eventData= patientDataLabel2EventService.getPatientEvent(patientIds);


        ConsoleUtils.log("+++++ 1. 执行患者标签引擎");
        dwdDataExecuteLabelService.executeLabelRuleByPatientData(patientDataMap,patientDataExtendMap,opUser);

        ConsoleUtils.log("+++++ 2. 重新获取患者标签数据");
        List<DwdPatientDataBO> patientDataList2=ruleEngineDataService.reloadRuleRoamMap(patientIds,patientDataList);
        Map<String, XXRuleRoam> patientDataMap2= ruleEngineDataService.getRuleRoamMapByData(patientDataList2);

        ConsoleUtils.log("+++++ 3. 执行患者流程引擎");
        dwdDataExecuteRuleFlowService.executeAll(patientDataMap2,eventData);

        dataPatientRunExeCallbackService.updateLabelRuleStatus(updateIds);
    }









}
