package com.xxh.cloud.dw.healthy.engine.modules.event.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson2.JSON;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.xxh.cloud.common.mq.bean.MQPatientEventBean;
import com.xxh.cloud.dw.healthy.engine.modules.event.config.PatientEventTableWriteConfigUtils;
import com.xxh.cloud.dw.healthy.engine.modules.event.service.PatientEventOpBizService;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.write.bean.DbTaskResult;
import com.xxh.cloud.framework.common.write.bean.HwdsWriteDBConfigBean;
import com.xxh.cloud.framework.common.write.doris.DorisWriter;
import com.xxh.cloud.framework.common.write2.DorisWriteUtils;
import com.xxh.cloud.web.common.config.XmWriteConfig;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import javax.sql.DataSource;
import java.util.*;

@DS("wd")
@Log4j2
@Service
public class PatientEventOpBizServiceImpl implements PatientEventOpBizService {

//    @Autowired
//    private XmWriteConfig xmWriteConfig;


    @Autowired
    private JdbcTemplate jdbcTemplate;

    private DataSource dataSource;


    @Override
    public void save(List<MQPatientEventBean> list) {
        if(CollUtil.isEmpty(list)){
            log.debug("+++++ 无事件数据不处理");
            return;
        }

        HwdsWriteDBConfigBean writeDBConfig= PatientEventTableWriteConfigUtils.dws_patient_event_info();
//        writeDBConfig.setUrl(xmWriteConfig.getUrl());
//        writeDBConfig.setUsername(xmWriteConfig.getUsername());
//        writeDBConfig.setPassword(xmWriteConfig.getPassword());
//        DorisWriter dorisWriter=new DorisWriter();
        List<Map<String, Object>> dataList=new ArrayList<>();
        for(MQPatientEventBean item:list){
            Map<String, Object> dataItemMap=new HashMap<>();
            dataItemMap.put("patient_id",item.getPatientId());
            dataItemMap.put("event_type",item.getEventType());
            dataItemMap.put("event_date",item.getEventDate());
            dataList.add(dataItemMap);
        }
        if(this.dataSource==null){
            System.out.println("++++ init dataSource ............");
            this.dataSource = jdbcTemplate.getDataSource();
        }
         DorisWriteUtils.batchWrite(this.dataSource,writeDBConfig,dataList);



       // DbTaskResult writerResult= dorisWriter.writer(writeDBConfig,dataList);
    }



}
