package com.xxh.cloud.dw.healthy.engine.modules.mq.consumer;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.common.mq.bean.qr.RuleEventRunBO;
import com.xxh.cloud.common.mq.bean.qr.RuleLabelRunBO;
import com.xxh.cloud.common.mq.constant.HMQQueueName;
import com.xxh.cloud.common.mq.constant.HMQQueueName2EventExe;
import com.xxh.cloud.dw.healthy.engine.modules.biz.service.DataPatientEventRuleRunService;
import com.xxh.cloud.dw.healthy.engine.modules.biz.service.DataPatientLabelRuleRunService;
import com.xxh.cloud.dw.healthy.engine.modules.data.bean.bos.DwdPatientDataBO;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.rule.basic.context.XXRuleRoam;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jms.annotation.JmsListener;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Log4j2
@Component
public class DataEventTaskConsumer {

    @Autowired
    private DataPatientEventRuleRunService dataPatientEventRuleRunService;

    @Autowired
    private DataPatientLabelRuleRunService dataPatientLabelRuleRunService;



    //todo:2024-10-16 发布测试,临时关闭 remove
    /**
     *
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_Def)
    public void consumer_real(String message) {
        ConsoleUtils.log("++++++实时队列处理：事件规则消费");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }

    /**
     *
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_register)
    public void consumer_event_register(String message) {
        ConsoleUtils.log("++++++实时队列处理：register ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }

    /**
     *
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_ExamineReport)
    public void consumer_event_examineReport(String message) {
        ConsoleUtils.log("++++++实时队列处理：ExamineReport ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }


    /**
     *
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_LaboratoryReport)
    public void consumer_event_LaboratoryReport(String message) {
        ConsoleUtils.log("++++++实时队列处理：LaboratoryReport ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }

    /**
     *
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_InReserve)
    public void consumer_event_InReserve(String message) {
        ConsoleUtils.log("++++++实时队列处理：InReserve ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }

    /**
     *
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_In)
    public void consumer_event_In(String message) {
        ConsoleUtils.log("++++++实时队列处理：In ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }

    /**
     *
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_Out)
    public void consumer_event_Out(String message) {
        ConsoleUtils.log("++++++实时队列处理：Out ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }

    /**
     *
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_ExamineApply)
    public void consumer_event_ExamineApply(String message) {
        ConsoleUtils.log("++++++实时队列处理：ExamineApply ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }

    /**
     *
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_LaboratoryApply)
    public void consumer_event_LaboratoryApply(String message) {
        ConsoleUtils.log("++++++实时队列处理：LaboratoryApply ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }

    /**
     * 用药
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_Medicine)
    public void consumer_event_Medicine(String message) {
        ConsoleUtils.log("++++++实时队列处理：Medicine ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }

    /**
     * 手术申请
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_OpApply)
    public void consumer_event_OpApply(String message) {
        ConsoleUtils.log("++++++实时队列处理：手术申请 OpApply ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }



    /**
     * 手术执行
     * */
    @JmsListener(destination =  HMQQueueName2EventExe.Que_Event_Exe_OpExe)
    public void consumer_event_OpExe(String message) {
        ConsoleUtils.log("++++++实时队列处理：手术执行 OPExe ");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleEventRunBO> list= JSON.parseArray(message,RuleEventRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        //执行事件
        dataPatientEventRuleRunService.process(list);
    }





}
