package com.xxh.cloud.dw.healthy.engine.modules.mq.consumer;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.common.mq.bean.qr.RuleEventRunBO;
import com.xxh.cloud.common.mq.bean.qr.RuleLabelRunBO;
import com.xxh.cloud.common.mq.constant.HMQQueueName;
import com.xxh.cloud.common.mq.constant.HMQQueueName2RuleExe;
import com.xxh.cloud.dw.healthy.engine.modules.biz.service.DataPatientLabelRuleRunService;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jms.annotation.JmsListener;
import org.springframework.stereotype.Component;

import java.util.List;

@Log4j2
@Component
public class DataLabelTaskConsumer {

    @Autowired
    private DataPatientLabelRuleRunService dataPatientLabelRuleRunService;



    //todo:2024-10-16 发布测试,临时关闭
    /**
     * 历史标签数据 ok
     * */
    @JmsListener(destination = HMQQueueName2RuleExe.Que_Label_RunHis)
    public void consumer_his(String message) {
        ConsoleUtils.log("++++++ 历史数据处理： 标签规则消费");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleLabelRunBO> list= JSON.parseArray(message, RuleLabelRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        dataPatientLabelRuleRunService.process(list,false,"MQ");
    }


    /**
     * 标签规则:执行(实时队列) ok
     * */
    @JmsListener(destination = HMQQueueName2RuleExe.Que_Label_RunReal)
    public void consumer_real(String message) {
        ConsoleUtils.log("++++++ 实时队列处理:标签规则消费[默认场景]");
        if(StrUtil.isEmpty(message)){
            return;
        }
        List<RuleLabelRunBO> list= JSON.parseArray(message, RuleLabelRunBO.class);
        if(CollUtil.isEmpty(list)){
            return;
        }
        dataPatientLabelRuleRunService.process(list,true,"MQ");
    }





}
