package com.xxh.cloud.data.run.modules.mq.consumer;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.io.file.FileAppender;
import cn.hutool.core.util.StrUtil;
import cn.hutool.log.StaticLog;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.common.mq.bean.MQPatientEventBean;
import com.xxh.cloud.common.mq.constant.HMQQueueName;
import com.xxh.cloud.common.mq.constant.PatientEventEnum;
import com.xxh.cloud.data.run.modules.biz.service.PatientEventRuleIngBizService;
import com.xxh.cloud.data.run.modules.dw.service.DwsPatientEventBizService;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jms.annotation.JmsListener;
import org.springframework.stereotype.Component;

import java.io.File;
import java.util.Date;
import java.util.List;

@Log4j2
@Component
public class DataRunEventConsumer {

    @Autowired
    private DwsPatientEventBizService dwsPatientEventBizService;

    @Autowired
    private PatientEventRuleIngBizService patientEventRuleIngBizService;


    @JmsListener(destination= HMQQueueName.Que_Event_Data_Sava)
    public void consumer(String message) {
        ConsoleUtils.log("++++++++ 消费事件规则");
        if(StrUtil.isEmpty(message)){
            ConsoleUtils.log("+++++ 无消费数据");
            return;
        }
        List<MQPatientEventBean> list= JSON.parseArray(message,MQPatientEventBean.class);
        if(CollUtil.isEmpty(list)){
            return;
        }


        MQPatientEventBean mqbean= list.get(0);
        if(PatientEventEnum.PE_E1110.getCode().equals( mqbean.getEventType())){
            try {

                String path="/home/debug_log/xx_data/";
                String filePath = path+"Data_Event_Consumer_"+DateUtil.format(new Date(),"yyyyMMdd")+".log";
                File file = new File(filePath);
                if(!file.exists()){
                    FileUtil.touch(file);
                }
                FileAppender appender =new FileAppender(file,100,true);
                appender.append("DataRunEventConsumer.consumer E1110 执行手术 MQ 消息内容");
                appender.append(DateUtil.now());
                list.forEach(item->{
                    appender.append(JSON.toJSONString(item));
                });
                appender.flush();

            }catch (Exception e){
                e.printStackTrace();
            }
        }






        dwsPatientEventBizService.saveDwsPatientEvent(list);
        patientEventRuleIngBizService.addEventIng(list);
    }





}
