package com.xxh.cloud.data.run.modules.mq.consumer;


import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.common.mq.bean.MQRuleLabelBean;
import com.xxh.cloud.common.mq.constant.HMQQueueName;
import com.xxh.cloud.data.run.modules.biz.service.PatientFlowRuleIngBizService;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jms.annotation.JmsListener;
import org.springframework.stereotype.Component;

import java.util.List;

@Log4j2
@Component
public class DataRunLabelConsumer {


    @Autowired
    private PatientFlowRuleIngBizService patientFlowRuleIngBizService;

    @JmsListener(destination= HMQQueueName.Que_Rule_Data_Save)
    public void consumer(String message) {
        ConsoleUtils.log("++++++++ 消费标签规则");
        if(StrUtil.isEmpty(message)){
            ConsoleUtils.log("+++++ 无消费数据");
            return;
        }
        List<MQRuleLabelBean> patientIds= JSON.parseArray(message,MQRuleLabelBean.class);
        patientFlowRuleIngBizService.addIng(patientIds);
    }













}
