package com.xxh.cloud.data.run.modules.biz.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.xxh.cloud.data.run.client.constant.RuleRunStatusEnum;
import com.xxh.cloud.data.run.modules.base.entity.PatientFlowRuleIngInfo;
import com.xxh.cloud.data.run.modules.base.entity.PatientHisTagRuleIngInfo;
import com.xxh.cloud.data.run.modules.base.service.PatientHisTagRuleIngInfoService;
import com.xxh.cloud.data.run.modules.biz.bean.bos.PatientLabelRuleHisDataBO;
import com.xxh.cloud.data.run.modules.biz.bean.mos.PatientLabelRuleHisTaskQueryMO;
import com.xxh.cloud.data.run.modules.biz.mapper.PatientLabelRuleHisDataQueryMapper;
import com.xxh.cloud.data.run.modules.biz.service.PatientLabelRuleHisDataIngBizService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Set;

@Service
public class PatientLabelRuleHisDataIngBizServiceImpl implements PatientLabelRuleHisDataIngBizService {


    @Autowired
    private PatientHisTagRuleIngInfoService patientHisTagRuleIngInfoService;
    @Autowired
    private PatientLabelRuleHisDataQueryMapper patientLabelRuleHisDataQueryMapper;


    @Override
    public List<PatientLabelRuleHisDataBO> getLabelRuleHisData2None(int num) {
        Date date=new Date();
        Date end= DateUtil.offsetMinute(date,-3);

        List<PatientLabelRuleHisDataBO> list= patientLabelRuleHisDataQueryMapper.queryPatientLabelHisTask(
                new QueryWrapper<PatientLabelRuleHisDataBO>()
                        .eq("op_status", RuleRunStatusEnum.None.getCode())
                        .le("op_time",end)
                        .groupBy("patient_id")
                        .orderByDesc("max(op_time)")
                        .last(" LIMIT " + num)
        );


        return list;
    }

    @Override
    public void updateIng(Set<String> ids) {
        if(CollUtil.isEmpty(ids)){
            return;
        }
        patientHisTagRuleIngInfoService.update(
                new UpdateWrapper<PatientHisTagRuleIngInfo>()
                        .set("op_status",RuleRunStatusEnum.Ing.getCode())
                        .set("op_time",new Date())
                        .set("op_num",1)
                        .in("id",ids)
                        .eq("op_status",RuleRunStatusEnum.None.getCode())
        );
    }


}
