package com.xxh.cloud.data.run.modules.dw.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.data.run.modules.dw.bean.bos.DwsPatientDayDataBO;
import com.xxh.cloud.data.run.modules.dw.bean.dto.PatientDayDataListDTO;
import com.xxh.cloud.data.run.modules.dw.mapper.DwsPatientDayDataQueryMapper;
import com.xxh.cloud.data.run.modules.dw.service.DwsPatientDayDataQueryBizService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@DS("wd")
@Log4j2
@Service
public class DwsPatientDayDataQueryBizServiceImpl implements DwsPatientDayDataQueryBizService {

    @Autowired
    private DwsPatientDayDataQueryMapper dwsPatientDayDataQueryMapper;


    @Override
    public List<DwsPatientDayDataBO> listPatientDayData(PatientDayDataListDTO params) {
        List<DwsPatientDayDataBO> list= dwsPatientDayDataQueryMapper.patientDataDayList(
                new QueryWrapper<DwsPatientDayDataBO>()
                        .ge("data_day",params.getStartTime())
                        .le("data_day",params.getEndTime())
                        .groupBy("patient_id")
                        .orderByAsc("patient_id")
                        .last(StrUtil.format("LIMIT {}, {} ",params.getStart(),params.getPageNum()))
        );
        return list;
    }
}
