package com.xxh.cloud.data.run.modules.dw.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.xxh.cloud.common.mq.bean.MQPatientEventBean;
import com.xxh.cloud.data.run.modules.dw.service.DwsPatientEventBizService;
import com.xxh.cloud.data.run.modules.dw.utils.PatientEventTableWriteConfigUtils2;
import com.xxh.cloud.framework.common.write.bean.DbTaskResult;
import com.xxh.cloud.framework.common.write.bean.HwdsWriteDBConfigBean;
import com.xxh.cloud.framework.common.write.doris.DorisWriter;
import com.xxh.cloud.framework.common.write2.DorisWriteUtils;
import com.xxh.cloud.web.common.config.XmWriteConfig;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import javax.sql.DataSource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@DS("wd")
@Log4j2
@Service
public class DwsPatientEventBizServiceImpl implements DwsPatientEventBizService {

//    @Autowired
//    private XmWriteConfig xmWriteConfig;


    @Autowired
    private JdbcTemplate jdbcTemplate;

    private DataSource dataSource;


    @Override
    public void saveDwsPatientEvent(List<MQPatientEventBean> list) {
        if(CollUtil.isEmpty(list)){
            log.debug("+++++ 无事件数据不处理");
            return;
        }
        HwdsWriteDBConfigBean writeDBConfig= PatientEventTableWriteConfigUtils2.dws_patient_event_info();

        DorisWriter dorisWriter=new DorisWriter();
        List<Map<String, Object>> dataList=new ArrayList<>();
        for(MQPatientEventBean item:list){
            if(StrUtil.isNotEmpty(item.getPatientId()) && StrUtil.isNotEmpty(item.getEventType()) && StrUtil.isNotEmpty(item.getEventDate())){
                Map<String, Object> dataItemMap=new HashMap<>();
                dataItemMap.put("patient_id",item.getPatientId());
                dataItemMap.put("event_type",item.getEventType());
                dataItemMap.put("event_date", Convert.toDate(item.getEventDate()));
                dataList.add(dataItemMap);
            }
        }

        if(dataList.size()<=0){
            return;
        }

        if(this.dataSource==null){
            System.out.println("++++ init dataSource ............");
            this.dataSource = jdbcTemplate.getDataSource();
        }

        DorisWriteUtils.batchWrite(this.dataSource,writeDBConfig,dataList);
    }

























}
