package com.xxh.cloud.data.run.manager.controller;


import cn.dev33.satoken.annotation.SaCheckPermission;
import com.xxh.cloud.data.run.modules.biz.bean.dto.LabelRuleRunMgrDTO;
import com.xxh.cloud.data.run.modules.biz.service.PatientLabelRuleMgrBizService;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.validator.ValidatorUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


@Log4j2
@RestController
@RequestMapping("/sys/labelRule/data/run")
@Api(tags = "数据标签规则执行管理")
public class DataLabelRuleRunManagerController {


    @Autowired
    private PatientLabelRuleMgrBizService patientLabelRuleMgrBizService;

    @SaCheckPermission("sys:labelRule:data:run:start2stop")
    @PostMapping("/start2stop")
    @ApiOperation(value = "启动和截止执行", response = String.class)
    public Result<String> start2stop(@RequestBody LabelRuleRunMgrDTO params) {
        ValidatorUtils.validateEntity(params);
        patientLabelRuleMgrBizService.runManager(params);
        return new Result<String>().ok("ok");
    }




    @GetMapping("/tw")
    public Result<String> tw() {
        return new Result<String>().ok("******tw**************");
    }




//
//    @GetMapping("/test")
//    public Result<String> test() {
//        LabelRuleRunMgrDTO params=new LabelRuleRunMgrDTO();
//        params.setId("1727506790578524160");
//        params.setStatus(LabelRuleExeStatusEnum.LRES_Start.getCode());
//        patientLabelRuleMgrBizService.runManager(params);
//
//        return new Result<String>().ok("test-save");
//    }
//
//
//
//    @GetMapping("/test2")
//    public Result<String> test2() {
//        LabelRuleRunMgrDTO params=new LabelRuleRunMgrDTO();
//        params.setId("1727506790578524160");
//        params.setStatus(LabelRuleExeStatusEnum.LRES_Stop.getCode());
//        patientLabelRuleMgrBizService.runManager(params);
//        return new Result<String>().ok("test2");
//    }
//
//    @GetMapping("/test3")
//    public Result<String> test3() {
//
//
//
////        public static final String Que_LableCal_Pid = "Que:tagRule:pid";
////        public static final String Que_PatientEvent = "Que:P:Event";
//
//
//        List<String> ids=new ArrayList<>();
//        ids.add("700");
//        ids.add("800");
//        ids.add("900");
//        ActiveMQSendUtils.send(ActiveMQWayEnum.MQ_SW_Queue, HMQQueueName.Que_LableCal_Pid, JSON.toJSONString(ids));
//
//
//        return new Result<String>().ok("test3");
//    }
//
//
//    @GetMapping("/test4")
//    public Result<String> test4() {
//
//
//
////        public static final String Que_LableCal_Pid = "Que:tagRule:pid";
////        public static final String  = "Que:P:Event";
//
//
//        List<MQPatientEventBean> eventList=new ArrayList<MQPatientEventBean>();
//        MQPatientEventBean eb1=new MQPatientEventBean();
//        eb1.setPatientId("100");
//        eb1.setEventType("E100");
//        eb1.setEventDate(DateUtil.formatDateTime(new Date()));
//
//
//        MQPatientEventBean eb2=new MQPatientEventBean();
//        eb2.setPatientId("200");
//        eb2.setEventType("E200");
//        eb2.setEventDate(DateUtil.formatDateTime(new Date()));
//
//        MQPatientEventBean eb3=new MQPatientEventBean();
//        eb3.setPatientId("300");
//        eb3.setEventType("E300");
//        eb3.setEventDate(DateUtil.formatDateTime(new Date()));
//
//        eventList.add(eb1);
//        eventList.add(eb2);
//        eventList.add(eb3);
//
//
//        ActiveMQSendUtils.send(ActiveMQWayEnum.MQ_SW_Queue, HMQQueueName.Que_PatientEvent, JSON.toJSONString(eventList));
//
//
//        return new Result<String>().ok("test4");
//    }



}
