package com.xxh.cloud.data.run.modules.task;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.ListUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.common.mq.bean.qr.RuleHisLabelRunBO;
import com.xxh.cloud.common.mq.constant.HMQQueueName;
import com.xxh.cloud.data.run.modules.biz.bean.bos.PatientEventTaskNoneBO;
import com.xxh.cloud.data.run.modules.biz.bean.bos.PatientEventTaskNoneResp;
import com.xxh.cloud.data.run.modules.biz.bean.bos.PatientLabelRuleHisDataBO;
import com.xxh.cloud.data.run.modules.biz.service.PatientLabelRuleHisDataIngBizService;
import com.xxh.cloud.data.run.modules.config.DataRunTaskConfig;
import com.xxh.cloud.framework.activemq.constant.ActiveMQWayEnum;
import com.xxh.cloud.framework.activemq.utils.ActiveMQSendUtils;
import com.xxh.cloud.framework.common.utils.ConsoleUtils;
import com.xxh.cloud.framework.common.utils.StrJoinSplitUtils;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

@Component
@Log4j2
public class DataRunHisLabelTask {


    @Autowired
    private DataRunTaskConfig dataRunTaskConfig;

    @Autowired
    private PatientLabelRuleHisDataIngBizService patientLabelRuleHisDataIngBizService;



    /**
     * 计算标签历史数据
     * */
    @XxlJob("sendLabelRuleHisDataTask")
    public void sendLabelRuleHisDataTask(){
        ConsoleUtils.log("++++++ 计算标签历史数据:启动任务{}", DateUtil.now());

        //1.
        List<PatientLabelRuleHisDataBO> list= patientLabelRuleHisDataIngBizService.getLabelRuleHisData2None(dataRunTaskConfig.getLableHisDataMum());
        if(CollUtil.isEmpty(list)){
            ConsoleUtils.log("++++++ 计算标签历史数据:无数据");
            return;
        }

        Set<String> ids=new HashSet<>();

        List<RuleHisLabelRunBO> dataList=new ArrayList<>();
        for(PatientLabelRuleHisDataBO item:list){
            List<String> configIds=  StrJoinSplitUtils.split2List(item.getLabelRuleIds());
            List<String> objIds=  StrJoinSplitUtils.split2List(item.getIds());
            dataList.add(new RuleHisLabelRunBO(item.getPatientId(),configIds,objIds));
            ids.addAll(objIds);
        }

        //2.
        List<List<RuleHisLabelRunBO>> lists= ListUtil.split(dataList,5);
        for(List<RuleHisLabelRunBO> item:lists){
            //todo: wjj 改成实时队列，发送;
            ActiveMQSendUtils.send(ActiveMQWayEnum.MQ_SW_Queue, HMQQueueName.Que_His_Label_Run_Real, JSON.toJSONString(item));
        }

        //3.
        patientLabelRuleHisDataIngBizService.updateIng(ids);

    }






}
