package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD诊断信息表
 * </p>
 *
 * @author
 * @since 2023-11-01
 */
@Data
//@EqualsAndHashCode(callSuper = true)
public class DwdDiagnosisReportInfo {

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 就诊记录号
     */
     @ApiModelProperty(value = "就诊记录号")
      private String visitId;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inPatientNo;

    /**
     * 关联处方id
     */
     @ApiModelProperty(value = "关联处方id")
      private String recipeId;

    /**
     * 患者姓名
     */
     @ApiModelProperty(value = "患者姓名")
      private String patientName;

    /**
     * 下诊断科室名称(原始)
     */
     @ApiModelProperty(value = "下诊断科室名称(原始)")
      private String departmentNameRaw;

    /**
     * 下诊断科室名称(标准)
     */
     @ApiModelProperty(value = "下诊断科室名称(标准)")
      private String departmentNameStandard;

    /**
     * 下诊断科室编码(原始)
     */
     @ApiModelProperty(value = "下诊断科室编码(原始)")
      private String departmentCodeRaw;

    /**
     * 下诊断科室编码(标准)
     */
     @ApiModelProperty(value = "下诊断科室编码(标准)")
      private String departmentCodeStandard;

    /**
     * 下诊断医生编号
     */
     @ApiModelProperty(value = "下诊断医生编号")
      private String doctorCode;

    /**
     * 下诊断医生姓名
     */
     @ApiModelProperty(value = "下诊断医生姓名")
      private String doctorName;

    /**
     * 诊断时间
     */
     @ApiModelProperty(value = "诊断时间")
      private Date diagnosisTime;

    /**
     * 场景分类(原始)
     */
     @ApiModelProperty(value = "场景分类(原始)")
      private String sceneTypeRaw;

    /**
     * 场景分类(标准)
     */
     @ApiModelProperty(value = "场景分类(标准)")
      private String sceneTypeStandard;


     @ApiModelProperty(value = "诊断业务分类")
      private String relType;

    @ApiModelProperty(value = "诊断业务分类")
    private String relId;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String description;

    /**
     * 诊断编码(原始)
     */
     @ApiModelProperty(value = "诊断编码(原始)")
      private String diagnosisCodeRaw;

    /**
     * 诊断编码(标准)
     */
     @ApiModelProperty(value = "诊断编码(标准)")
      private String diagnosisCodeStandard;

    /**
     * 诊断内容(原始)
     */
     @ApiModelProperty(value = "诊断内容(原始)")
      private String diagnosisNameRaw;

    /**
     * 诊断内容(标准)
     */
     @ApiModelProperty(value = "诊断内容(标准)")
      private String diagnosisNameStandard;

    /**
     * 是否主诊断
     */
     @ApiModelProperty(value = "是否主诊断")
      private String mainFlag;

    /**
     * 是否确诊
     */
     @ApiModelProperty(value = "是否确诊")
      private String confirmFlag;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opDataUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;

    /**
     * 诊断排序
     */
     @ApiModelProperty(value = "诊断排序")
      private Integer sortIdx;


}
