package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;


/**
 * <p>
 * DWD出院信息表
 * </p>
 *
 * @author anros
 * @since 2023-11-01
 */
@Data
//@EqualsAndHashCode(callSuper = true)
public class DwdDischargeRecordInfo {

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
    private String patientId;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 就诊记录号
     */
    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    /**
     * 关联住院号
     */
    @ApiModelProperty(value = "关联住院号")
    private String inPatientNo;

    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    /**
     * 医院编号
     */
    @ApiModelProperty(value = "医院编号")
    private String companyCode;

    /**
     * 医院名称
     */
    @ApiModelProperty(value = "医院名称")
    private String companyName;

    /**
     * 入住科室名称(原始)
     */
    @ApiModelProperty(value = "入住科室名称(原始)")
    private String admitDepartmentNameRaw;

    /**
     * 入住科室名称(标准)
     */
    @ApiModelProperty(value = "入住科室名称(标准)")
    private String admitDepartmentNameStandard;

    /**
     * 入住科室编码(原始)
     */
    @ApiModelProperty(value = "入住科室编码(原始)")
    private String admitDepartmentCodeRaw;

    /**
     * 入住科室编码(标准)
     */
    @ApiModelProperty(value = "入住科室编码(标准)")
    private String admitDepartmentCodeStandard;


    @ApiModelProperty(value = "离住科室名称(原始)")
    private String outDepartmentNameRaw;

    @ApiModelProperty(value = "离住科室名称(标准)")
    private String outDepartmentNameStandard;


    @ApiModelProperty(value = "离住科室编码(原始)")
    private String outDepartmentCodeRaw;

    @ApiModelProperty(value = "离住科室编码(标准)")
    private String outDepartmentCodeStandard;


    /**
     * 出院时间
     */
    @ApiModelProperty(value = "出院时间")
    private Date leaveDate;

    /**
     * icu天数
     */
    @ApiModelProperty(value = "icu天数")
    private Integer icuDays;

    /**
     * 出院方式(原始)
     */
    @ApiModelProperty(value = "出院方式(原始)")
    private String leaveWayRaw;

    /**
     * 出院方式名称(原始)
     */
    @ApiModelProperty(value = "出院方式名称(原始)")
    private String leaveWayNameRaw;

    /**
     * 出院方式(标准)
     */
    @ApiModelProperty(value = "出院方式(标准)")
    private String leaveWayStandard;

    /**
     * 病情危重天数
     */
    @ApiModelProperty(value = "病情危重天数")
    private Integer emergencyTreatmentDays;

    /**
     * 出院小结(原始)
     * 放到出院小结表
     */
    // @ApiModelProperty(value = "出院小结(原始)")
    // private String contentRaw;

    /**
     * 出院小结(标准)
     * 放到出院小结表
     */
    // @ApiModelProperty(value = "出院小结(标准)")
    // private String contentStandard;

    /**
     * 诊断内容(原始)
     */
    @ApiModelProperty(value = "诊断内容(原始)")
    private String diagnosisRaw;

    /**
     * 诊断内容(标准)
     */
    @ApiModelProperty(value = "诊断内容(标准)")
    private String diagnosisStandard;

    /**
     * 诊断编码(标准)
     */
    @ApiModelProperty(value = "诊断编码(标准)")
    private String diagnosisCodeStandard;

    /**
     * 数据更新时间(原始)
     */
    @ApiModelProperty(value = "数据更新时间(原始)")
    private Date dataUpdateDate;

    /**
     * 操作人
     */
    @ApiModelProperty(value = "操作人")
    private String opDataUser;

    /**
     * 数据操作时间
     */
    @ApiModelProperty(value = "数据操作时间")
    private Date opDate;


}
