package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD检查报告单信息表
 * </p>
 *
 * @author anros
 * @since 2023-10-29
 */
@Data
public class DwdExamineReportInfo{

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * 报告ID
     */
     @ApiModelProperty(value = "报告ID")
      private String id;

    /**
     * 申请流水号
     */
     @ApiModelProperty(value = "申请流水号")
      private String applyId;

    /**
     * 就诊记录号
     */
     @ApiModelProperty(value = "就诊记录号")
      private String visitId;

    /**
     * 关联处方id
     */
     @ApiModelProperty(value = "关联处方id")
      private String recipeId;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inPatientNo;

    /**
     * 患者姓名
     */
     @ApiModelProperty(value = "患者姓名")
      private String patientName;

    /**
     * 患者电话
     */
     @ApiModelProperty(value = "患者电话")
      private String patientPhone;

    /**
     * 患者性别(原始)
     */
     @ApiModelProperty(value = "患者性别(原始)")
      private String patientGenderRaw;

    /**
     * 患者性别(标准)
     */
     @ApiModelProperty(value = "患者性别(标准)")
      private String patientGenderStandard;

    /**
     * 患者证件号
     */
     @ApiModelProperty(value = "患者证件号")
      private String patientCardNo;

    /**
     * 患者年龄
     */
     @ApiModelProperty(value = "患者年龄")
      private String patientAge;

    /**
     * 申请科室名称(原始)
     */
     @ApiModelProperty(value = "申请科室名称(原始)")
      private String departmentNameRaw;

    /**
     * 申请科室名称(标准)
     */
     @ApiModelProperty(value = "申请科室名称(标准)")
      private String departmentNameStandard;

    /**
     * 申请科室编码(原始)
     */
     @ApiModelProperty(value = "申请科室编码(原始)")
      private String departmentCodeRaw;

    /**
     * 申请科室编码(标准)
     */
     @ApiModelProperty(value = "申请科室编码(标准)")
      private String departmentCodeStandard;

    /**
     * 报告时间
     */
     @ApiModelProperty(value = "报告时间")
      private Date reportsTime;

    /**
     * 申请时间
     */
     @ApiModelProperty(value = "申请时间")
      private Date applyTime;

    /**
     * 检查时间
     */
     @ApiModelProperty(value = "检查时间")
      private Date inspectTime;

    /**
     * 场景分类(原始)
     */
     @ApiModelProperty(value = "场景分类(原始)")
      private String sceneTypeRaw;

    /**
     * 场景分类(标准)
     */
     @ApiModelProperty(value = "场景分类(标准)")
      private String sceneTypeStandard;

    /**
     * 申请医生编号
     */
     @ApiModelProperty(value = "申请医生编号")
      private String applyDoctorCode;

    /**
     * 申请医生姓名
     */
     @ApiModelProperty(value = "申请医生姓名")
      private String applyDoctorName;

    /**
     * 报告医生编号
     */
     @ApiModelProperty(value = "报告医生编号")
      private String doctorCode;

    /**
     * 报告医生姓名
     */
     @ApiModelProperty(value = "报告医生姓名")
      private String doctorName;

    /**
     * 检查类别(原始)
     */
     @ApiModelProperty(value = "检查类别(原始)")
      private String examineTypeRaw;

    /**
     * 检查类别(标准)
     */
     @ApiModelProperty(value = "检查类别(标准)")
      private String examineTypeStandard;

    /**
     * 报告名称(原始)
     */
     @ApiModelProperty(value = "报告名称(原始)")
      private String reportNameRaw;

    /**
     * 报告名称(标准)
     */
     @ApiModelProperty(value = "报告名称(标准)")
      private String reportNameStandard;

    /**
     * 检查部位名称(原始)
     */
     @ApiModelProperty(value = "检查部位名称(原始)")
      private String bodyPartNameRaw;

    /**
     * 检查部位名称(标准)
     */
     @ApiModelProperty(value = "检查部位名称(标准)")
      private String bodyPartNameStandard;

    /**
     * 检查部位编号(原始)
     */
     @ApiModelProperty(value = "检查部位编号(原始)")
      private String bodyPartCodeRaw;

    /**
     * 检查部位编号(标准)
     */
     @ApiModelProperty(value = "检查部位编号(标准)")
      private String bodyPartCodeStandard;

    /**
     * 检查所见(原始)
     */
     @ApiModelProperty(value = "检查所见(原始)")
      private String reportDescriptionRaw;

    /**
     * 检查所见(标准)
     */
     @ApiModelProperty(value = "检查所见(标准)")
      private String reportDescriptionStandard;

    /**
     * 检查结果(原始)
     */
     @ApiModelProperty(value = "检查结果(原始)")
      private String reportResultRaw;

    /**
     * 检查结果(标准)
     */
     @ApiModelProperty(value = "检查结果(标准)")
      private String reportResultStandard;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opDataUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;

    /**
     * 报告路径
     */
     @ApiModelProperty(value = "报告路径")
      private String reportPath;

    /**
     * 影象报告编号
     */
     @ApiModelProperty(value = "影象报告编号")
      private String reportNo;

    /**
     * 活动编号
     */
     @ApiModelProperty(value = "活动编号")
      private String activityNo;

}
