package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD住院信息表
 * </p>
 *
 * @author anros
 * @since 2023-10-29
 */
@Data
public class DwdInpatientRecordInfo{

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * 住院流水号
     */
     @ApiModelProperty(value = "住院流水号")
      private String id;

    /**
     * 就诊记录号
     */
     @ApiModelProperty(value = "就诊记录号")
      private String visitId;

    /**
     * 关联住院号
     */
     @ApiModelProperty(value = "关联住院号")
      private String inPatientNo;

    /**
     * 患者姓名
     */
     @ApiModelProperty(value = "患者姓名")
      private String patientName;

    /**
     * 医院编号
     */
     @ApiModelProperty(value = "医院编号")
      private String companyCode;

    /**
     * 医院名称
     */
     @ApiModelProperty(value = "医院名称")
      private String companyName;

    /**
     * 入住科室名称(原始)
     */
     @ApiModelProperty(value = "入住科室名称(原始)")
      private String admitDepartmentNameRaw;

    /**
     * 入住科室名称(标准)
     */
     @ApiModelProperty(value = "入住科室名称(标准)")
      private String admitDepartmentNameStandard;

    /**
     * 入住科室编码(原始)
     */
     @ApiModelProperty(value = "入住科室编码(原始)")
      private String admitDepartmentCodeRaw;

    /**
     * 入住科室编码(标准)
     */
     @ApiModelProperty(value = "入住科室编码(标准)")
      private String admitDepartmentCodeStandard;

    /**
     * 入住时间
     */
     @ApiModelProperty(value = "入住时间")
      private Date inpatientDate;

    /**
     * 入住病区
     */
     @ApiModelProperty(value = "入住病区")
      private String inpatientWard;

    /**
     * 床号
     */
     @ApiModelProperty(value = "床号")
      private String bedNumber;

    /**
     * 入院方式(原始)
     */
     @ApiModelProperty(value = "入院方式(原始)")
      private String enterWayRaw;

    /**
     * 入院方式(标准)
     */
     @ApiModelProperty(value = "入院方式(标准)")
      private String enterWayStandard;

    /**
     * 预约时间
     */
     @ApiModelProperty(value = "预约时间")
      private Date bookDate;

    /**
     * 住院状态(原始)
     */
     @ApiModelProperty(value = "住院状态(原始)")
      private String statusRaw;

    /**
     * 住院状态(标准)
     */
     @ApiModelProperty(value = "住院状态(标准)")
      private String statusStandard;

    /**
     * 入院诊断内容(原始)
     */
     @ApiModelProperty(value = "入院诊断内容(原始)")
      private String diagnosisRaw;

    /**
     * 入院诊断内容(标准)
     */
     @ApiModelProperty(value = "入院诊断内容(标准)")
      private String diagnosisStandard;

    /**
     * 入院诊断编码(标准)
     */
     @ApiModelProperty(value = "入院诊断编码(标准)")
      private String diagnosisCodeStandard;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opDataUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;

    /**
     * 管床医生编号
     */
     @ApiModelProperty(value = "管床医生编号")
      private String doctorCode;

    /**
     * 管床医生名称
     */
     @ApiModelProperty(value = "管床医生名称")
      private String doctorName;


}
