package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD检验申请单项目信息表
 * </p>
 *
 * @author anros
 * @since 2023-10-29
 */
@Data
public class DwdLaboratoryApplyProjectInfo{

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * 检验申请单ID
     */
     @ApiModelProperty(value = "检验申请单ID")
      private String laboratoryApplyId;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 组套编号(原始)
     */
     @ApiModelProperty(value = "组套编号(原始)")
      private String itemGroupCodeRaw;

    /**
     * 组套编号(标准)
     */
     @ApiModelProperty(value = "组套编号(标准)")
      private String itemGroupCodeStandard;

    /**
     * 组套名称(原始)
     */
     @ApiModelProperty(value = "组套名称(原始)")
      private String itemGroupNameRaw;

    /**
     * 组套名称(标准)
     */
     @ApiModelProperty(value = "组套名称(标准)")
      private String itemGroupNameStandard;

    /**
     * 项目编号(原始)
     */
     @ApiModelProperty(value = "项目编号(原始)")
      private String itemCodeRaw;

    /**
     * 项目编号(标准)
     */
     @ApiModelProperty(value = "项目编号(标准)")
      private String itemCodeStandard;

    /**
     * 项目名称(原始)
     */
     @ApiModelProperty(value = "项目名称(原始)")
      private String itemNameRaw;

    /**
     * 项目名称(标准)
     */
     @ApiModelProperty(value = "项目名称(标准)")
      private String itemNameStandard;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opDataUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;


}
