package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD手术记录明细信息表
 * </p>
 *
 * @author anros
 * @since 2023-11-01
 */
@Data
//@EqualsAndHashCode(callSuper = true)
public class DwdOperationRecordItemInfo {

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 手术记录数据ID
     */
     @ApiModelProperty(value = "手术记录数据ID")
      private String operationRecordId;

    /**
     * 手术编码(原始)
     */
     @ApiModelProperty(value = "手术编码(原始)")
      private String codeRaw;

    /**
     * 手术编码(标准)
     */
     @ApiModelProperty(value = "手术编码(标准)")
      private String codeStandard;

    /**
     * 手术名称(原始)
     */
     @ApiModelProperty(value = "手术名称(原始)")
      private String nameRaw;

    /**
     * 手术名称(标准)
     */
     @ApiModelProperty(value = "手术名称(标准)")
      private String nameStandard;

    /**
     * 预计手术时长
     */
     @ApiModelProperty(value = "预计手术时长")
      private String estOptDuration;

    /**
     * 手术类别(原始)
     */
     @ApiModelProperty(value = "手术类别(原始)")
      private String operationTypeRaw;

    /**
     * 手术类别(标准)
     */
     @ApiModelProperty(value = "手术类别(标准)")
      private String operationTypeStandard;

    /**
     * 手术等级(原始)
     */
     @ApiModelProperty(value = "手术等级(原始)")
      private String operationLevelRaw;

    /**
     * 手术等级(标准)
     */
     @ApiModelProperty(value = "手术等级(标准)")
      private String operationLevelStandard;

    /**
     * 麻醉方法(原始)
     */
     @ApiModelProperty(value = "麻醉方法(原始)")
      private String anaesthesiaMethodRaw;

    /**
     * 麻醉方法(标准)
     */
     @ApiModelProperty(value = "麻醉方法(标准)")
      private String anaesthesiaMethodStandard;

    /**
     * 手术医生编码
     */
     @ApiModelProperty(value = "手术医生编码")
      private String operationDoctorCode;

    /**
     * 手术医生姓名
     */
     @ApiModelProperty(value = "手术医生姓名")
      private String operationDoctorName;

    /**
     * 实际手术开始时间
     */
     @ApiModelProperty(value = "实际手术开始时间")
      private String actStartTime;

    /**
     * 实际手术结束时间
     */
     @ApiModelProperty(value = "实际手术结束时间")
      private String actEndTime;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opDataUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;


}
