package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiImplicitParam;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD电子病例体格检查基础检查
 * </p>
 */
@Data
public class DwdPatientEmrBodyCheckBasicInfo{

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 电子病例ID
     */
     @ApiModelProperty(value = "电子病例ID")
      private String emrId;

    /**
     * 身高
     */
     @ApiModelProperty(value = "身高")
      private String height;

    @ApiModelProperty(value = "身高标准")
     private Float heightStandard;

    /**
     * 体重
     */
     @ApiModelProperty(value = "体重")
      private String weight;

     @ApiModelProperty(value = "体重标准")
     private Float weightStandard;

    /**
     * 血压
     */
     @ApiModelProperty(value = "血压")
      private String bloodPressure;

    @ApiModelProperty(value = "血压高压标准")
     private Float bloodPressureHigh;

    @ApiModelProperty("血压低压标准")
    private Float bloodPressureLow;

    /**
     * 心率
     */
     @ApiModelProperty(value = "心率")
      private String heartRate;

    @ApiModelProperty(value = "心率标准")
     private Float heartRateStandard;
    /**
     * 体温
     */
     @ApiModelProperty(value = "体温")
      private String temperature;

     @ApiModelProperty(value = "体温标准")
     private Float temperatureStandard;

    /**
     * BMI
     */
     @ApiModelProperty(value = "BMI")
      private String bmi;

    @ApiModelProperty(value = "BMI标准")
     private Float bmiStandard;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;


}
