package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD电子病例症状表
 * </p>
 *
 * @author anros
 * @since 2025-01-09
 */
@Data
public class DwdPatientEmrSymptomInfo{

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 电子病例ID
     */
     @ApiModelProperty(value = "电子病例ID")
      private String emrId;

    /**
     * 分类
     */
     @ApiModelProperty(value = "分类")
      private String type;

    /**
     * 名称
     */
     @ApiModelProperty(value = "名称")
      private String name;

    /**
     * 部位
     */
     @ApiModelProperty(value = "部位")
      private String bodyPart;

    /**
     * 程度
     */
     @ApiModelProperty(value = "程度")
      private String degree;

    /**
     * 持续时间
     */
     @ApiModelProperty(value = "持续时间")
      private String durationTime;

    /**
     * 单次时间
     */
     @ApiModelProperty(value = "单次时间")
      private String oneTime;

    /**
     * 标准名称
     */
     @ApiModelProperty(value = "标准名称")
      private String nameStandard;

    /**
     * 标准部位
     */
     @ApiModelProperty(value = "标准部位")
      private String bodyPartStandard;

    /**
     * 标准程度
     */
     @ApiModelProperty(value = "标准程度")
      private String degreeStandard;

    /**
     * 标准持续时间
     */
     @ApiModelProperty(value = "标准持续时间")
      private String durationTimeStandard;


     @ApiModelProperty(value = "标准持续时间单位")
     private String durationTimeUnitStandard;

    /**
     * 标准单次时间
     */
     @ApiModelProperty(value = "标准单次时间")
      private String oneTimeStandard;


    @ApiModelProperty(value = "标准单次时间单位")
    private String oneTimeUnitStandard;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;


}
