package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD医嘱用药数据表
 * </p>
 *
 * @author anros
 * @since 2023-10-29
 */
@Data
public class DwdRecipeMedicineInfo  {

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * ID
     */
     @ApiModelProperty(value = "ID")
      private String id;

    /**
     * 就诊记录号
     */
     @ApiModelProperty(value = "就诊记录号")
      private String visitId;

    /**
     * 关联处方id
     */
     @ApiModelProperty(value = "关联处方id")
      private String recipeId;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inPatientNo;

    /**
     * 患者姓名
     */
     @ApiModelProperty(value = "患者姓名")
      private String patientName;

    /**
     * 申请科室名称(原始)
     */
     @ApiModelProperty(value = "申请科室名称(原始)")
      private String departmentNameRaw;

    /**
     * 申请科室名称(标准)
     */
     @ApiModelProperty(value = "申请科室名称(标准)")
      private String departmentNameStandard;

    /**
     * 申请科室编码(原始)
     */
     @ApiModelProperty(value = "申请科室编码(原始)")
      private String departmentCodeRaw;

    /**
     * 申请科室编码(标准)
     */
     @ApiModelProperty(value = "申请科室编码(标准)")
      private String departmentCodeStandard;

    /**
     * 付费时间
     */
     @ApiModelProperty(value = "付费时间")
      private Date payTime;

    /**
     * 处方时间
     */
     @ApiModelProperty(value = "处方时间")
      private Date recipeTime;

    /**
     * 场景分类(原始)
     */
     @ApiModelProperty(value = "场景分类(原始)")
      private String sceneTypeRaw;

    /**
     * 场景分类(标准)
     */
     @ApiModelProperty(value = "场景分类(标准)")
      private String sceneTypeStandard;

    /**
     * 申请医生编号
     */
     @ApiModelProperty(value = "申请医生编号")
      private String doctorCode;

    /**
     * 申请医生姓名
     */
     @ApiModelProperty(value = "申请医生姓名")
      private String doctorName;

    /**
     * 备注
     */
     @ApiModelProperty(value = "备注")
      private String description;

    /**
     * 诊断编码(标准)
     */
     @ApiModelProperty(value = "诊断编码(标准)")
      private String diagnosisCodeStandard;

    /**
     * 诊断内容(原始)
     */
     @ApiModelProperty(value = "诊断内容(原始)")
      private String diagnosisRaw;

    /**
     * 诊断内容(标准)
     */
     @ApiModelProperty(value = "诊断内容(标准)")
      private String diagnosisStandard;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opDataUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;


}
