package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD病理报告单数据
 * </p>
 *
 * @author anros
 * @since 2023-09-07
 */
@Deprecated
@Data
public class DwdRecipePathologyReportInfo {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
    @TableId(value = "id", type = IdType.INPUT)
      private String id;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
      private String patientId;

    /**
     * 就诊记录号
     */
     @ApiModelProperty(value = "就诊记录号")
      private String visitId;

    /**
     * 关联处方id
     */
     @ApiModelProperty(value = "关联处方id")
      private String recipeId;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inPatientNo;

    /**
     * 患者姓名
     */
     @ApiModelProperty(value = "患者姓名")
      private String patientName;

    /**
     * 申请科室名称(原始)
     */
     @ApiModelProperty(value = "申请科室名称(原始)")
      private String departmentNameRaw;

    /**
     * 申请科室名称(标准)
     */
     @ApiModelProperty(value = "申请科室名称(标准)")
      private String departmentNameStandard;

    /**
     * 申请科室编码(原始)
     */
     @ApiModelProperty(value = "申请科室编码(原始)")
      private String departmentCodeRaw;

    /**
     * 申请科室编码(标准)
     */
     @ApiModelProperty(value = "申请科室编码(标准)")
      private String departmentCodeStandard;

    /**
     * 报告时间
     */
     @ApiModelProperty(value = "报告时间")
      private Date reportsTime;

    /**
     * 样本送检时间
     */
     @ApiModelProperty(value = "样本送检时间")
      private Date deliveryTime;

    /**
     * 样本接收时间
     */
     @ApiModelProperty(value = "样本接收时间")
      private Date collectTime;

    /**
     * 申请时间
     */
     @ApiModelProperty(value = "申请时间")
      private Date applyTime;

    /**
     * 检查时间
     */
     @ApiModelProperty(value = "检查时间")
      private Date inspectTime;

    /**
     * 场景分类(原始)
     */
     @ApiModelProperty(value = "场景分类(原始)")
      private String typeRaw;

    /**
     * 场景分类(标准)
     */
     @ApiModelProperty(value = "场景分类(标准)")
      private String typeStandard;

    /**
     * 申请医生编号
     */
     @ApiModelProperty(value = "申请医生编号")
      private String applyDoctorCode;

    /**
     * 申请医生姓名
     */
     @ApiModelProperty(value = "申请医生姓名")
      private String applyDoctorName;

    /**
     * 报告医生编号
     */
     @ApiModelProperty(value = "报告医生编号")
      private String doctorCode;

    /**
     * 报告医生姓名
     */
     @ApiModelProperty(value = "报告医生姓名")
      private String doctorName;

    /**
     * 检查类别(原始)
     */
     @ApiModelProperty(value = "检查类别(原始)")
      private String examineTypeRaw;

    /**
     * 检查类别(标准)
     */
     @ApiModelProperty(value = "检查类别(标准)")
      private String examineTypeStandard;

    /**
     * 报告名称(原始)
     */
     @ApiModelProperty(value = "报告名称(原始)")
      private String reportNameRaw;

    /**
     * 报告名称(标准)
     */
     @ApiModelProperty(value = "报告名称(标准)")
      private String reportNameStandard;

    /**
     * 检查部位(原始)
     */
     @ApiModelProperty(value = "检查部位(原始)")
      private String bodyPartNameRaw;

    /**
     * 检查部位(标准)
     */
     @ApiModelProperty(value = "检查部位(标准)")
      private String bodyPartNameStandard;

    /**
     * 检查部位编号(原始)
     */
     @ApiModelProperty(value = "检查部位编号(原始)")
      private String bodyPartCodeRaw;

    /**
     * 检查部位编号(标准)
     */
     @ApiModelProperty(value = "检查部位编号(标准)")
      private String bodyPartCodeStandard;

    /**
     * 标本描述
     */
     @ApiModelProperty(value = "标本描述")
      private String specimenDescription;

    /**
     * 标本满意度
     */
     @ApiModelProperty(value = "标本满意度")
      private String specimenStatus;

    /**
     * 报告描述
     */
     @ApiModelProperty(value = "报告描述")
      private String description;

    /**
     * 初步结论
     */
     @ApiModelProperty(value = "初步结论")
      private String conclusion;

    /**
     * 病理诊断编码(原始)
     */
     @ApiModelProperty(value = "病理诊断编码(原始)")
      private String diagnosisCodeRaw;

    /**
     * 病理诊断编码(标准)
     */
     @ApiModelProperty(value = "病理诊断编码(标准)")
      private String diagnosisCodeStandard;

    /**
     * 病理诊断项目内容(原始)
     */
     @ApiModelProperty(value = "病理诊断项目内容(原始)")
      private String diagnosisNameRaw;

    /**
     * 病理诊断项目内容(标准)
     */
     @ApiModelProperty(value = "病理诊断项目内容(标准)")
      private String diagnosisNameStandard;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;


}
