package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD治疗明细表
 * </p>
 *
 * @author anros
 * @since 2023-11-01
 */
@Data
//@EqualsAndHashCode(callSuper = true)
public class DwdRecipeTherapyItemInfo {

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * id
     */
     @ApiModelProperty(value = "id")
      private String id;

    /**
     * 治疗ID
     */
     @ApiModelProperty(value = "治疗ID")
      private String therapyId;

    /**
     * 就诊记录号
     */
     @ApiModelProperty(value = "就诊记录号")
      private String visitId;

    /**
     * 挂号住院号
     */
     @ApiModelProperty(value = "挂号住院号")
      private String regInId;

    /**
     * 关联处方id
     */
     @ApiModelProperty(value = "关联处方id")
      private String recipeId;

    /**
     * 住院号
     */
     @ApiModelProperty(value = "住院号")
      private String inPatientNo;

    /**
     * 患者姓名
     */
     @ApiModelProperty(value = "患者姓名")
      private String patientName;

    /**
     * 申请科室名称(原始)
     */
     @ApiModelProperty(value = "申请科室名称(原始)")
      private String departmentNameRaw;

    /**
     * 申请科室编码(原始)
     */
     @ApiModelProperty(value = "申请科室编码(原始)")
      private String departmentCodeRaw;

    /**
     * 申请科室名称(标准)
     */
     @ApiModelProperty(value = "申请科室名称(标准)")
      private String departmentNameStandard;

    /**
     * 申请科室编码(标准)
     */
     @ApiModelProperty(value = "申请科室编码(标准)")
      private String departmentCodeStandard;

    /**
     * 申请医生编号
     */
     @ApiModelProperty(value = "申请医生编号")
      private String doctorCode;

    /**
     * 申请医生姓名
     */
     @ApiModelProperty(value = "申请医生姓名")
      private String doctorName;

    /**
     * 付费时间
     */
     @ApiModelProperty(value = "付费时间")
      private Date payTime;

    /**
     * 处方时间
     */
     @ApiModelProperty(value = "处方时间")
      private Date recipeTime;

    /**
     * 项目名称(原始)
     */
     @ApiModelProperty(value = "项目名称(原始)")
      private String nameRaw;

    /**
     * 项目名称(标准)
     */
     @ApiModelProperty(value = "项目名称(标准)")
      private String nameStandard;

    /**
     * 项目编码(原始)
     */
     @ApiModelProperty(value = "项目编码(原始)")
      private String codeRaw;

    /**
     * 项目编码(标准)
     */
     @ApiModelProperty(value = "项目编码(标准)")
      private String codeStandard;

    /**
     * 父关联处方id
     */
     @ApiModelProperty(value = "父关联处方id")
      private String parentRecipeId;

    /**
     * 状态(原始)
     */
     @ApiModelProperty(value = "状态(原始)")
      private String statusRaw;

    /**
     * 状态(标准)
     */
     @ApiModelProperty(value = "状态(标准)")
      private String statusStandard;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opDataUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;


}
