package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD挂号信息表
 * </p>
 *
 * @author anros
 * @since 2023-10-29
 */
@Data
public class DwdRegisterRecordInfo  {

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * 挂号ID
     */
     @ApiModelProperty(value = "挂号ID")
      private String id;

    /**
     * 患者姓名
     */
     @ApiModelProperty(value = "患者姓名")
      private String patientName;

    /**
     * 卡号类型(原始)
     */
     @ApiModelProperty(value = "卡号类型(原始)")
      private String cardTypeRaw;

    /**
     * 卡号类型(标准)
     */
     @ApiModelProperty(value = "卡号类型(标准)")
      private String cardTypeStandard;

    /**
     * 证件号
     */
     @ApiModelProperty(value = "证件号")
      private String cardNo;

    /**
     * 就诊记录号
     */
     @ApiModelProperty(value = "就诊记录号")
      private String visitId;

    /**
     * 就诊卡号
     */
     @ApiModelProperty(value = "就诊卡号")
      private String visitCardNo;

    /**
     * 医院名称
     */
     @ApiModelProperty(value = "医院名称")
      private String companyName;

    /**
     * 医院编号
     */
     @ApiModelProperty(value = "医院编号")
      private String companyCode;

    /**
     * 挂号科室名称(原始)
     */
     @ApiModelProperty(value = "挂号科室名称(原始)")
      private String departmentNameRaw;

    /**
     * 挂号科室名称(标准)
     */
     @ApiModelProperty(value = "挂号科室名称(标准)")
      private String departmentNameStandard;

    /**
     * 挂号科室编码(原始)
     */
     @ApiModelProperty(value = "挂号科室编码(原始)")
      private String departmentCodeRaw;

    /**
     * 挂号科室编码(标准)
     */
     @ApiModelProperty(value = "挂号科室编码(标准)")
      private String departmentCodeStandard;

    /**
     * 挂号医生编号
     */
     @ApiModelProperty(value = "挂号医生编号")
      private String doctorCode;

    /**
     * 挂号医生姓名
     */
     @ApiModelProperty(value = "挂号医生姓名")
      private String doctorName;

    /**
     * 挂号级别编号(原始)
     */
     @ApiModelProperty(value = "挂号级别编号(原始)")
      private String regLevelCodeRaw;

    /**
     * 挂号级别名称(原始)
     */
     @ApiModelProperty(value = "挂号级别名称(原始)")
      private String regLevelNameRaw;

    /**
     * 挂号级别编号(标准)
     */
     @ApiModelProperty(value = "挂号级别编号(标准)")
      private String regLevelCodeStandard;

    /**
     * 挂号方式(原始)
     */
     @ApiModelProperty(value = "挂号方式(原始)")
      private String regWayRaw;

    /**
     * 挂号方式(标准)
     */
     @ApiModelProperty(value = "挂号方式(标准)")
      private String regWayStandard;

    /**
     * 挂号时间
     */
     @ApiModelProperty(value = "挂号时间")
      private Date regDate;

    /**
     * 初诊复诊分类
     */
     @ApiModelProperty(value = "初诊复诊分类")
      private String firstSubType;

    /**
     * 预约时间
     */
     @ApiModelProperty(value = "预约时间")
      private Date reserveDate;

    /**
     * 预约方式(原始)
     */
     @ApiModelProperty(value = "预约方式(原始)")
      private String reserveWayRaw;

    /**
     * 预约方式(标准)
     */
     @ApiModelProperty(value = "预约方式(标准)")
      private String reserveWayStandard;

    /**
     * 场景分类(原始)
     */
     @ApiModelProperty(value = "场景分类(原始)")
      private String sceneTypeRaw;

    /**
     * 场景分类(标准)
     */
     @ApiModelProperty(value = "场景分类(标准)")
      private String sceneTypeStandard;

    /**
     * 就诊状态(原始)
     */
     @ApiModelProperty(value = "就诊状态(原始)")
      private String visitStatusRaw;

    /**
     * 就诊状态(标准)
     */
     @ApiModelProperty(value = "就诊状态(标准)")
      private String visitStatusStandard;

    /**
     * 就诊时间
     */
     @ApiModelProperty(value = "就诊时间")
      private Date visitDate;

    /**
     * 挂号状态(原始)
     */
     @ApiModelProperty(value = "挂号状态(原始)")
      private String statusRaw;

    /**
     * 挂号状态(标准)
     */
     @ApiModelProperty(value = "挂号状态(标准)")
      private String statusStandard;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opDataUser;

    /**
     * 数据操作时间
     */
     @ApiModelProperty(value = "数据操作时间")
      private Date opDate;


}
