package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import java.util.Date;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD就诊信息表
 * </p>
 *
 * @author anros
 * @since 2023-10-29
 */
@Data
public class DwdVisitRecordInfo  {

    private static final long serialVersionUID = 1L;

    /**
     * 患者编号
     */
     @ApiModelProperty(value = "患者编号")
    @TableId(value = "patient_id", type = IdType.INPUT)
      private String patientId;

    /**
     * 就诊记录号
     */
     @ApiModelProperty(value = "就诊记录号")
      private String id;

    /**
     * 挂号ID
     */
     @ApiModelProperty(value = "挂号ID")
      private String registerId;

    /**
     * 患者姓名
     */
     @ApiModelProperty(value = "患者姓名")
      private String patientName;

    /**
     * 卡号类型(原始)
     */
     @ApiModelProperty(value = "卡号类型(原始)")
      private String cardTypeRaw;

    /**
     * 卡号类型(标准)
     */
     @ApiModelProperty(value = "卡号类型(标准)")
      private String cardTypeStandard;

    /**
     * 卡号
     */
     @ApiModelProperty(value = "卡号")
      private String cardNo;

    /**
     * 患者性别(原始)
     */
     @ApiModelProperty(value = "患者性别(原始)")
      private String patientGenderRaw;

    /**
     * 患者性别(标准)
     */
     @ApiModelProperty(value = "患者性别(标准)")
      private String patientGenderStandard;

    /**
     * 患者年龄
     */
     @ApiModelProperty(value = "患者年龄")
      private String patientAge;

    /**
     * 医院名称
     */
     @ApiModelProperty(value = "医院名称")
      private String companyName;

    /**
     * 医院编号
     */
     @ApiModelProperty(value = "医院编号")
      private String companyCode;

    /**
     * 科室名称(原始)
     */
     @ApiModelProperty(value = "科室名称(原始)")
      private String departmentNameRaw;

    /**
     * 科室名称(标准)
     */
     @ApiModelProperty(value = "科室名称(标准)")
      private String departmentNameStandard;

    /**
     * 科室编码(原始)
     */
     @ApiModelProperty(value = "科室编码(原始)")
      private String departmentCodeRaw;

    /**
     * 标准科室编码
     */
     @ApiModelProperty(value = "标准科室编码")
      private String departmentCodeStandard;

    /**
     * 医生编号
     */
     @ApiModelProperty(value = "医生编号")
      private String doctorCode;

    /**
     * 医生姓名
     */
     @ApiModelProperty(value = "医生姓名")
      private String doctorName;

    /**
     * 就诊时间
     */
     @ApiModelProperty(value = "就诊时间")
      private Date visitDate;

    /**
     * 就诊类型(原始)
     */
     @ApiModelProperty(value = "就诊类型(原始)")
      private String visitTypeRaw;

    /**
     * 就诊类型(标准)
     */
     @ApiModelProperty(value = "就诊类型(标准)")
      private String visitTypeStandard;

    /**
     * 就诊方式(原始)
     */
     @ApiModelProperty(value = "就诊方式(原始)")
      private String visitWayRaw;

    /**
     * 就诊方式(标准)
     */
     @ApiModelProperty(value = "就诊方式(标准)")
      private String visitWayStandard;

    /**
     * 场景分类(原始)
     */
     @ApiModelProperty(value = "场景分类(原始)")
      private String sceneTypeRaw;

    /**
     * 场景分类(标准)
     */
     @ApiModelProperty(value = "场景分类(标准)")
      private String sceneTypeStandard;

    /**
     * 状态编号(原始)
     */
     @ApiModelProperty(value = "状态编号(原始)")
      private String statusRaw;

    /**
     * 状态编号(标准)
     */
     @ApiModelProperty(value = "状态编号(标准)")
      private String statusStandard;

    /**
     * 状态名称(原始)
     */
     @ApiModelProperty(value = "状态名称(原始)")
      private String statusNameRaw;

    /**
     * 数据更新时间(原始)
     */
     @ApiModelProperty(value = "数据更新时间(原始)")
      private Date dataUpdateDate;

    /**
     * 操作时间
     */
     @ApiModelProperty(value = "操作时间")
      private Date opDate;

    /**
     * 操作人
     */
     @ApiModelProperty(value = "操作人")
      private String opDataUser;


}
