package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.entity.BasePageDTO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class DwdDiagnosisReportQueryDTO extends BasePageDTO {

    @ApiModelProperty(value = "患者id")
    private String patientId;

    @ApiModelProperty(value = "患者id列表")
    private List<String> patientIds;

    @ApiModelProperty(value = "就诊id")
    private String visitId;

    @ApiModelProperty(value = "就诊id列表")
    private List<String> visitIds;

    @ApiModelProperty(value = "开始时间")
    private Date startDate;

    @ApiModelProperty(value = "结束时间")
    private Date endDate;

    /**
     * 场景分类(原始)
     * cyzd：出院诊断
     * ryzd：入院诊断
     * mzzd：门诊诊断
     * bczd：
     * cbzd：
     * xzzd：
     * swzd：
     */
    @ApiModelProperty(value = "场景分类(原始)")
    private String sceneTypeRaw;

    @ApiModelProperty(value = "场景分类(原始)列表")
    private List<String> sceneTypeRaws;

    /**
     * 场景分类(标准)
     */
    @ApiModelProperty(value = "场景分类(标准)")
    private String sceneTypeStandard;

    @ApiModelProperty(value = "场景分类(标准)列表")
    private List<String> sceneTypeStandards;

    @ApiModelProperty(value = "诊断排序（1为主诊断）")
    private Integer sortIdx;

    @ApiModelProperty(value = "多诊断排序（1为主诊断）")
    private List<Integer> sortIdxs;

}
