package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto;

import java.util.List;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * ODS体检患者信息表
 * </p>
 */
@Getter
@Setter
public class DwdExaminationPatientQueryDTO  {

    @ApiModelProperty(value = "体检记录号")
    private String visitId;

    @ApiModelProperty(value = "体检记录号列表")
    private List<String> visitIds;

    /**
     * 主客户ID
     */
    @ApiModelProperty(value = "主客户ID")
    private String mainPersonId;

    /**
     * 主客户ID列表
     */
    @ApiModelProperty(value = "主客户ID列表")
    private List<String> mainPersonIds;

    /**
     * 体检者姓名
     */
    @ApiModelProperty(value = "体检者姓名")
    private String patientName;

    /**
     * 性别
     */
    @ApiModelProperty(value = "性别")
    private String sex;

    /**
     * 身份证号
     */
    @ApiModelProperty(value = "身份证号")
    private String idCard;

    @ApiModelProperty(value = "身份证号列表")
    private List<String> idCards;

    /**
     * 查询开始时间
     */
    @ApiModelProperty(value = "查询开始时间")
    private String startDate;

    /**
     * 查询结束时间
     */
    @ApiModelProperty(value = "查询结束时间")
    private String endDate;

    @ApiModelProperty(value = "数据类型[DwdConstant.DataTypeEnum]")
    private String dataType;

}
