package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo;

import java.util.Date;
import java.util.List;

import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD体检患者信息表
 * </p>
 */
@Data
public class DwdExaminationPatientVO  {

    /**
     * 体检记录号
     */
    @ApiModelProperty(value = "体检记录号")
    private String visitId;

    /**
     * 体检者姓名
     */
    @ApiModelProperty(value = "体检者姓名")
    private String patientName;

    /**
     * 性别
     */
    @ApiModelProperty(value = "性别")
    private String sex;

    /**
     * 生日
     */
    @ApiModelProperty(value = "生日")
    private Date birthDay;

    /**
     * 身份证号
     */
    @ApiModelProperty(value = "身份证号")
    private String idCard;

    /**
     * 数据创建时间
     */
    @ApiModelProperty(value = "数据创建时间")
    private Date dataCreateDate;

    /**
     * 数据更新时间
     */
    @ApiModelProperty(value = "数据更新时间")
    private Date dataUpdateDate;

    /**
     * 数据操作人
     */
    @ApiModelProperty(value = "数据操作人")
    private String opDataUser;

    /**
     * 数据操作时间
     */
    @ApiModelProperty(value = "数据操作时间")
    private Date opDate;


    // 体检登记信息
    @ApiModelProperty(value = "检查报告单")
    private OdsExaminationRegisterVO odsExaminationRegisterVO;
    // 体检报告信息
    @ApiModelProperty(value = "检查报告单")
    private OdsExaminationReportResultVO odsExaminationReportResultVO;
    // 体检总检验报告信息
    @ApiModelProperty(value = "检查报告单")
    private OdsExaminationFinalReportVO odsExaminationFinalReportVO;


    // 报告
    @ApiModelProperty(value = "检查报告单")
    private List<DwdExamineReportVO> dwdExamineReportVOs;
    @ApiModelProperty(value = "检验报告单")
    private List<DwdLaboratoryReportVO> dwdLaboratoryReportVOs;

}
