package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo;

import java.util.Date;
import java.util.List;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

// DWD检查申请单信息表
@Getter
@Setter
public class DwdExamineApplyVO {

  /**
   * 患者编号
   */
  @ApiModelProperty(value = "患者编号")
  private String patientId;

    /**
     * 检查申请单流水号
     */
    @ApiModelProperty(value = "检查申请单流水号")
    private String id;

  /**
   * 就诊记录号
   */
   @ApiModelProperty(value = "就诊记录号")
    private String visitId;

  /**
   * 住院号
   */
   @ApiModelProperty(value = "住院号")
    private String inPatientNo;

  /**
   * 关联处方id
   */
   @ApiModelProperty(value = "关联处方id")
    private String recipeId;

  /**
   * 患者姓名
   */
   @ApiModelProperty(value = "患者姓名")
    private String patientName;

  /**
   * 申请科室名称(原始)
   */
   @ApiModelProperty(value = "申请科室名称(原始)")
    private String departmentNameRaw;

  /**
   * 申请科室名称(标准)
   */
   @ApiModelProperty(value = "申请科室名称(标准)")
    private String departmentNameStandard;

  /**
   * 申请科室编码(原始)
   */
   @ApiModelProperty(value = "申请科室编码(原始)")
    private String departmentCodeRaw;

  /**
   * 申请科室编码(标准)
   */
   @ApiModelProperty(value = "申请科室编码(标准)")
    private String departmentCodeStandard;

  /**
   * 申请医生编号
   */
   @ApiModelProperty(value = "申请医生编号")
    private String doctorCode;

  /**
   * 申请医生姓名
   */
   @ApiModelProperty(value = "申请医生姓名")
    private String doctorName;

  /**
   * 申请支付时间
   */
   @ApiModelProperty(value = "申请支付时间")
    private Date payDate;

  /**
   * 申请时间
   */
   @ApiModelProperty(value = "申请时间")
    private Date applyDate;

  /**
   * 场景分类(原始)
   */
   @ApiModelProperty(value = "场景分类(原始)")
    private String sceneTypeRaw;

  /**
   * 场景分类(标准)
   */
   @ApiModelProperty(value = "场景分类(标准)")
    private String sceneTypeStandard;

//    /**
//     * 检查项目(原始)-del-2
//     */
//     @ApiModelProperty(value = "检查项目(原始)-del-2")
//      private String itemsRaw;
//
//    /**
//     * 检查项目(标准)-del-2
//     */
//     @ApiModelProperty(value = "检查项目(标准)-del-2")
//      private String itemsStandard;

  /**
   * 诊断项目内容(原始)
   */
   @ApiModelProperty(value = "诊断项目内容(原始)")
    private String diagnosisRaw;

  /**
   * 诊断项目内容(标准)
   */
   @ApiModelProperty(value = "诊断项目内容(标准)")
    private String diagnosisStandard;

  /**
   * 医嘱诊断编号(标准)
   */
   @ApiModelProperty(value = "医嘱诊断编号(标准)")
    private String diagnosisCodeStandard;

  /**
   * 状态编号(原始)
   */
   @ApiModelProperty(value = "状态编号(原始)")
    private String statusRaw;

  /**
   * 状态编号(标准)
   */
   @ApiModelProperty(value = "状态编号(标准)")
    private String statusStandard;

  /**
   * 状态名称(原始)
   */
   @ApiModelProperty(value = "状态名称(原始)")
    private String statusNameRaw;

  /**
   * 数据更新时间(原始)
   */
   @ApiModelProperty(value = "数据更新时间(原始)")
    private Date dataUpdateDate;

  /**
   * 操作人
   */
   @ApiModelProperty(value = "操作人")
    private String opDataUser;

  /**
   * 数据操作时间
   */
   @ApiModelProperty(value = "数据操作时间")
    private Date opDate;


   @ApiModelProperty(value = "检查申请详情")
    private List<DwdExamineApplyItemVO> dwdExamineApplyItemVOs;

}
