package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo;

import java.util.Date;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

// DWD检查预约单信息表
@Getter
@Setter
public class DwdExamineReserveVO extends BaseEntity {

  private static final long serialVersionUID = 1L;

  /**
   * 患者编号
   */
  @ApiModelProperty(value = "患者编号")
  private String patientId;

  /**
   * 预约申请号
   */
  @ApiModelProperty(value = "预约申请号")
  private String id;

  /**
   * 申请流水号
   */
  @ApiModelProperty(value = "申请流水号")
  private String applyId;

  /**
   * 就诊记录号
   */
  @ApiModelProperty(value = "就诊记录号")
  private String visitId;

  /**
   * 关联住院号
   */
  @ApiModelProperty(value = "关联住院号")
  private String inPatientNo;

  /**
   * 关联处方号
   */
  @ApiModelProperty(value = "关联处方号")
  private String recipeId;

  /**
   * 患者姓名
   */
  @ApiModelProperty(value = "患者姓名")
  private String patientName;

  /**
   * 申请科室名称(原始)
   */
  @ApiModelProperty(value = "申请科室名称(原始)")
  private String applyDepartmentNameRaw;

  /**
   * 申请科室名称(标准)
   */
  @ApiModelProperty(value = "申请科室名称(标准)")
  private String applyDepartmentNameStandard;

  /**
   * 申请科室编码(原始)
   */
  @ApiModelProperty(value = "申请科室编码(原始)")
  private String applyDepartmentCodeRaw;

  /**
   * 申请科室编码(标准)
   */
  @ApiModelProperty(value = "申请科室编码(标准)")
  private String applyDepartmentCodeStandard;

  /**
   * 医生编号
   */
  @ApiModelProperty(value = "医生编号")
  private String doctorCode;

  /**
   * 医生姓名
   */
  @ApiModelProperty(value = "医生姓名")
  private String doctorName;

  /**
   * 申请时间
   */
  @ApiModelProperty(value = "申请时间")
  private Date applyDate;

  /**
   * 预约时间
   */
  @ApiModelProperty(value = "预约时间")
  private Date bookDate;

  /**
   * 检查项目(原始)
   */
  @ApiModelProperty(value = "检查项目(原始)")
  private String itemsRaw;

  /**
   * 检查项目(标准)
   */
  @ApiModelProperty(value = "检查项目(标准)")
  private String itemsStandard;

  /**
   * 预约状态(原始)
   */
  @ApiModelProperty(value = "预约状态(原始)")
  private String statusRaw;

  /**
   * 预约状态(标准)
   */
  @ApiModelProperty(value = "预约状态(标准)")
  private String statusStandard;

  /**
   * 数据更新时间(原始)
   */
  @ApiModelProperty(value = "数据更新时间(原始)")
  private Date dataUpdateDate;

  /**
   * 操作人
   */
  @ApiModelProperty(value = "操作人")
  private String opDataUser;

  /**
   * 数据操作时间
   */
  @ApiModelProperty(value = "数据操作时间")
  private Date opDate;

}
