package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

// DWD住院信息表
@Getter
@Setter
public class DwdInpatientRecordVO extends BaseEntity {

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 住院流水号
     */
    @ApiModelProperty(value = "住院流水号")
    private String id;

    /**
     * 就诊记录号
     */
    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    /**
     * 关联住院号
     */
    @ApiModelProperty(value = "关联住院号")
    private String inPatientNo;

    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    /**
     * 医院编号
     */
    @ApiModelProperty(value = "医院编号")
    private String companyCode;

    /**
     * 医院名称
     */
    @ApiModelProperty(value = "医院名称")
    private String companyName;

    /**
     * 入住科室名称(原始)
     */
    @ApiModelProperty(value = "入住科室名称(原始)")
    private String admitDepartmentNameRaw;

    /**
     * 入住科室名称(标准)
     */
    @ApiModelProperty(value = "入住科室名称(标准)")
    private String admitDepartmentNameStandard;

    /**
     * 入住科室编码(原始)
     */
    @ApiModelProperty(value = "入住科室编码(原始)")
    private String admitDepartmentCodeRaw;

    /**
     * 入住科室编码(标准)
     */
    @ApiModelProperty(value = "入住科室编码(标准)")
    private String admitDepartmentCodeStandard;

    /**
     * 入住时间
     */
    @ApiModelProperty(value = "入住时间")
    private Date inpatientDate;

    /**
     * 入住病区
     */
    @ApiModelProperty(value = "入住病区")
    private String inpatientWard;

    /**
     * 床号
     */
    @ApiModelProperty(value = "床号")
    private String bedNumber;

    /**
     * 入院方式(原始)
     */
    @ApiModelProperty(value = "入院方式(原始)")
    private String enterWayRaw;

    /**
     * 入院方式(标准)
     */
    @ApiModelProperty(value = "入院方式(标准)")
    private String enterWayStandard;

    /**
     * 预约时间
     */
    @ApiModelProperty(value = "预约时间")
    private Date bookDate;

    /**
     * 住院状态(原始)
     */
    @ApiModelProperty(value = "住院状态(原始)")
    private String statusRaw;

    /**
     * 住院状态(标准)
     */
    @ApiModelProperty(value = "住院状态(标准)")
    private String statusStandard;

    /**
     * 入院诊断内容(原始)
     */
    @ApiModelProperty(value = "入院诊断内容(原始)")
    private String diagnosisRaw;

    /**
     * 入院诊断内容(标准)
     */
    @ApiModelProperty(value = "入院诊断内容(标准)")
    private String diagnosisStandard;

    /**
     * 入院诊断编码(标准)
     */
    @ApiModelProperty(value = "入院诊断编码(标准)")
    private String diagnosisCodeStandard;

    /**
     * 数据更新时间(原始)
     */
    @ApiModelProperty(value = "数据更新时间(原始)")
    private Date dataUpdateDate;

    /**
     * 操作人
     */
    @ApiModelProperty(value = "操作人")
    private String opDataUser;

    /**
     * 数据操作时间
     */
    @ApiModelProperty(value = "数据操作时间")
    private Date opDate;

    /**
     * 管床医生编号
     */
    @ApiModelProperty(value = "管床医生编号")
    private String doctorCode;

    /**
     * 管床医生名称
     */
    @ApiModelProperty(value = "管床医生名称")
    private String doctorName;

    /**
     * 出院记录信息
     */
    @ApiModelProperty(value = "出院记录信息")
    private List<DwdDischargeRecordVO> dwdDischargeRecordVOs;
    @ApiModelProperty(value = "住院预约信息")
    private List<DwdInpatientReserveVO> dwdInpatientReserveVOs;

    /**
     * 医嘱
     */
    @ApiModelProperty(value = "检查申请表")
    private List<DwdExamineApplyVO> dwdExamineApplyVOs;
    @ApiModelProperty(value = "检验申请表")
    private List<DwdLaboratoryApplyVO> dwdLaboratoryApplyVOs;
    @ApiModelProperty(value = "医嘱用药")
    private List<DwdRecipeMedicineVO> dwdRecipeMedicineVOs;
    @ApiModelProperty(value = "手术申请")
    private List<DwdOperationApplyVO> dwdOperationApplyVOs;

    /**
     * 预约记录
     */
    @ApiModelProperty(value = "检查预约单")
    private List<DwdExamineReserveVO> dwdExamineReserveVOs;

    /**
     * 报告
     */
    @ApiModelProperty(value = "检查报告单")
    private List<DwdExamineReportVO> dwdExamineReportVOs;
    @ApiModelProperty(value = "检验报告单")
    private List<DwdLaboratoryReportVO> dwdLaboratoryReportVOs;

    // 手术记录
    @ApiModelProperty(value = "手术记录")
    private List<DwdOperationRecordVO> dwdOperationRecordVOs;

    // 诊断信息
    @ApiModelProperty(value = "诊断信息")
    private List<DwdDiagnosisReportVO> dwdDiagnosisReportVOs;

    // 治疗信息
    @ApiModelProperty(value = "治疗信息")
    private List<DwdRecipeTherapyVO> dwdRecipeTherapyVOs;

    // 住院变更信息
    @ApiModelProperty(value = "住院变更信息")
    private List<DwdInpatientChangeVO> dwdInpatientChangeVOs;

    // 患者首次病程
    @ApiModelProperty(value = "患者首次病程")
    private List<OdsFirstCourseIllnessVO> odsFirstCourseIllnessVOs;

}
