package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

// DWD检验报告单信息表
@Getter
@Setter
public class DwdLaboratoryReportVO extends BaseEntity {

  /**
   * 患者编号
   */
  @ApiModelProperty(value = "患者编号")
  private String patientId;

  /**
   * id
   */
  @ApiModelProperty(value = "id")
  private String id;

  /**
   * 申请单流水号
   */
  @ApiModelProperty(value = "申请单流水号")
  private String applyId;

  /**
   * 就诊记录号
   */
  @ApiModelProperty(value = "就诊记录号")
  private String visitId;

  /**
   * 关联处方id
   */
  @ApiModelProperty(value = "关联处方id")
  private String recipeId;

  /**
   * 住院号
   */
  @ApiModelProperty(value = "住院号")
  private String inPatientNo;

  /**
   * 患者姓名
   */
  @ApiModelProperty(value = "患者姓名")
  private String patientName;

  /**
   * 申请科室名称(原始)
   */
  @ApiModelProperty(value = "申请科室名称(原始)")
  private String departmentNameRaw;

  /**
   * 申请科室名称(标准)
   */
  @ApiModelProperty(value = "申请科室名称(标准)")
  private String departmentNameStandard;

  /**
   * 申请科室编码(原始)
   */
  @ApiModelProperty(value = "申请科室编码(原始)")
  private String departmentCodeRaw;

  /**
   * 申请科室编码(标准)
   */
  @ApiModelProperty(value = "申请科室编码(标准)")
  private String departmentCodeStandard;

  /**
   * 报告时间
   */
  @ApiModelProperty(value = "报告时间")
  private Date reportsTime;

  /**
   * 复核时间
   */
  @ApiModelProperty(value = "复核时间")
  private Date checkTime;

  /**
   * 申请时间
   */
  @ApiModelProperty(value = "申请时间")
  private Date applyTime;

  /**
   * 采样时间
   */
  @ApiModelProperty(value = "采样时间")
  private Date inspectTime;

  /**
   * 场景分类(原始)
   */
  @ApiModelProperty(value = "场景分类(原始)")
  private String sceneTypeRaw;

  /**
   * 场景分类(标准)
   */
  @ApiModelProperty(value = "场景分类(标准)")
  private String sceneTypeStandard;

  /**
   * 申请医生编号
   */
  @ApiModelProperty(value = "申请医生编号")
  private String applyDoctorCode;

  /**
   * 申请医生姓名
   */
  @ApiModelProperty(value = "申请医生姓名")
  private String applyDoctorName;

  /**
   * 报告医生编号
   */
  @ApiModelProperty(value = "报告医生编号")
  private String doctorCode;

  /**
   * 报告医生姓名
   */
  @ApiModelProperty(value = "报告医生姓名")
  private String doctorName;

  /**
   * 样本类别(原始)
   */
  @ApiModelProperty(value = "样本类别(原始)")
  private String sampleTypeRaw;

  /**
   * 样本类别(标准)
   */
  @ApiModelProperty(value = "样本类别(标准)")
  private String sampleTypeStandard;

  /**
   * 报告名称
   */
  @ApiModelProperty(value = "报告名称")
  private String reportName;

  /**
   * 报告描述或备注(原始)
   */
  @ApiModelProperty(value = "报告描述或备注(原始)")
  private String descriptionRaw;

  /**
   * 报告描述或备注(标准)
   */
  @ApiModelProperty(value = "报告描述或备注(标准)")
  private String descriptionStandard;

  /**
   * 初步结论(原始)
   */
  @ApiModelProperty(value = "初步结论(原始)")
  private String conclusionRaw;

  /**
   * 初步结论(标准)
   */
  @ApiModelProperty(value = "初步结论(标准)")
  private String conclusionStandard;

  /**
   * 数据更新时间(原始)
   */
  @ApiModelProperty(value = "数据更新时间(原始)")
  private Date dataUpdateDate;

  /**
   * 操作人
   */
  @ApiModelProperty(value = "操作人")
  private String opDataUser;

  /**
   * 数据操作时间
   */
  @ApiModelProperty(value = "数据操作时间")
  private Date opDate;

  @ApiModelProperty(value = "状态编号(原始)")
  private String statusRaw;

  @ApiModelProperty(value = "状态编号(标准)")
  private String statusStandard;

  /**
   * 活动编号
   */
  @ApiModelProperty(value = "活动编号")
  private String activityNo;

  /**
   * 检验报告单明细
   */
  @ApiModelProperty(value = "检验报告单明细")
  private List<DwdLaboratoryReportItemVO> dwdLaboratoryReportItemVOs;

}
