package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo;

import java.util.Date;
import lombok.Data;
import io.swagger.annotations.ApiModelProperty;

/**
 * <p>
 * DWD电子病例信息表
 * </p>
 */
@Data
public class DwdPatientMedicalRecordVO  {

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    /**
     * 患者类型(原始)
     */
    @ApiModelProperty(value = "患者类型(原始)")
    private String patientTypeRaw;

    /**
     * 患者类型(标准)
     */
    @ApiModelProperty(value = "患者类型(标准)")
    private String patientTypeStandard;

    /**
     * 患者卡号
     */
    @ApiModelProperty(value = "患者卡号")
    private String patientCardNo;

    /**
     * 申请科室名称(原始)
     */
    @ApiModelProperty(value = "申请科室名称(原始)")
    private String departmentNameRaw;

    /**
     * 申请科室编码(原始)
     */
    @ApiModelProperty(value = "申请科室编码(原始)")
    private String departmentCodeRaw;

    /**
     * 申请科室名称(标准)
     */
    @ApiModelProperty(value = "申请科室名称(标准)")
    private String departmentNameStandard;

    /**
     * 申请科室编码(标准)
     */
    @ApiModelProperty(value = "申请科室编码(标准)")
    private String departmentCodeStandard;

    /**
     * 医生编号
     */
    @ApiModelProperty(value = "医生编号")
    private String doctorCode;

    /**
     * 医生姓名
     */
    @ApiModelProperty(value = "医生姓名")
    private String doctorName;

    /**
     * 状态编号(原始)
     */
    @ApiModelProperty(value = "状态编号(原始)")
    private String statusRaw;

    /**
     * 状态编号(标准)
     */
    @ApiModelProperty(value = "状态编号(标准)")
    private String statusStandard;

    /**
     * 数据更新时间(原始)
     */
    @ApiModelProperty(value = "数据更新时间(原始)")
    private Date dataUpdateDate;

    /**
     * 操作人
     */
    @ApiModelProperty(value = "操作人")
    private String opDataUser;

    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    private Date opDate;

}
