package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo;

import java.util.Date;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

// DWD患者基本信息表
@Getter
@Setter
public class DwdPatientVO extends BaseEntity {

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 患者姓名
     */
    @ApiModelProperty(value = "患者姓名")
    private String patientName;

    /**
     * 证件类型(原始)
     */
    @ApiModelProperty(value = "证件类型(原始)")
    private String cardNoTypeRaw;

    /**
     * 证件类型(标准)
     */
    @ApiModelProperty(value = "证件类型(标准)")
    private String cardNoTypeStandard;

    /**
     * 证件号
     */
    @ApiModelProperty(value = "证件号")
    private String cardNo;

    /**
     * 性别(原始)
     */
    @ApiModelProperty(value = "性别(原始)")
    private String patientGenderRaw;

    /**
     * 性别(标准)
     */
    @ApiModelProperty(value = "性别(标准)")
    private String patientGenderStandard;

    /**
     * 生日
     */
    @ApiModelProperty(value = "生日")
    private String birthday;

    /**
     * 电话号码
     */
    @ApiModelProperty(value = "电话号码")
    private String phone;

    /**
     * 备注信息
     */
    @ApiModelProperty(value = "备注信息")
    private String remark;

    /**
     * 数据更新时间(原始)
     */
    @ApiModelProperty(value = "数据更新时间(原始)")
    private Date dataUpdateDate;

    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    private Date opDate;

    /**
     * 操作人
     */
    @ApiModelProperty(value = "操作人")
    private String opDataUser;

    /**
     * 主客户ID
     */
    @ApiModelProperty(value = "主客户ID")
    private String mainPersonId;

    /**
     * 死亡状态(Y生 N死)
     */
    @ApiModelProperty(value = "死亡状态(Y生 N死)")
    private String deathStatus;

    /**
     * 死亡时间
     */
    @ApiModelProperty(value = "死亡时间")
    private Date deathTime;

}
