package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo;

import java.util.Date;
import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

// DWD医嘱用药明细数据表
@Getter
@Setter
public class DwdRecipeMedicineItemVO extends BaseEntity {

    /**
     * 患者编号
     */
    @ApiModelProperty(value = "患者编号")
    private String patientId;

    /**
     * 医嘱用药数据ID
     */
    @ApiModelProperty(value = "医嘱用药数据ID")
    private String recipeMedicineId;

    /**
     * id
     */
    @ApiModelProperty(value = "id")
    private String id;

    /**
     * 就诊记录号
     */
    @ApiModelProperty(value = "就诊记录号")
    private String visitId;

    /**
     * 住院号
     */
    @ApiModelProperty(value = "住院号")
    private String inPatientNo;

    /**
     * 关联处方id
     */
    @ApiModelProperty(value = "关联处方id")
    private String recipeId;

    /**
     * 申请科室名称(原始)
     */
    @ApiModelProperty(value = "申请科室名称(原始)")
    private String departmentNameRaw;

    /**
     * 申请科室编码(原始)
     */
    @ApiModelProperty(value = "申请科室编码(原始)")
    private String departmentCodeRaw;

    /**
     * 申请科室名称(标准)
     */
    @ApiModelProperty(value = "申请科室名称(标准)")
    private String departmentNameStandard;

    /**
     * 申请科室编码(标准)
     */
    @ApiModelProperty(value = "申请科室编码(标准)")
    private String departmentCodeStandard;

    /**
     * 付费时间
     */
    @ApiModelProperty(value = "付费时间")
    private Date payTime;

    /**
     * 处方时间
     */
    @ApiModelProperty(value = "处方时间")
    private Date recipeTime;

    /**
     * 药品名称(原始)
     */
    @ApiModelProperty(value = "药品名称(原始)")
    private String nameRaw;

    /**
     * 药品名称(标准)
     */
    @ApiModelProperty(value = "药品名称(标准)")
    private String nameStandard;

    /**
     * 药品编码(原始)
     */
    @ApiModelProperty(value = "药品编码(原始)")
    private String codeRaw;

    /**
     * 药品编码(标准)
     */
    @ApiModelProperty(value = "药品编码(标准)")
    private String codeStandard;

    /**
     * 药物分类(原始)
     */
    @ApiModelProperty(value = "药物分类(原始)")
    private String medicineClassRaw;

    /**
     * 药物分类(标准)
     */
    @ApiModelProperty(value = "药物分类(标准)")
    private String medicineClassStandard;

    /**
     * 药品规格
     */
    @ApiModelProperty(value = "药品规格")
    private String medicineSpec;

    /**
     * 单次用药单位(原始)
     */
    @ApiModelProperty(value = "单次用药单位(原始)")
    private String doseUnitRaw;

    /**
     * 单次用药单位(标准)
     */
    @ApiModelProperty(value = "单次用药单位(标准)")
    private String doseUnitStandard;

    /**
     * 单次用药数量
     */
    @ApiModelProperty(value = "单次用药数量")
    private String eachQuantity;

    /**
     * 用药天数
     */
    @ApiModelProperty(value = "用药天数")
    private String inspectResult;

    /**
     * 用药频次代码(原始)
     */
    @ApiModelProperty(value = "用药频次代码(原始)")
    private String frequencyCodeRaw;

    /**
     * 用药频次代码(标准)
     */
    @ApiModelProperty(value = "用药频次代码(标准)")
    private String frequencyCodeStandard;

    /**
     * 用药频次名称(原始)
     */
    @ApiModelProperty(value = "用药频次名称(原始)")
    private String frequencyNameRaw;

    /**
     * 用药频次名称(标准)
     */
    @ApiModelProperty(value = "用药频次名称(标准)")
    private String frequencyNameStandard;

    /**
     * 带药(发药)总数
     */
    @ApiModelProperty(value = "带药(发药)总数")
    private String medicationAmount;

    /**
     * 带药(发药)总数单位
     */
    @ApiModelProperty(value = "带药(发药)总数单位")
    private String medicationAmountUnit;

    /**
     * 包装规格
     */
    @ApiModelProperty(value = "包装规格")
    private String packingSpecNum;

    /**
     * 包装单位(原始)
     */
    @ApiModelProperty(value = "包装单位(原始)")
    private String packingSpecUnitRaw;

    /**
     * 包装单位(标准)
     */
    @ApiModelProperty(value = "包装单位(标准)")
    private String packingSpecUnitStandard;

    /**
     * 用法用量
     */
    @ApiModelProperty(value = "用法用量")
    private String usage;

    /**
     * 用药建议
     */
    @ApiModelProperty(value = "用药建议")
    private String usageAdvic;

    /**
     * 用药方式编码(原始)
     */
    @ApiModelProperty(value = "用药方式编码(原始)")
    private String usageCodeRaw;

    /**
     * 用药方式编码(标准)
     */
    @ApiModelProperty(value = "用药方式编码(标准)")
    private String usageCodeStandard;

    /**
     * 用药方式名称(原始)
     */
    @ApiModelProperty(value = "用药方式名称(原始)")
    private String usageContentRaw;

    /**
     * 用药方式名称(标准)
     */
    @ApiModelProperty(value = "用药方式名称(标准)")
    private String usageContentStandard;

    /**
     * 数据更新时间(原始)
     */
    @ApiModelProperty(value = "数据更新时间(原始)")
    private Date dataUpdateDate;

    /**
     * 操作人
     */
    @ApiModelProperty(value = "操作人")
    private String opDataUser;

    /**
     * 数据操作时间
     */
    @ApiModelProperty(value = "数据操作时间")
    private Date opDate;

}
