package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo;

import java.util.Date;
import java.util.List;

import com.xxh.cloud.framework.common.mybatisplus.entity.BaseEntity;

import lombok.Getter;
import lombok.Setter;
import io.swagger.annotations.ApiModelProperty;

// DWD就诊信息表
@Getter
@Setter
public class DwdVisitRecordVO extends BaseEntity {

  /**
   * 患者编号
   */
  @ApiModelProperty(value = "患者编号")
  private String patientId;

  /**
   * 就诊记录号
   */
  @ApiModelProperty(value = "就诊记录号")
  private String id;

  /**
   * 挂号ID
   */
  @ApiModelProperty(value = "挂号ID")
  private String registerId;

  /**
   * 患者姓名
   */
  @ApiModelProperty(value = "患者姓名")
  private String patientName;

  /**
   * 卡号类型(原始)
   */
  @ApiModelProperty(value = "卡号类型(原始)")
  private String cardTypeRaw;

  /**
   * 卡号类型(标准)
   */
  @ApiModelProperty(value = "卡号类型(标准)")
  private String cardTypeStandard;

  /**
   * 卡号
   */
  @ApiModelProperty(value = "卡号")
  private String cardNo;

  /**
   * 患者性别(原始)
   */
  @ApiModelProperty(value = "患者性别(原始)")
  private String patientGenderRaw;

  /**
   * 患者性别(标准)
   */
  @ApiModelProperty(value = "患者性别(标准)")
  private String patientGenderStandard;

  /**
   * 患者年龄
   */
  @ApiModelProperty(value = "患者年龄")
  private String patientAge;

  /**
   * 医院名称
   */
  @ApiModelProperty(value = "医院名称")
  private String companyName;

  /**
   * 医院编号
   */
  @ApiModelProperty(value = "医院编号")
  private String companyCode;

  /**
   * 科室名称(原始)
   */
  @ApiModelProperty(value = "科室名称(原始)")
  private String departmentNameRaw;

  /**
   * 科室名称(标准)
   */
  @ApiModelProperty(value = "科室名称(标准)")
  private String departmentNameStandard;

  /**
   * 科室编码(原始)
   */
  @ApiModelProperty(value = "科室编码(原始)")
  private String departmentCodeRaw;

  /**
   * 标准科室编码
   */
  @ApiModelProperty(value = "标准科室编码")
  private String departmentCodeStandard;

  /**
   * 医生编号
   */
  @ApiModelProperty(value = "医生编号")
  private String doctorCode;

  /**
   * 医生姓名
   */
  @ApiModelProperty(value = "医生姓名")
  private String doctorName;

  /**
   * 就诊时间
   */
  @ApiModelProperty(value = "就诊时间")
  private Date visitDate;

  /**
   * 就诊类型(原始)
   */
  @ApiModelProperty(value = "就诊类型(原始)")
  private String visitTypeRaw;

  /**
   * 就诊类型(标准)
   */
  @ApiModelProperty(value = "就诊类型(标准)")
  private String visitTypeStandard;

  /**
   * 就诊方式(原始)
   */
  @ApiModelProperty(value = "就诊方式(原始)")
  private String visitWayRaw;

  /**
   * 就诊方式(标准)
   */
  @ApiModelProperty(value = "就诊方式(标准)")
  private String visitWayStandard;

  /**
   * 场景分类(原始)
   */
  @ApiModelProperty(value = "场景分类(原始)")
  private String sceneTypeRaw;

  /**
   * 场景分类(标准)
   */
  @ApiModelProperty(value = "场景分类(标准)")
  private String sceneTypeStandard;

  /**
   * 状态编号(原始)
   */
  @ApiModelProperty(value = "状态编号(原始)")
  private String statusRaw;

  /**
   * 状态编号(标准)
   */
  @ApiModelProperty(value = "状态编号(标准)")
  private String statusStandard;

  /**
   * 状态名称(原始)
   */
  @ApiModelProperty(value = "状态名称(原始)")
  private String statusNameRaw;

  /**
   * 数据更新时间(原始)
   */
  @ApiModelProperty(value = "数据更新时间(原始)")
  private Date dataUpdateDate;

  /**
   * 操作时间
   */
  @ApiModelProperty(value = "操作时间")
  private Date opDate;

  /**
   * 操作人
   */
  @ApiModelProperty(value = "操作人")
  private String opDataUser;

  /**
   * 医嘱
   */
  @ApiModelProperty(value = "检查申请表")
  private List<DwdExamineApplyVO> dwdExamineApplyVOs;
  @ApiModelProperty(value = "检验申请表")
  private List<DwdLaboratoryApplyVO> dwdLaboratoryApplyVOs;
  @ApiModelProperty(value = "医嘱用药")
  private List<DwdRecipeMedicineVO> dwdRecipeMedicineVOs;
  @ApiModelProperty(value = "手术申请")
  private List<DwdOperationApplyVO> dwdOperationApplyVOs;

  // 预约记录
  @ApiModelProperty(value = "挂号")
  private List<DwdRegisterRecordVO> dwdRegisterRecordVOs;
  @ApiModelProperty(value = "检查预约单")
  private List<DwdExamineReserveVO> dwdExamineReserveVOs;

  // 报告
  @ApiModelProperty(value = "检查报告单")
  private List<DwdExamineReportVO> dwdExamineReportVOs;
  @ApiModelProperty(value = "检验报告单")
  private List<DwdLaboratoryReportVO> dwdLaboratoryReportVOs;

  // 手术记录
  @ApiModelProperty(value = "手术记录")
  private List<DwdOperationRecordVO> dwdOperationRecordVOs;

  // 诊断信息
  @ApiModelProperty(value = "诊断信息")
  private List<DwdDiagnosisReportVO> dwdDiagnosisReportVOs;

  // 治疗信息
  @ApiModelProperty(value = "治疗信息")
  private List<DwdRecipeTherapyVO> dwdRecipeTherapyVOs;

  // 患者既往史
  @ApiModelProperty(value = "患者既往史")
  private OdsPatientPastHisVO odsPatientPastHisVOs;

}
