package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdInpatientRecordInfo;

public interface DeptRelationBizMapper {

    // 查询上级部门id
    @Select(" SELECT pid " + 
            " FROM sys_dept " +
            " WHERE id = ${deptId} ")
    String getParentDeptId(@Param("deptId") String deptId);

    // 查询下级部门id列表
    @Select(" SELECT id " + 
            " FROM sys_dept " +
            " WHERE pid = ${deptId} ")
    List<String> getSubDeptId(@Param("deptId") String deptId);

    // 查询上级部门id
    @Select(" SELECT id, pid " + 
            " FROM sys_dept " +
            " ${ew.customSqlSegment} ")
    List<Map<String, String>> getParentDeptIds(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 查询下级部门id列表
    @Select(" SELECT id, pid " + 
            " FROM sys_dept " +
            " ${ew.customSqlSegment} ")
    List<Map<String, String>> getSubDeptIds(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

}