package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdDiagnosisReportInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdExaminationPatientInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdInpatientRecordInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdVisitRecordInfo;

public interface DwdPatientHealthInfoBizMapper {

    // 就诊

    // 就诊
    @Select(" SELECT a.id, b.main_person_id patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_patient_info b ON a.patient_id = b.patient_id " + 
            "    ${ew.customSqlSegment} ")
    List<DwdVisitRecordInfo> visitList(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);


    // 挂号
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_register_record_info b ON a.register_id = b.id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithRegisterRecord(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 检查申请单
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_examine_apply_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithExamineApply(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 检验申请单
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_laboratory_apply_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithLaboratoryApply(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 医嘱用药
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_recipe_medicine_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithRecipeMedicine(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 手术申请
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_operation_apply_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithOperationApply(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 检查预约单
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_examine_reserve_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithExamineReserve(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 检查报告单
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_examine_report_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithExamineReport(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 检验报告单
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_laboratory_report_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithLaboratoryReport(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 手术记录
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_operation_record_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithOperationRecord(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 诊断
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_diagnosis_report_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithDiagnosisReport(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);

    // 治疗
    @Select(" SELECT a.id, a.patient_id, a.visit_date " + 
            "    FROM dwd_visit_record_info a " +
            "    INNER JOIN dwd_recipe_therapy_info b ON a.register_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.visit_date " + 
            "    ORDER BY a.visit_date DESC " + 
            "    LIMIT 10 ")
    List<DwdVisitRecordInfo> visitListWithRecipeTherapy(@Param(Constants.WRAPPER) Wrapper<DwdVisitRecordInfo> wrapper);


    // 住院

    // 住院预约
    // TODO 住院预约的科室和实际住院的科室有可能不是一个，但是上级科室是一个，所以只要能从上级科室下的所有子科室中匹配到则说明该预约属于科室
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_inpatient_reserve_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithInpatientReserve(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 出院
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_discharge_record_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithDischargeRecord(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 检查申请单
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_examine_apply_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithExamineApply(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 检验申请单
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_laboratory_apply_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithLaboratoryApply(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 医嘱用药
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_recipe_medicine_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithRecipeMedicine(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 手术申请
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_operation_apply_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithOperationApply(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 检查预约单
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_examine_reserve_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithExamineReserve(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 检查报告单
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_examine_report_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithExamineReport(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 检验报告单
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_laboratory_report_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithLaboratoryReport(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 手术记录
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_operation_record_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithOperationRecord(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 诊断
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_diagnosis_report_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithDiagnosisReport(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);

    // 治疗
    @Select(" SELECT a.id, a.patient_id, a.inpatient_date " + 
            "    FROM dwd_inpatient_record_info a " +
            "    INNER JOIN dwd_recipe_therapy_info b ON a.id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.id, a.patient_id, a.inpatient_date " + 
            "    ORDER BY a.inpatient_date DESC " + 
            "    LIMIT 10 ")
    List<DwdInpatientRecordInfo> inHospitalListWithRecipeTherapy(@Param(Constants.WRAPPER) Wrapper<DwdInpatientRecordInfo> wrapper);


    
    // 体检
    
    // 检查报告单
    @Select(" SELECT a.visit_id, a.main_person_id, a.data_create_date " + 
            "    FROM dwd_examination_patient_info a " +
            "    INNER JOIN dwd_examine_report_info b ON a.visit_id = b.visit_id " +
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.visit_id, a.main_person_id, a.data_create_date " + 
            "    ORDER BY a.data_create_date DESC " + 
            "    LIMIT 10 ")
    List<DwdExaminationPatientInfo> examinationListWithExamineReport(@Param(Constants.WRAPPER) Wrapper<DwdExaminationPatientInfo> wrapper);

    // 检验报告单
    @Select(" SELECT a.visit_id, a.main_person_id, a.data_create_date " + 
            "    FROM dwd_examination_patient_info a " + 
            "    INNER JOIN dwd_laboratory_report_info b ON a.visit_id = b.visit_id " + 
            "    ${ew.customSqlSegment} " + 
            "    GROUP BY a.visit_id, a.main_person_id, a.data_create_date " + 
            "    ORDER BY a.data_create_date DESC " + 
            "    LIMIT 10 ")
    List<DwdExaminationPatientInfo> examinationListWithLaboratoryReport(@Param(Constants.WRAPPER) Wrapper<DwdExaminationPatientInfo> wrapper);

    // 诊断
    @Select(" SELECT a.patient_id, a.visit_id, a.diagnosis_code_standard, MAX(a.diagnosis_name_standard) diagnosis_name_standard, MAX(a.diagnosis_code_raw) diagnosis_code_raw, MAX(a.diagnosis_name_raw) diagnosis_name_raw, " + 
            "    MAX(a.diagnosis_time) diagnosis_time, MAX(a.sort_idx) sort_idx, MAX(a.scene_type_standard) scene_type_standard, MAX(a.scene_type_raw) scene_type_raw " + 
            " FROM dwd_diagnosis_report_info a " + 
            " ${ew.customSqlSegment} " + 
            " GROUP BY a.patient_id, a.visit_id, a.diagnosis_code_standard " + 
            " ORDER BY diagnosis_time DESC ")
    IPage<DwdDiagnosisReportInfo> diagnosisReportGroupPage(Page<DwdDiagnosisReportInfo> page, @Param(Constants.WRAPPER) Wrapper<DwdDiagnosisReportInfo> wrapper);

}