package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdCollectFeeRecordInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdOperationRecordItemInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdCollectFeeRecordInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdCollectFeeRecordBizService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * DWD收费记录信息表 服务类
 * </p>
 */
@DS("wd")
@Service
public class DwdCollectFeeRecordBizServiceImpl implements DwdCollectFeeRecordBizService {

    @Autowired
    private DwdCollectFeeRecordInfoService dwdCollectFeeRecordInfoService;

    @Override
    public List<DwdCollectFeeRecordInfo> listByPatientId(String patientId) {
        List<DwdCollectFeeRecordInfo> data = dwdCollectFeeRecordInfoService.list(
                new QueryWrapper<DwdCollectFeeRecordInfo>()
                        .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwdCollectFeeRecordInfo> listByPatientId(List<String> patientIds) {
        List<DwdCollectFeeRecordInfo> data = dwdCollectFeeRecordInfoService.list(
                new QueryWrapper<DwdCollectFeeRecordInfo>()
                        .in("patient_id",patientIds)
        );
        return data;
    }

    @Override
    public DwdCollectFeeRecordInfo getById(String id) {
        return dwdCollectFeeRecordInfoService.getById(id);
    }
}
