package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdExamineApplyItemInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdExamineApplyItemInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdExamineApplyItemQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdExamineApplyItemVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.helper.PatientHealthyHelper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdExamineApplyItemBizService;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@DS("wd")
@Service
public class DwdExamineApplyItemBizServiceImpl implements DwdExamineApplyItemBizService {

    @Autowired
    private DwdExamineApplyItemInfoService dwdExamineApplyItemInfoService;

    @Override
    public List<DwdExamineApplyItemVO> list(DwdExamineApplyItemQueryDTO params) {
        List<DwdExamineApplyItemInfo> data = dwdExamineApplyItemInfoService.list(new QueryWrapper<DwdExamineApplyItemInfo>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getApplyId()), "apply_id", params.getApplyId())
                .in(CollectionUtil.isNotEmpty(params.getApplyIds()), "apply_id", params.getApplyIds())
        );
        return data.stream().map(PatientHealthyHelper::getDwdExamineApplyItemVO).collect(Collectors.toList());
    }

    @Override
    public List<DwdExamineApplyItemVO> listByPatientId(String patientId) {
        List<DwdExamineApplyItemInfo> data = dwdExamineApplyItemInfoService.list(new QueryWrapper<DwdExamineApplyItemInfo>()
                .eq("patient_id",patientId)
        );
        return data.stream().map(PatientHealthyHelper::getDwdExamineApplyItemVO).collect(Collectors.toList());
    }

    @Override
    public List<DwdExamineApplyItemVO> listByPatientIds(List<String> patientIds) {
        List<DwdExamineApplyItemInfo> data = dwdExamineApplyItemInfoService.list(new QueryWrapper<DwdExamineApplyItemInfo>()
                .in("patient_id",patientIds)
        );
        return data.stream().map(PatientHealthyHelper::getDwdExamineApplyItemVO).collect(Collectors.toList());
    }

    @Override
    public DwdExamineApplyItemVO getById(String id) {
        DwdExamineApplyItemInfo entity = dwdExamineApplyItemInfoService.getById(id);
        return PatientHealthyHelper.getDwdExamineApplyItemVO(entity);
    }

    @Override
    public List<DwdExamineApplyItemInfo> listBeanByPatient(String patientId) {
        List<DwdExamineApplyItemInfo> data = dwdExamineApplyItemInfoService.list(new QueryWrapper<DwdExamineApplyItemInfo>()
                .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwdExamineApplyItemInfo> listBeanByPatient(List<String> patientIds) {
        List<DwdExamineApplyItemInfo> data = dwdExamineApplyItemInfoService.list(new QueryWrapper<DwdExamineApplyItemInfo>()
                .in("patient_id",patientIds)
        );
        return data;
    }

}
