package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.alibaba.fastjson2.JSON;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.client.api.constant.DwdConstant;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdInpatientRecordInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdInpatientRecordInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdDiagnosisReportQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdDischargeRecordQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdExamineApplyQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdExamineReportQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdExamineReserveQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdInpatientChangeQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdInpatientRecordQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdInpatientReserveQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdLaboratoryApplyQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdLaboratoryReportQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdOperationApplyQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdOperationRecordQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdRecipeMedicineQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdRecipeTherapyQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.OdsFirstCourseIllnessQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdDiagnosisReportVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdDischargeRecordVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdExamineApplyVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdExamineReportVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdExamineReserveVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdInpatientChangeVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdInpatientRecordVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdInpatientReserveVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdLaboratoryApplyVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdLaboratoryReportVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdOperationApplyVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdOperationRecordVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdRecipeMedicineVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdRecipeTherapyVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.OdsFirstCourseIllnessVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.helper.PatientHealthyHelper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdDiagnosisReportBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdDischargeRecordBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdExamineApplyBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdExamineReportBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdExamineReserveBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdInpatientChangeBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdInpatientRecordBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdInpatientReserveBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdLaboratoryApplyBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdLaboratoryReportBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdOperationApplyBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdOperationRecordBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdRecipeMedicineBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdRecipeTherapyBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.OdsFirstCourseIllnessBizService;
import com.xxh.cloud.framework.common.constant.YN;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * DWD住院记录信息表
 */
@DS("wd")
@Slf4j
@Service
public class DwdInpatientRecordBizServiceImpl implements DwdInpatientRecordBizService {

    @Autowired
    private DwdInpatientRecordInfoService dwdInpatientRecordInfoService;
    @Autowired
    private DwdDischargeRecordBizService dwdDischargeRecordBizService;
    @Autowired
    private DwdInpatientReserveBizService dwdInpatientReserveBizService;
    @Autowired
    private DwdExamineApplyBizService dwdExamineApplyBizService;
    @Autowired
    private DwdLaboratoryApplyBizService dwdLaboratoryApplyBizService;
    @Autowired
    private DwdRecipeMedicineBizService dwdRecipeMedicineBizService;
    @Autowired
    private DwdExamineReserveBizService dwdExamineReserveBizService;
    @Autowired
    private DwdExamineReportBizService dwdExamineReportBizService;
    @Autowired
    private DwdLaboratoryReportBizService dwdLaboratoryReportBizService;
    @Autowired
    private DwdOperationApplyBizService dwdOperationApplyBizService;
    @Autowired
    private DwdOperationRecordBizService dwdOperationRecordBizService;
    @Autowired
    private DwdDiagnosisReportBizService dwdDiagnosisReportBizService;
    @Autowired
    private DwdRecipeTherapyBizService dwdRecipeTherapyBizService;
    @Autowired
    private DwdInpatientChangeBizService dwdInpatientChangeBizService;
    @Autowired
    private OdsFirstCourseIllnessBizService odsFirstCourseIllnessBizService;

    @Override
    public List<DwdInpatientRecordVO> list(DwdInpatientRecordQueryDTO params) {
        log.info("DwdInpatientRecordBizServiceImpl.list::params >>>>>> {}", JSON.toJSONString(params));

        List<DwdInpatientRecordInfo> data =  dwdInpatientRecordInfoService.list(new QueryWrapper<DwdInpatientRecordInfo>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .ge(StrUtil.isNotBlank(params.getStartDate()), "inpatient_date", params.getStartDate())
                .le(StrUtil.isNotBlank(params.getEndDate()), "inpatient_date", params.getEndDate())
                .eq((StrUtil.isNotBlank(params.getIsDept()) && YN.YES.getCode().equals(params.getIsDept())) && StrUtil.isNotBlank(params.getDeptId()), "admit_department_code_standard", params.getDeptId()) // 查询指定部门的数据
                .ne((StrUtil.isNotBlank(params.getIsDept()) && YN.NO.getCode().equals(params.getIsDept())) && StrUtil.isNotBlank(params.getDeptId()), "admit_department_code_standard", params.getDeptId()) // 过滤指定部门的数据
                .orderByDesc("inpatient_date")
                .last(StrUtil.isNotBlank(params.getStartDate()) && StrUtil.isBlank(params.getEndDate()) && params.getRows() > 0, " limit " + params.getRows()) // 以开始时间为条件查询固定条数数据（伪分页），可能问题：相同时间数据如果在不同页中，查询数据会有重叠
        );
        List<DwdInpatientRecordVO> list = data.stream().map(PatientHealthyHelper::getDwdInpatientRecordVO).collect(Collectors.toList());

        if (CollectionUtil.isNotEmpty(list)) {
            List<String> ids = new ArrayList<>();
            List<String> visitIds = new ArrayList<>();
            list.forEach(i -> {
                ids.add(i.getId());
                visitIds.add(i.getVisitId());
            });
            // 住院
            // 1.住院 本数据本身就是住院信息
            // 2.出院
            Map<String, List<DwdDischargeRecordVO>> dwdDischargeRecordVOMap = this.getDwdDischargeRecordVOMap(params, visitIds);
            // 3.住院预约 上层单独处理
            // Map<String, List<DwdInpatientReserveVO>> dwdInpatientReserveVOMap = this.getDwdInpatientReserveVOMap(params, visitIds);
            // 4.手术申请
            Map<String, List<DwdOperationApplyVO>> dwdOperationApplyVOMap = this.getDwdOperationApplyVOMap(params, visitIds);

            // 医嘱
            // 1.检查申请表
            Map<String, List<DwdExamineApplyVO>> dwdExamineApplyVOMap = this.getDwdExamineApplyVOMap(params, visitIds);
            // 2.检验申请表
            Map<String, List<DwdLaboratoryApplyVO>> dwdLaboratoryApplyVOMap = this.getDwdLaboratoryApplyVOMap(params, visitIds);
            // 3.医嘱用药
            Map<String, List<DwdRecipeMedicineVO>> dwdRecipeMedicineVOMap = this.getDwdRecipeMedicineVOMap(params, visitIds);

            // 预约记录
            // 2.检查预约
            Map<String, List<DwdExamineReserveVO>> dwdExamineReserveVOMap = this.getDwdExamineReserveVOMap(params, visitIds);

            // 报告
            // 1.检查报告单
            Map<String, List<DwdExamineReportVO>> dwdExamineReportVOMap = this.getDwdExamineReportVOMap(params, visitIds);
            // 2.检验报告单
            Map<String, List<DwdLaboratoryReportVO>> dwdLaboratoryReportVOMap = this.getDwdLaboratoryReportVOMap(params, visitIds);

            // 手术记录
            Map<String, List<DwdOperationRecordVO>> dwdOperationRecordVOMap = this.getDwdOperationRecordVOMap(params, visitIds);

            // 诊断
            Map<String, List<DwdDiagnosisReportVO>> dwdDiagnosisReportVOMap = this.getDwdDiagnosisReportVOMap(params, visitIds);
            
            // 治疗信息
            Map<String, List<DwdRecipeTherapyVO>> dwdRecipeTherapyVOMap = this.getDwdRecipeTherapyVOMap(params, visitIds);

            // 住院变更信息
            Map<String, List<DwdInpatientChangeVO>> dwdInpatientChangeVOMap = this.getDwdInpatientChangeVOMap(params, ids);

            // 患者首次病程
            Map<String, List<OdsFirstCourseIllnessVO>> odsFirstCourseIllnessVOMap = this.getOdsFirstCourseIllnessVOMap(params, ids);

            list.forEach(i -> {
                i.setDwdDischargeRecordVOs(dwdDischargeRecordVOMap.get(i.getVisitId()));
                // i.setDwdInpatientReserveVOs(dwdInpatientReserveVOMap.get(i.getVisitId()));
                i.setDwdOperationApplyVOs(dwdOperationApplyVOMap.get(i.getVisitId()));

                i.setDwdExamineApplyVOs(dwdExamineApplyVOMap.get(i.getVisitId()));
                i.setDwdLaboratoryApplyVOs(dwdLaboratoryApplyVOMap.get(i.getVisitId()));
                i.setDwdRecipeMedicineVOs(dwdRecipeMedicineVOMap.get(i.getVisitId()));

                i.setDwdExamineReserveVOs(dwdExamineReserveVOMap.get(i.getVisitId()));

                i.setDwdExamineReportVOs(dwdExamineReportVOMap.get(i.getVisitId()));
                i.setDwdLaboratoryReportVOs(dwdLaboratoryReportVOMap.get(i.getVisitId()));

                i.setDwdOperationRecordVOs(dwdOperationRecordVOMap.get(i.getVisitId()));

                i.setDwdDiagnosisReportVOs(dwdDiagnosisReportVOMap.get(i.getVisitId()));

                i.setDwdRecipeTherapyVOs(dwdRecipeTherapyVOMap.get(i.getVisitId()));

                i.setOdsFirstCourseIllnessVOs(odsFirstCourseIllnessVOMap.get(i.getVisitId()));

                List<DwdInpatientChangeVO> dwdInpatientChangeVOs = dwdInpatientChangeVOMap.get(i.getVisitId());
                if (CollectionUtil.isNotEmpty(dwdInpatientChangeVOs)) {
                    i.setDwdInpatientChangeVOs(dwdInpatientChangeVOs);

                    DwdInpatientChangeVO dept = null;
                    DwdInpatientChangeVO bed = null;

                    for (DwdInpatientChangeVO change : dwdInpatientChangeVOs) {
                        if ("ZKZRKS".equals(change.getChangeType()) && (dept == null || dept.getChangeTime().compareTo(change.getChangeTime()) < 0)) {
                            dept = change;
                        }
                        if ("ZKZRCW".equals(change.getChangeType()) && (bed == null || bed.getChangeTime().compareTo(change.getChangeTime()) < 0)) {
                            bed = change;
                        }
                    }

                    String inpatientDate = DateUtil.format(i.getInpatientDate(), "yyyy-MM-dd HH:mm:ss").toString(); // 变动时间大于住院记录中的时间才以变动数据为准
                    // 最后变动科室
                    if (null != dept && dept.getChangeTime().compareTo(inpatientDate) > 0) {
                        i.setAdmitDepartmentNameRaw(dept.getName());
                        i.setAdmitDepartmentNameStandard(dept.getName());
                        i.setAdmitDepartmentCodeRaw(dept.getCode());
                        i.setAdmitDepartmentCodeStandard(dept.getCode());
                    }
                    // 最后变动床位
                    if (null != bed && bed.getChangeTime().compareTo(inpatientDate) > 0) {
                        i.setBedNumber(bed.getCode());
                    }
                }
            });
        }

        return list;
    }

    // 出院记录
    private Map<String, List<DwdDischargeRecordVO>> getDwdDischargeRecordVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.DischargeRecord.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdDischargeRecordQueryDTO queryDTO = new DwdDischargeRecordQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdDischargeRecordVO> voList = dwdDischargeRecordBizService.list(queryDTO);

        Map<String, List<DwdDischargeRecordVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdDischargeRecordVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 入院预约信息
    private Map<String, List<DwdInpatientReserveVO>> getDwdInpatientReserveVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.InpatientReserve.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdInpatientReserveQueryDTO queryDTO = new DwdInpatientReserveQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdInpatientReserveVO> voList = dwdInpatientReserveBizService.list(queryDTO);

        Map<String, List<DwdInpatientReserveVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdInpatientReserveVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 检查申请表
    private Map<String, List<DwdExamineApplyVO>> getDwdExamineApplyVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.ExamineApply.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdExamineApplyQueryDTO queryDTO = new DwdExamineApplyQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdExamineApplyVO> voList = dwdExamineApplyBizService.list(queryDTO);

        Map<String, List<DwdExamineApplyVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdExamineApplyVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 检验申请表
    private Map<String, List<DwdLaboratoryApplyVO>> getDwdLaboratoryApplyVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.LaboratoryApply.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdLaboratoryApplyQueryDTO queryDTO = new DwdLaboratoryApplyQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdLaboratoryApplyVO> voList = dwdLaboratoryApplyBizService.list(queryDTO);

        Map<String, List<DwdLaboratoryApplyVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdLaboratoryApplyVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 医嘱用药
    private Map<String, List<DwdRecipeMedicineVO>> getDwdRecipeMedicineVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.RecipeMedicine.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdRecipeMedicineQueryDTO queryDTO = new DwdRecipeMedicineQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdRecipeMedicineVO> voList = dwdRecipeMedicineBizService.list(queryDTO);

        Map<String, List<DwdRecipeMedicineVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdRecipeMedicineVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 手术申请
    private Map<String, List<DwdOperationApplyVO>> getDwdOperationApplyVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.OperationApply.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdOperationApplyQueryDTO queryDTO = new DwdOperationApplyQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdOperationApplyVO> voList = dwdOperationApplyBizService.list(queryDTO);

        Map<String, List<DwdOperationApplyVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdOperationApplyVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 检查预约
    private Map<String, List<DwdExamineReserveVO>> getDwdExamineReserveVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.ExamineReserve.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdExamineReserveQueryDTO queryDTO = new DwdExamineReserveQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdExamineReserveVO> voList = dwdExamineReserveBizService.list(queryDTO);

        Map<String, List<DwdExamineReserveVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdExamineReserveVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 检查报告单
    private Map<String, List<DwdExamineReportVO>> getDwdExamineReportVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.ExamineReport.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdExamineReportQueryDTO queryDTO = new DwdExamineReportQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdExamineReportVO> voList = dwdExamineReportBizService.list(queryDTO);

        Map<String, List<DwdExamineReportVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdExamineReportVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 检验报告单
    private Map<String, List<DwdLaboratoryReportVO>> getDwdLaboratoryReportVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.LaboratoryReport.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdLaboratoryReportQueryDTO queryDTO = new DwdLaboratoryReportQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdLaboratoryReportVO> voList = dwdLaboratoryReportBizService.list(queryDTO);

        Map<String, List<DwdLaboratoryReportVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdLaboratoryReportVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 手术记录
    private Map<String, List<DwdOperationRecordVO>> getDwdOperationRecordVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.OperationRecord.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdOperationRecordQueryDTO queryDTO = new DwdOperationRecordQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdOperationRecordVO> voList = dwdOperationRecordBizService.list(queryDTO);

        Map<String, List<DwdOperationRecordVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdOperationRecordVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 诊断信息
    private Map<String, List<DwdDiagnosisReportVO>> getDwdDiagnosisReportVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.DiagnosisReport.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdDiagnosisReportQueryDTO queryDTO = new DwdDiagnosisReportQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdDiagnosisReportVO> voList = dwdDiagnosisReportBizService.list(queryDTO);

        Map<String, List<DwdDiagnosisReportVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdDiagnosisReportVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 治疗信息
    private Map<String, List<DwdRecipeTherapyVO>> getDwdRecipeTherapyVOMap(DwdInpatientRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.RecipeTherapy.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdRecipeTherapyQueryDTO queryDTO = new DwdRecipeTherapyQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdRecipeTherapyVO> voList = dwdRecipeTherapyBizService.list(queryDTO);

        Map<String, List<DwdRecipeTherapyVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdRecipeTherapyVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 住院变更信息
    private Map<String, List<DwdInpatientChangeVO>> getDwdInpatientChangeVOMap(DwdInpatientRecordQueryDTO params, List<String> ids) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.InpatientChange.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdInpatientChangeQueryDTO queryDTO = new DwdInpatientChangeQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setInpatientIds(ids);
        List<DwdInpatientChangeVO> voList = dwdInpatientChangeBizService.list(queryDTO);

        Map<String, List<DwdInpatientChangeVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdInpatientChangeVO> vos = voMap.get(i.getInpatientId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getInpatientId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 患者首次病程信息
    private Map<String, List<OdsFirstCourseIllnessVO>> getOdsFirstCourseIllnessVOMap(DwdInpatientRecordQueryDTO params, List<String> ids) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.FirstCourseIllness.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        OdsFirstCourseIllnessQueryDTO queryDTO = new OdsFirstCourseIllnessQueryDTO();
        queryDTO.setIpIds(ids);
        List<OdsFirstCourseIllnessVO> voList = odsFirstCourseIllnessBizService.list(queryDTO);

        Map<String, List<OdsFirstCourseIllnessVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<OdsFirstCourseIllnessVO> vos = voMap.get(i.getIpId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getIpId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    @Override
    public List<DwdInpatientRecordVO> listByPatientId(String patientId) {
        List<DwdInpatientRecordInfo> data =  dwdInpatientRecordInfoService.list(new QueryWrapper<DwdInpatientRecordInfo>()
                .eq("patient_id",patientId)
        );
        return data.stream().map(PatientHealthyHelper::getDwdInpatientRecordVO).collect(Collectors.toList());
    }

    @Override
    public List<DwdInpatientRecordVO> listByPatientId(List<String> patientIds) {
        List<DwdInpatientRecordInfo> data =  dwdInpatientRecordInfoService.list(new QueryWrapper<DwdInpatientRecordInfo>()
                .in("patient_id",patientIds)
        );
        return data.stream().map(PatientHealthyHelper::getDwdInpatientRecordVO).collect(Collectors.toList());
    }

    @Override
    public DwdInpatientRecordVO getById(String id) {
        DwdInpatientRecordInfo entity = dwdInpatientRecordInfoService.getById(id);
        return PatientHealthyHelper.getDwdInpatientRecordVO(entity);
    }

    @Override
    public List<DwdInpatientRecordInfo> listBeanByPatient(String patientId) {
        List<DwdInpatientRecordInfo> data =  dwdInpatientRecordInfoService.list(new QueryWrapper<DwdInpatientRecordInfo>()
                .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwdInpatientRecordInfo> listBeanByPatient(List<String> patientIds) {
        List<DwdInpatientRecordInfo> data =  dwdInpatientRecordInfoService.list(new QueryWrapper<DwdInpatientRecordInfo>()
                .in("patient_id",patientIds)
        );
        return data;
    }

    @Override
    public List<DwdInpatientRecordVO> simpleList(DwdInpatientRecordQueryDTO params) {
        log.info("DwdInpatientRecordBizServiceImpl.simpleList::params >>>>>> {}", JSON.toJSONString(params));

        List<DwdInpatientRecordInfo> data =  dwdInpatientRecordInfoService.list(new QueryWrapper<DwdInpatientRecordInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .ge(StrUtil.isNotBlank(params.getStartDate()), "inpatient_date", params.getStartDate())
                .le(StrUtil.isNotBlank(params.getEndDate()), "inpatient_date", params.getEndDate())
                .orderByDesc("inpatient_date")
                .last(StrUtil.isNotBlank(params.getStartDate()) && StrUtil.isBlank(params.getEndDate()) && params.getRows() > 0, " limit " + params.getRows()) // 以开始时间为条件查询固定条数数据（伪分页），可能问题：相同时间数据如果在不同页中，查询数据会有重叠
        );

        return data.stream().map(PatientHealthyHelper::getDwdInpatientRecordVO).collect(Collectors.toList());
    }

    @Override
    public List<DwdInpatientRecordVO> simpleList2(DwdInpatientRecordQueryDTO params) {
        log.info("DwdInpatientRecordBizServiceImpl.simpleList2::params >>>>>> {}", JSON.toJSONString(params));
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(DateUtil.parseDate(params.getEndDate()), 1).toDateStr());
        }

        List<DwdInpatientRecordInfo> data =  dwdInpatientRecordInfoService.list(new QueryWrapper<DwdInpatientRecordInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .ge(StrUtil.isNotBlank(params.getStartDate()), "inpatient_date", params.getStartDate())
                .lt(StrUtil.isNotBlank(params.getEndDate()), "inpatient_date", params.getEndDate())
                .orderByDesc("inpatient_date")
                .last(" limit 1000 ") // TODO 防止不传参数查询所有导致爆库
        );

        return data.stream().map(PatientHealthyHelper::getDwdInpatientRecordVO).collect(Collectors.toList());
    }

}
