package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdOperationApplyItemInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdOperationApplyItemInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdOperationApplyItemQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdOperationApplyItemVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.helper.PatientHealthyHelper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdOperationApplyItemBizService;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@DS("wd")
@Service
public class DwdOperationApplyItemBizServiceImpl implements DwdOperationApplyItemBizService {

    @Autowired
    private DwdOperationApplyItemInfoService dwdOperationApplyItemInfoService;

    @Override
    public List<DwdOperationApplyItemVO> list(DwdOperationApplyItemQueryDTO params) {
        List<DwdOperationApplyItemInfo> data = dwdOperationApplyItemInfoService.list(new QueryWrapper<DwdOperationApplyItemInfo>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .eq(StrUtil.isNotBlank(params.getOperationApplyId()), "operation_apply_id", params.getOperationApplyId())
                .in(CollectionUtil.isNotEmpty(params.getOperationApplyIds()), "operation_apply_id", params.getOperationApplyIds())
                .eq(StrUtil.isNotBlank(params.getVisitId()), "visit_id", params.getVisitId())
                .in(CollectionUtil.isNotEmpty(params.getVisitIds()), "visit_id", params.getVisitIds())
        );
        return data.stream().map(PatientHealthyHelper::getDwdOperationApplyItemVO).collect(Collectors.toList());
    }

    @Override
    public List<DwdOperationApplyItemVO> listByPatientId(String patientId) {
        List<DwdOperationApplyItemInfo> data = dwdOperationApplyItemInfoService.list(new QueryWrapper<DwdOperationApplyItemInfo>()
                .eq("patient_id",patientId)
        );
        return data.stream().map(PatientHealthyHelper::getDwdOperationApplyItemVO).collect(Collectors.toList());
    }

    @Override
    public List<DwdOperationApplyItemVO> listByPatientId(List<String> patientIds) {
        List<DwdOperationApplyItemInfo> data = dwdOperationApplyItemInfoService.list(new QueryWrapper<DwdOperationApplyItemInfo>()
                .in("patient_id",patientIds)
        );
        return data.stream().map(PatientHealthyHelper::getDwdOperationApplyItemVO).collect(Collectors.toList());
    }

    @Override
    public DwdOperationApplyItemVO getById(String id) {
        DwdOperationApplyItemInfo entity = dwdOperationApplyItemInfoService.getById(id);
        return PatientHealthyHelper.getDwdOperationApplyItemVO(entity);
    }

    @Override
    public List<DwdOperationApplyItemInfo> listBeanByPatient(String patientId) {
        List<DwdOperationApplyItemInfo> data = dwdOperationApplyItemInfoService.list(new QueryWrapper<DwdOperationApplyItemInfo>()
                .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwdOperationApplyItemInfo> listBeanByPatient(List<String> patientIds) {
        List<DwdOperationApplyItemInfo> data = dwdOperationApplyItemInfoService.list(new QueryWrapper<DwdOperationApplyItemInfo>()
                .in("patient_id",patientIds)
        );
        return data;
    }

}
