package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import java.util.List;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdPatientEmrBodyCheckBasicInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdPatientEmrSymptomInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdPatientMedicalRecordInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdPatientEmrBodyCheckBasicInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdPatientEmrSymptomInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdPatientEmrBodyCheckBasicVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdPatientEmrSymptomVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdPatientMedicalRecordInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdPatientMedicalRecordGetDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdPatientMedicalRecordQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdPatientMedicalRecordVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdPatientMedicalRecordBizService;
import com.xxh.cloud.framework.common.page.PageData;

/**
 * <p>
 * DWD电子病例内容信息表
 * </p>
 */
@Service
public class DwdPatientMedicalRecordBizServiceImpl implements DwdPatientMedicalRecordBizService {

    @Autowired
    private DwdPatientMedicalRecordInfoService dwdPatientMedicalRecordInfoService;

    @Autowired
    private DwdPatientEmrBodyCheckBasicInfoService dwdPatientEmrBodyCheckBasicInfoService;

    @Autowired
    private DwdPatientEmrSymptomInfoService dwdPatientEmrSymptomInfoService;





    @Override
    public PageData<DwdPatientMedicalRecordVO> query(DwdPatientMedicalRecordQueryDTO params) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'query'");
    }

    @Override
    public List<DwdPatientMedicalRecordVO> list(DwdPatientMedicalRecordQueryDTO params) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'list'");
    }

    @Override
    public DwdPatientMedicalRecordVO detail(DwdPatientMedicalRecordGetDTO params) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'detail'");
    }

    @Override
    public List<DwdPatientMedicalRecordVO> listMedicalByPatient(String patientId) {
        throw new UnsupportedOperationException("Unimplemented method 'detail'");
    }


    @Override
    public List<DwdPatientEmrSymptomVO> listSymptomByPatient(String patientId) {
        throw new UnsupportedOperationException("Unimplemented method 'detail'");
    }

    @Override
    public List<DwdPatientEmrBodyCheckBasicVO> listCheckBasicByPatient(String patientId) {
        throw new UnsupportedOperationException("Unimplemented method 'detail'");
    }

    @Override
    public List<DwdPatientMedicalRecordInfo> listMedical2ByPatient(String patientId) {
        if(StrUtil.isEmpty(patientId)){
            return null;
        }
        List<DwdPatientMedicalRecordInfo> list= dwdPatientMedicalRecordInfoService.list(
                new QueryWrapper<DwdPatientMedicalRecordInfo>()
                        .eq("patient_id",patientId)
        );
        return list;
    }

    @Override
    public List<DwdPatientEmrSymptomInfo> listSymptom2ByPatient(String patientId) {
        if(StrUtil.isEmpty(patientId)){
            return null;
        }
        List<DwdPatientEmrSymptomInfo> list= dwdPatientEmrSymptomInfoService.list(
                new QueryWrapper<DwdPatientEmrSymptomInfo>()
                        .eq("patient_id",patientId)
        );
        return list;
    }

    @Override
    public List<DwdPatientEmrBodyCheckBasicInfo> listCheckBasic2ByPatient(String patientId) {
        if(StrUtil.isEmpty(patientId)){
            return null;
        }
        List<DwdPatientEmrBodyCheckBasicInfo> list = dwdPatientEmrBodyCheckBasicInfoService.list(
                new QueryWrapper<DwdPatientEmrBodyCheckBasicInfo>()
                        .eq("patient_id",patientId)
        );
        return list;
    }

    @Override
    public List<DwdPatientMedicalRecordInfo> listMedical2ByPatients(List<String> patientIds) {
        if(CollUtil.isEmpty(patientIds)){
            return null;
        }
        List<DwdPatientMedicalRecordInfo> list= dwdPatientMedicalRecordInfoService.list(
                new QueryWrapper<DwdPatientMedicalRecordInfo>()
                        .in("patient_id",patientIds)
        );
        return list;
    }

    @Override
    public List<DwdPatientEmrSymptomInfo> listSymptom2ByPatients(List<String> patientIds) {
        if(CollUtil.isEmpty(patientIds)){
            return null;
        }
        List<DwdPatientEmrSymptomInfo> list= dwdPatientEmrSymptomInfoService.list(
                new QueryWrapper<DwdPatientEmrSymptomInfo>()
                        .in("patient_id",patientIds)
        );
        return list;
    }

    @Override
    public List<DwdPatientEmrBodyCheckBasicInfo> listCheckBasic2ByPatients(List<String> patientIds) {
        if(CollUtil.isEmpty(patientIds)){
            return null;
        }
        List<DwdPatientEmrBodyCheckBasicInfo> list = dwdPatientEmrBodyCheckBasicInfoService.list(
                new QueryWrapper<DwdPatientEmrBodyCheckBasicInfo>()
                        .in("patient_id",patientIds)
        );
        return list;
    }


}
