package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdExamineApplyInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdRecipePathologyApplyInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdRecipePathologyApplyInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdRecipePathologyApplyBizService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@DS("wd")
@Service
public class DwdRecipePathologyApplyBizServiceImpl implements DwdRecipePathologyApplyBizService {


    @Autowired
    private DwdRecipePathologyApplyInfoService dwdRecipePathologyApplyInfoService;


    @Override
    public List<DwdRecipePathologyApplyInfo> listByPatientId(String patientId) {
        List<DwdRecipePathologyApplyInfo> data = dwdRecipePathologyApplyInfoService.list(
                new QueryWrapper<DwdRecipePathologyApplyInfo>()
                        .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwdRecipePathologyApplyInfo> listByPatientId(List<String> patientIds) {
        List<DwdRecipePathologyApplyInfo> data = dwdRecipePathologyApplyInfoService.list(
                new QueryWrapper<DwdRecipePathologyApplyInfo>()
                        .in("patient_id",patientIds)
        );
        return data;
    }

    @Override
    public DwdRecipePathologyApplyInfo getById(String id) {
        return dwdRecipePathologyApplyInfoService.getById(id);
    }
}
