package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdRecipePathologyApplyInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdRecipePathologyApplyProjectInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdRecipePathologyApplyProjectInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdRecipePathologyApplyProjectBizService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@DS("wd")
@Service
public class DwdRecipePathologyApplyProjectBizServiceImpl implements DwdRecipePathologyApplyProjectBizService {

    @Autowired
    private DwdRecipePathologyApplyProjectInfoService dwdRecipePathologyApplyProjectInfoService;



    @Override
    public List<DwdRecipePathologyApplyProjectInfo> listByPatientId(String patientId) {
        List<DwdRecipePathologyApplyProjectInfo> data = dwdRecipePathologyApplyProjectInfoService.list(
                new QueryWrapper<DwdRecipePathologyApplyProjectInfo>()
                        .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwdRecipePathologyApplyProjectInfo> listByPatientId(List<String> patientIds) {
        List<DwdRecipePathologyApplyProjectInfo> data = dwdRecipePathologyApplyProjectInfoService.list(
                new QueryWrapper<DwdRecipePathologyApplyProjectInfo>()
                        .in("patient_id",patientIds)
        );
        return data;
    }

    @Override
    public DwdRecipePathologyApplyProjectInfo getById(String id) {
        return dwdRecipePathologyApplyProjectInfoService.getById(id);
    }

}
