package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdRecipePathologyReportInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdRecipePathologyReportInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdRecipePathologyReportBizService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@DS("wd")
@Service
public class DwdRecipePathologyReportBizServiceImpl implements DwdRecipePathologyReportBizService {

    @Autowired
    private DwdRecipePathologyReportInfoService dwdRecipePathologyReportInfoService;

    @Override
    public List<DwdRecipePathologyReportInfo> listByPatientId(String patientId) {
        List<DwdRecipePathologyReportInfo> data = dwdRecipePathologyReportInfoService.list(
                new QueryWrapper<DwdRecipePathologyReportInfo>()
                        .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwdRecipePathologyReportInfo> listByPatientIds(List<String> patientIds) {
        List<DwdRecipePathologyReportInfo> data = dwdRecipePathologyReportInfoService.list(
                new QueryWrapper<DwdRecipePathologyReportInfo>()
                        .in("patient_id",patientIds)
        );
        return data;
    }

    @Override
    public DwdRecipePathologyReportInfo getById(String id) {
        return dwdRecipePathologyReportInfoService.getById(id);
    }
}
