package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdRegisterRecordInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdRegisterRecordInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdRegisterRecordQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdRegisterRecordVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.helper.PatientHealthyHelper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdRegisterRecordBizService;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@DS("wd")
@Service
public class DwdRegisterRecordBizServiceImpl implements DwdRegisterRecordBizService {

    @Autowired
    private DwdRegisterRecordInfoService dwdRegisterRecordInfoService;

    @Override
    public List<DwdRegisterRecordVO> list(DwdRegisterRecordQueryDTO params) {
        List<DwdRegisterRecordInfo> data =  dwdRegisterRecordInfoService.list(new QueryWrapper<DwdRegisterRecordInfo>()
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
        );
        return data.stream().map(PatientHealthyHelper::getDwdRegisterRecordVO).collect(Collectors.toList());
    }

    @Override
    public List<DwdRegisterRecordVO> listByPatientId(String patientId) {
        List<DwdRegisterRecordInfo> data =  dwdRegisterRecordInfoService.list(new QueryWrapper<DwdRegisterRecordInfo>()
                .eq("patient_id",patientId)
        );
        return data.stream().map(PatientHealthyHelper::getDwdRegisterRecordVO).collect(Collectors.toList());
    }

    @Override
    public List<DwdRegisterRecordVO> listByPatientId(List<String> patientIds) {
        List<DwdRegisterRecordInfo> data =  dwdRegisterRecordInfoService.list(new QueryWrapper<DwdRegisterRecordInfo>()
                .in("patient_id",patientIds)
        );
        return data.stream().map(PatientHealthyHelper::getDwdRegisterRecordVO).collect(Collectors.toList());
    }

    @Override
    public DwdRegisterRecordVO getById(String id) {
        DwdRegisterRecordInfo entity = dwdRegisterRecordInfoService.getById(id);
        return PatientHealthyHelper.getDwdRegisterRecordVO(entity);
    }

    @Override
    public List<DwdRegisterRecordInfo> listBeanByPatientId(String patientId) {
        List<DwdRegisterRecordInfo> data =  dwdRegisterRecordInfoService.list(new QueryWrapper<DwdRegisterRecordInfo>()
                .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwdRegisterRecordInfo> listBeanByPatientId(List<String> patientIds) {
        List<DwdRegisterRecordInfo> data =  dwdRegisterRecordInfoService.list(new QueryWrapper<DwdRegisterRecordInfo>()
                .in("patient_id",patientIds)
        );
        return data;
    }

}
