package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.alibaba.fastjson2.JSON;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxh.cloud.dw.healthy.data.client.api.constant.DwdConstant;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.DwdVisitRecordInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.DwdVisitRecordInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdDiagnosisReportQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdExamineApplyQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdExamineReportQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdExamineReserveQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdLaboratoryApplyQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdLaboratoryReportQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdOperationApplyQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdOperationRecordQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdRecipeMedicineQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdRecipeTherapyQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdRegisterRecordQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.DwdVisitRecordQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.OdsPatientPastHisQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdDiagnosisReportVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdExamineApplyVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdExamineReportVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdExamineReserveVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdLaboratoryApplyVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdLaboratoryReportVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdOperationApplyVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdOperationRecordVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdRecipeMedicineVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdRecipeTherapyVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdRegisterRecordVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.DwdVisitRecordVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.OdsPatientPastHisVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.helper.PatientHealthyHelper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdDiagnosisReportBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdExamineApplyBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdExamineReportBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdExamineReserveBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdLaboratoryApplyBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdLaboratoryReportBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdOperationApplyBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdOperationRecordBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdRecipeMedicineBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdRecipeTherapyBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdRegisterRecordBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.DwdVisitRecordBizService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.OdsPatientPastHisBizService;
import com.xxh.cloud.framework.common.constant.YN;
import com.xxh.cloud.framework.common.mybatisplus.page.PageConverter;
import com.xxh.cloud.framework.common.page.PageData;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@DS("wd")
@Slf4j
@Service
public class DwdVisitRecordBizServiceImpl implements DwdVisitRecordBizService {

    @Autowired
    private DwdVisitRecordInfoService dwdVisitRecordInfoService;
    @Autowired
    private DwdExamineApplyBizService dwdExamineApplyBizService;
    @Autowired
    private DwdLaboratoryApplyBizService dwdLaboratoryApplyBizService;
    @Autowired
    private DwdRecipeMedicineBizService dwdRecipeMedicineBizService;
    @Autowired
    private DwdRegisterRecordBizService dwdRegisterRecordBizService;
    @Autowired
    private DwdExamineReserveBizService dwdExamineReserveBizService;
    @Autowired
    private DwdExamineReportBizService dwdExamineReportBizService;
    @Autowired
    private DwdLaboratoryReportBizService dwdLaboratoryReportBizService;
    @Autowired
    private DwdOperationApplyBizService dwdOperationApplyBizService;
    @Autowired
    private DwdOperationRecordBizService dwdOperationRecordBizService;
    @Autowired
    private DwdDiagnosisReportBizService dwdDiagnosisReportBizService;
    @Autowired
    private DwdRecipeTherapyBizService dwdRecipeTherapyBizService;
    @Autowired
    private OdsPatientPastHisBizService odsPatientPastHisBizService;

    /**
     * zs20231027 患者健康档案(就诊)分页查询
     */
    @Override
    public PageData<DwdVisitRecordVO> page(DwdVisitRecordQueryDTO params) {
        log.info("DwdVisitRecordBizServiceImpl.page::params >>>>>> {}", JSON.toJSONString(params));
        // 查询就诊信息（门诊、急诊）
        IPage<DwdVisitRecordInfo> page =  dwdVisitRecordInfoService.page(new Page<>(params.getPage(), params.getRows()), new QueryWrapper<DwdVisitRecordInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .ge(StrUtil.isNotBlank(params.getStartDate()), "visit_date", params.getStartDate())
                .le(StrUtil.isNotBlank(params.getEndDate()), "visit_date", params.getEndDate())
                .orderByDesc("visit_date")
        );

        List<DwdVisitRecordVO> list = page.getRecords().stream().map(PatientHealthyHelper::getDwdVisitRecordVO).collect(Collectors.toList());

        if (CollectionUtil.isNotEmpty(list)) {
            // List<String> visitIds = new ArrayList<>();
            List<String> registerIds = new ArrayList<>();
            list.forEach(i -> {
                // visitIds.add(i.getId());
                registerIds.add(i.getRegisterId());
            });
            // 医嘱
            // 1.检查申请表
            Map<String, List<DwdExamineApplyVO>> dwdExamineApplyVOMap = this.getDwdExamineApplyVOMap(params, registerIds);
            // 2.检验申请表
            Map<String, List<DwdLaboratoryApplyVO>> dwdLaboratoryApplyVOMap = this.getDwdLaboratoryApplyVOMap(params, registerIds);
            // 3.医嘱用药
            Map<String, List<DwdRecipeMedicineVO>> dwdRecipeMedicineVOMap = this.getDwdRecipeMedicineVOMap(params, registerIds);
            // 4.手术申请
            Map<String, List<DwdOperationApplyVO>> dwdOperationApplyVOMap = this.getDwdOperationApplyVOMap(params, registerIds);

            // 预约记录
            // 1.预约挂号
            Map<String, List<DwdRegisterRecordVO>> dwdRegisterRecordVOMap = this.getDwdRegisterRecordVOMap(params, registerIds);
            // 2.检查预约
            Map<String, List<DwdExamineReserveVO>> dwdExamineReserveVOMap = this.getDwdExamineReserveVOMap(params, registerIds);

            // 报告
            // 1.检查报告单
            Map<String, List<DwdExamineReportVO>> dwdExamineReportVOMap = this.getDwdExamineReportVOMap(params, registerIds);
            // 2.检验报告单
            Map<String, List<DwdLaboratoryReportVO>> dwdLaboratoryReportVOMap = this.getDwdLaboratoryReportVOMap(params, registerIds);

            // 手术记录
            Map<String, List<DwdOperationRecordVO>> dwdOperationRecordVOMap = this.getDwdOperationRecordVOMap(params, registerIds);

            // 治疗信息
            Map<String, List<DwdRecipeTherapyVO>> dwdRecipeTherapyVOMap = this.getDwdRecipeTherapyVOMap(params, registerIds);

            list.forEach(i -> {
                i.setDwdExamineApplyVOs(dwdExamineApplyVOMap.get(i.getRegisterId()));
                i.setDwdLaboratoryApplyVOs(dwdLaboratoryApplyVOMap.get(i.getRegisterId()));
                i.setDwdRecipeMedicineVOs(dwdRecipeMedicineVOMap.get(i.getRegisterId()));
                i.setDwdOperationApplyVOs(dwdOperationApplyVOMap.get(i.getRegisterId()));

                i.setDwdRegisterRecordVOs(dwdRegisterRecordVOMap.get(i.getRegisterId()));
                i.setDwdExamineReserveVOs(dwdExamineReserveVOMap.get(i.getRegisterId()));

                i.setDwdExamineReportVOs(dwdExamineReportVOMap.get(i.getRegisterId()));
                i.setDwdLaboratoryReportVOs(dwdLaboratoryReportVOMap.get(i.getRegisterId()));

                i.setDwdOperationRecordVOs(dwdOperationRecordVOMap.get(i.getRegisterId()));

                i.setDwdRecipeTherapyVOs(dwdRecipeTherapyVOMap.get(i.getRegisterId()));
            });
        }

        PageData<DwdVisitRecordVO> data = new PageConverter<DwdVisitRecordVO, DwdVisitRecordVO>() {
            @Override
            public DwdVisitRecordVO converter(DwdVisitRecordVO vo) {
                return vo;
            }
        }.getPageData(list, page.getTotal(), page.getSize(), page.getPages());
        return data;
    }

    @Override
    public List<DwdVisitRecordVO> list(DwdVisitRecordQueryDTO params) {
        log.info("DwdVisitRecordBizServiceImpl.list::params >>>>>> {}", JSON.toJSONString(params));

        List<DwdVisitRecordInfo> data =  dwdVisitRecordInfoService.list(new QueryWrapper<DwdVisitRecordInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .ge(StrUtil.isNotBlank(params.getStartDate()), "visit_date", params.getStartDate())
                .le(StrUtil.isNotBlank(params.getEndDate()), "visit_date", params.getEndDate())
                .eq((StrUtil.isNotBlank(params.getIsDept()) && YN.YES.getCode().equals(params.getIsDept())) && StrUtil.isNotBlank(params.getDeptId()), "department_code_standard", params.getDeptId()) // 查询指定部门的数据
                .ne((StrUtil.isNotBlank(params.getIsDept()) && YN.NO.getCode().equals(params.getIsDept())) && StrUtil.isNotBlank(params.getDeptId()), "department_code_standard", params.getDeptId()) // 过滤指定部门的数据
                .orderByDesc("visit_date")
        );

        List<DwdVisitRecordVO> list = data.stream().map(PatientHealthyHelper::getDwdVisitRecordVO).collect(Collectors.toList());
        
        if (CollectionUtil.isNotEmpty(list)) {
            // List<String> visitIds = new ArrayList<>(); // 都是挂号id关联
            List<String> registerIds = new ArrayList<>();
            list.forEach(i -> {
                // visitIds.add(i.getId());
                registerIds.add(i.getRegisterId());
            });
            // 医嘱
            // 1.检查申请表
            Map<String, List<DwdExamineApplyVO>> dwdExamineApplyVOMap = this.getDwdExamineApplyVOMap(params, registerIds);
            // 2.检验申请表
            Map<String, List<DwdLaboratoryApplyVO>> dwdLaboratoryApplyVOMap = this.getDwdLaboratoryApplyVOMap(params, registerIds);
            // 3.医嘱用药
            Map<String, List<DwdRecipeMedicineVO>> dwdRecipeMedicineVOMap = this.getDwdRecipeMedicineVOMap(params, registerIds);
            // 4.手术申请
            Map<String, List<DwdOperationApplyVO>> dwdOperationApplyVOMap = this.getDwdOperationApplyVOMap(params, registerIds);

            // 预约记录
            // 1.预约挂号
            Map<String, List<DwdRegisterRecordVO>> dwdRegisterRecordVOMap = this.getDwdRegisterRecordVOMap(params, registerIds);
            // 2.检查预约
            Map<String, List<DwdExamineReserveVO>> dwdExamineReserveVOMap = this.getDwdExamineReserveVOMap(params, registerIds);

            // 报告
            // 1.检查报告单
            Map<String, List<DwdExamineReportVO>> dwdExamineReportVOMap = this.getDwdExamineReportVOMap(params, registerIds);
            // 2.检验报告单
            Map<String, List<DwdLaboratoryReportVO>> dwdLaboratoryReportVOMap = this.getDwdLaboratoryReportVOMap(params, registerIds);

            // 手术记录
            Map<String, List<DwdOperationRecordVO>> dwdOperationRecordVOMap = this.getDwdOperationRecordVOMap(params, registerIds);
            
            // 诊断信息
            Map<String, List<DwdDiagnosisReportVO>> dwdDiagnosisReportVOMap = this.getDwdDiagnosisReportVOMap(params, registerIds);

            // 治疗信息
            Map<String, List<DwdRecipeTherapyVO>> dwdRecipeTherapyVOMap = this.getDwdRecipeTherapyVOMap(params, registerIds);

            // 患者既往史
            Map<String, List<OdsPatientPastHisVO>> odsPatientPastHisVOMap = this.getOdsPatientPastHisVOMap(params, registerIds);

            list.forEach(i -> {
                i.setDwdExamineApplyVOs(dwdExamineApplyVOMap.get(i.getRegisterId()));
                i.setDwdLaboratoryApplyVOs(dwdLaboratoryApplyVOMap.get(i.getRegisterId()));
                i.setDwdRecipeMedicineVOs(dwdRecipeMedicineVOMap.get(i.getRegisterId()));
                i.setDwdOperationApplyVOs(dwdOperationApplyVOMap.get(i.getRegisterId()));

                i.setDwdRegisterRecordVOs(dwdRegisterRecordVOMap.get(i.getRegisterId()));
                i.setDwdExamineReserveVOs(dwdExamineReserveVOMap.get(i.getRegisterId()));

                i.setDwdExamineReportVOs(dwdExamineReportVOMap.get(i.getRegisterId()));
                i.setDwdLaboratoryReportVOs(dwdLaboratoryReportVOMap.get(i.getRegisterId()));

                i.setDwdOperationRecordVOs(dwdOperationRecordVOMap.get(i.getRegisterId()));

                i.setDwdDiagnosisReportVOs(dwdDiagnosisReportVOMap.get(i.getRegisterId()));

                i.setDwdRecipeTherapyVOs(dwdRecipeTherapyVOMap.get(i.getRegisterId()));

                List<OdsPatientPastHisVO> odsPatientPastHisList = odsPatientPastHisVOMap.get(i.getRegisterId());
                if (CollectionUtil.isNotEmpty(odsPatientPastHisList)) {
                    OdsPatientPastHisVO odsPatientPastHisVO = null;
                    Long flag = null;
                    for (OdsPatientPastHisVO vo : odsPatientPastHisList) {
                        if (null != i.getVisitDate() && null != vo.getTreatDate()) {
                            Long l = Math.abs(i.getVisitDate().getTime() - vo.getTreatDate().getTime());
                            if (null != flag && flag < l) {
                                continue;
                            }
                            flag = l;
                            odsPatientPastHisVO = vo;
                        }
                    }
                    i.setOdsPatientPastHisVOs(odsPatientPastHisVO);
                }
            });
        }

        return list;
    }

    // 检查申请表
    private Map<String, List<DwdExamineApplyVO>> getDwdExamineApplyVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.ExamineApply.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdExamineApplyQueryDTO queryDTO = new DwdExamineApplyQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdExamineApplyVO> voList = dwdExamineApplyBizService.list(queryDTO);

        Map<String, List<DwdExamineApplyVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdExamineApplyVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 检验申请表
    private Map<String, List<DwdLaboratoryApplyVO>> getDwdLaboratoryApplyVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.LaboratoryApply.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdLaboratoryApplyQueryDTO queryDTO = new DwdLaboratoryApplyQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdLaboratoryApplyVO> voList = dwdLaboratoryApplyBizService.list(queryDTO);

        Map<String, List<DwdLaboratoryApplyVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdLaboratoryApplyVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 医嘱用药
    private Map<String, List<DwdRecipeMedicineVO>> getDwdRecipeMedicineVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.RecipeMedicine.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdRecipeMedicineQueryDTO queryDTO = new DwdRecipeMedicineQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdRecipeMedicineVO> voList = dwdRecipeMedicineBizService.list(queryDTO);

        Map<String, List<DwdRecipeMedicineVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdRecipeMedicineVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 手术申请
    private Map<String, List<DwdOperationApplyVO>> getDwdOperationApplyVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.OperationApply.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdOperationApplyQueryDTO queryDTO = new DwdOperationApplyQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdOperationApplyVO> voList = dwdOperationApplyBizService.list(queryDTO);

        Map<String, List<DwdOperationApplyVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdOperationApplyVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 挂号
    private Map<String, List<DwdRegisterRecordVO>> getDwdRegisterRecordVOMap(DwdVisitRecordQueryDTO params, List<String> registerIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.RegisterRecord.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdRegisterRecordQueryDTO queryDTO = new DwdRegisterRecordQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setIds(registerIds);
        List<DwdRegisterRecordVO> voList = dwdRegisterRecordBizService.list(queryDTO);

        Map<String, List<DwdRegisterRecordVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdRegisterRecordVO> vos = voMap.get(i.getId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 检查预约
    private Map<String, List<DwdExamineReserveVO>> getDwdExamineReserveVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.ExamineReserve.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdExamineReserveQueryDTO queryDTO = new DwdExamineReserveQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdExamineReserveVO> voList = dwdExamineReserveBizService.list(queryDTO);

        Map<String, List<DwdExamineReserveVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdExamineReserveVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 检查报告单
    private Map<String, List<DwdExamineReportVO>> getDwdExamineReportVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.ExamineReport.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdExamineReportQueryDTO queryDTO = new DwdExamineReportQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdExamineReportVO> voList = dwdExamineReportBizService.list(queryDTO);

        Map<String, List<DwdExamineReportVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdExamineReportVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 检验报告单
    private Map<String, List<DwdLaboratoryReportVO>> getDwdLaboratoryReportVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.LaboratoryReport.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdLaboratoryReportQueryDTO queryDTO = new DwdLaboratoryReportQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdLaboratoryReportVO> voList = dwdLaboratoryReportBizService.list(queryDTO);

        Map<String, List<DwdLaboratoryReportVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdLaboratoryReportVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 手术记录
    private Map<String, List<DwdOperationRecordVO>> getDwdOperationRecordVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.OperationRecord.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdOperationRecordQueryDTO queryDTO = new DwdOperationRecordQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdOperationRecordVO> voList = dwdOperationRecordBizService.list(queryDTO);

        Map<String, List<DwdOperationRecordVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdOperationRecordVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 诊断信息
    private Map<String, List<DwdDiagnosisReportVO>> getDwdDiagnosisReportVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.DiagnosisReport.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdDiagnosisReportQueryDTO queryDTO = new DwdDiagnosisReportQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdDiagnosisReportVO> voList = dwdDiagnosisReportBizService.list(queryDTO);

        Map<String, List<DwdDiagnosisReportVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdDiagnosisReportVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 治疗信息
    private Map<String, List<DwdRecipeTherapyVO>> getDwdRecipeTherapyVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.RecipeTherapy.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        DwdRecipeTherapyQueryDTO queryDTO = new DwdRecipeTherapyQueryDTO();
        queryDTO.setPatientId(params.getPatientId());
        queryDTO.setPatientIds(params.getPatientIds());
        queryDTO.setVisitIds(visitIds);
        List<DwdRecipeTherapyVO> voList = dwdRecipeTherapyBizService.list(queryDTO);

        Map<String, List<DwdRecipeTherapyVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<DwdRecipeTherapyVO> vos = voMap.get(i.getVisitId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getVisitId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    // 既往史信息
    private Map<String, List<OdsPatientPastHisVO>> getOdsPatientPastHisVOMap(DwdVisitRecordQueryDTO params, List<String> visitIds) {
        if (StrUtil.isNotBlank(params.getDataType()) && !DwdConstant.DataTypeEnum.PastHis.getCode().equals(params.getDataType())) {
            return new HashMap<>(0);
        }

        OdsPatientPastHisQueryDTO queryDTO = new OdsPatientPastHisQueryDTO();
        queryDTO.setRegisterIds(visitIds);
        List<OdsPatientPastHisVO> voList = odsPatientPastHisBizService.list(queryDTO);

        Map<String, List<OdsPatientPastHisVO>> voMap = new HashMap<>();
        if (CollectionUtil.isNotEmpty(voList)) {
            voList.forEach(i -> {
                List<OdsPatientPastHisVO> vos = voMap.get(i.getRegisterId());
                if (null == vos) {
                    vos = new ArrayList<>();
                    voMap.put(i.getRegisterId(), vos);
                }
                vos.add(i);
            });
        }
        return voMap;
    }

    @Override
    public List<DwdVisitRecordVO> listByPatient(String patientId) {
        List<DwdVisitRecordInfo> data =  dwdVisitRecordInfoService.list(new QueryWrapper<DwdVisitRecordInfo>()
                .eq("patient_id",patientId)
                .orderByDesc("visit_date")
        );
        return data.stream().map(PatientHealthyHelper::getDwdVisitRecordVO).collect(Collectors.toList());
    }

    @Override
    public List<DwdVisitRecordVO> listByPatient(List<String> patientIds) {
        List<DwdVisitRecordInfo> data =  dwdVisitRecordInfoService.list(new QueryWrapper<DwdVisitRecordInfo>()
                .in("patient_id",patientIds)
        );
        return data.stream().map(PatientHealthyHelper::getDwdVisitRecordVO).collect(Collectors.toList());
    }

    @Override
    public DwdVisitRecordVO getById(String id) {
        DwdVisitRecordInfo entity = dwdVisitRecordInfoService.getById(id);
        return PatientHealthyHelper.getDwdVisitRecordVO(entity);
    }

    @Override
    public List<DwdVisitRecordInfo> listBeanByPatient(String patientId) {
        //todo:
        List<DwdVisitRecordInfo> data =  dwdVisitRecordInfoService.list(new QueryWrapper<DwdVisitRecordInfo>()
                .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwdVisitRecordInfo> listBeanByPatient(List<String> patientIds) {
        //todo:
        List<DwdVisitRecordInfo> data =  dwdVisitRecordInfoService.list(new QueryWrapper<DwdVisitRecordInfo>()
                .in("patient_id",patientIds)
        );
        return data;
    }

    @Override
    public List<DwdVisitRecordVO> simpleList(DwdVisitRecordQueryDTO params) {
        log.info("DwdVisitRecordBizServiceImpl.simpleList::params >>>>>> {}", JSON.toJSONString(params));
        if (null != params.getEndDate()) {
            params.setEndDate(DateUtil.offsetDay(DateUtil.parseDate(params.getEndDate()), 1).toDateStr());
        }

        List<DwdVisitRecordInfo> data =  dwdVisitRecordInfoService.list(new QueryWrapper<DwdVisitRecordInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .ge(StrUtil.isNotBlank(params.getStartDate()), "visit_date", params.getStartDate())
                .lt(StrUtil.isNotBlank(params.getEndDate()), "visit_date", params.getEndDate())
                .orderByDesc("visit_date")
                .last(" limit 1000 ") // TODO 防止不传参数查询所有导致爆库
        );

        return data.stream().map(PatientHealthyHelper::getDwdVisitRecordVO).collect(Collectors.toList());
    }

}
