package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.OdsExaminationFinalReportInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.OdsExaminationFinalReportInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.OdsExaminationFinalReportQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.OdsExaminationFinalReportVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.helper.PatientHealthyHelper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.OdsExaminationFinalReportBizService;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@DS("wd")
@Slf4j
@Service
public class OdsExaminationFinalReportBizServiceImpl implements OdsExaminationFinalReportBizService {
    
    @Autowired
    private OdsExaminationFinalReportInfoService odsExaminationFinalReportInfoService;

    @Override
    public List<OdsExaminationFinalReportVO> list(OdsExaminationFinalReportQueryDTO params) {

        List<OdsExaminationFinalReportInfo> data = odsExaminationFinalReportInfoService.list(new QueryWrapper<OdsExaminationFinalReportInfo>()
                .eq(StrUtil.isNotBlank(params.getVisitId()), "visit_id", params.getVisitId())
                .in(CollectionUtil.isNotEmpty(params.getVisitIds()), "visit_id", params.getVisitIds())
                .orderByDesc("data_create_date")
                .last(" limit 1000 ") // 防止不传参数查询所有导致爆库
        );
        
        return data.stream().map(PatientHealthyHelper::getOdsExaminationFinalReportVO).collect(Collectors.toList());
    }

}
