package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.OdsExaminationRegisterInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.OdsExaminationRegisterInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.OdsExaminationRegisterQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.OdsExaminationRegisterVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.helper.PatientHealthyHelper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.OdsExaminationRegisterBizService;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

@DS("wd")
@Slf4j
@Service
public class OdsExaminationRegisterBizServiceImpl implements OdsExaminationRegisterBizService {
    
    @Autowired
    private OdsExaminationRegisterInfoService odsExaminationRegisterInfoService;

    @Override
    public List<OdsExaminationRegisterVO> list(OdsExaminationRegisterQueryDTO params) {

        List<OdsExaminationRegisterInfo> data = odsExaminationRegisterInfoService.list(new QueryWrapper<OdsExaminationRegisterInfo>()
                .eq(StrUtil.isNotBlank(params.getVisitId()), "visit_id", params.getVisitId())
                .in(CollectionUtil.isNotEmpty(params.getVisitIds()), "visit_id", params.getVisitIds())
                .orderByDesc("data_create_date")
                .last(" limit 1000 ") // 防止不传参数查询所有导致爆库
        );
        
        return data.stream().map(PatientHealthyHelper::getOdsExaminationRegisterVO).collect(Collectors.toList());
    }

}
