package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.OdsFirstCourseIllnessInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.OdsFirstCourseIllnessInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.OdsFirstCourseIllnessGetDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.OdsFirstCourseIllnessQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.OdsFirstCourseIllnessVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.helper.PatientHealthyHelper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.OdsFirstCourseIllnessBizService;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class OdsFirstCourseIllnessBizServiceImpl implements OdsFirstCourseIllnessBizService {

    @Autowired
    private OdsFirstCourseIllnessInfoService odsFirstCourseIllnessInfoService;

    @Override
    public List<OdsFirstCourseIllnessVO> list(OdsFirstCourseIllnessQueryDTO params) {
        List<OdsFirstCourseIllnessInfo> data = odsFirstCourseIllnessInfoService.list(new QueryWrapper<OdsFirstCourseIllnessInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getIpId()), "ip_id", params.getIpId())
                .in(CollectionUtil.isNotEmpty(params.getIpIds()), "ip_id", params.getIpIds())
                .orderByDesc("node_date")
                .last(" limit 1000 ") // TODO 防止不传参数查询所有导致爆库
        );
        List<OdsFirstCourseIllnessVO> list = data.stream().map(PatientHealthyHelper::getOdsFirstCourseIllnessVO).collect(Collectors.toList());

        return list;
    }

    @Override
    public OdsFirstCourseIllnessVO detail(OdsFirstCourseIllnessGetDTO params) {
        OdsFirstCourseIllnessInfo entity = odsFirstCourseIllnessInfoService.getOne(new QueryWrapper<OdsFirstCourseIllnessInfo>()
                .eq("id", params.getId())
                .eq(StrUtil.isNotBlank(params.getIpId()), "ip_id", params.getIpId())
        );
        if (null == entity) {
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }
        OdsFirstCourseIllnessVO vo = PatientHealthyHelper.getOdsFirstCourseIllnessVO(entity);

        return vo;
    }

}
