package com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.entity.OdsPatientPastHisInfo;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.base.service.OdsPatientPastHisInfoService;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.OdsPatientPastHisGetDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.dto.OdsPatientPastHisQueryDTO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.bean.vo.OdsPatientPastHisVO;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.helper.PatientHealthyHelper;
import com.xxh.cloud.dw.healthy.data.dwd.framework.modules.biz.service.OdsPatientPastHisBizService;
import com.xxh.cloud.framework.common.exception.BusinessBaseErrorEnum;
import com.xxh.cloud.framework.common.exception.BusinessException;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class OdsPatientPastHisBizServiceImpl implements OdsPatientPastHisBizService {

    @Autowired
    private OdsPatientPastHisInfoService odsPatientPastHisInfoService;

    @Override
    public List<OdsPatientPastHisVO> list(OdsPatientPastHisQueryDTO params) {
        List<OdsPatientPastHisInfo> data = odsPatientPastHisInfoService.list(new QueryWrapper<OdsPatientPastHisInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .in(CollectionUtil.isNotEmpty(params.getIds()), "id", params.getIds())
                .eq(StrUtil.isNotBlank(params.getRegisterId()), "register_id", params.getRegisterId())
                .in(CollectionUtil.isNotEmpty(params.getRegisterIds()), "register_id", params.getRegisterIds())
                .orderByDesc("treat_date")
                .last(" limit 1000 ") // TODO 防止不传参数查询所有导致爆库
        );
        List<OdsPatientPastHisVO> list = data.stream().map(PatientHealthyHelper::getOdsPatientPastHisVO).collect(Collectors.toList());

        return list;
    }

    @Override
    public OdsPatientPastHisVO detail(OdsPatientPastHisGetDTO params) {
        OdsPatientPastHisInfo entity = odsPatientPastHisInfoService.getOne(new QueryWrapper<OdsPatientPastHisInfo>()
                .eq("id", params.getId())
                .eq(StrUtil.isNotBlank(params.getRegisterId()), "register_id", params.getRegisterId())
                .in(null != params.getTreatDate(), "treat_date", params.getTreatDate())
        );
        if (null == entity) {
            throw new BusinessException(BusinessBaseErrorEnum.DB_RECORD_NOT_EXISTS);
        }
        OdsPatientPastHisVO vo = PatientHealthyHelper.getOdsPatientPastHisVO(entity);

        return vo;
    }

}
