package com.xxh.cloud.dw.healthy.data.dws.framework.modules.biz.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.dw.healthy.data.dws.framework.modules.base.entity.DwsPatientEventInfo;
import com.xxh.cloud.dw.healthy.data.dws.framework.modules.base.service.DwsPatientEventInfoService;
import com.xxh.cloud.dw.healthy.data.dws.framework.modules.biz.service.DwsPatientEventMgrBizService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@DS("wd")
@Service
public class DwsPatientEventMgrBizServiceImpl implements DwsPatientEventMgrBizService {

    @Autowired
    private DwsPatientEventInfoService dwsPatientEventInfoService;


    @Override
    public List<DwsPatientEventInfo> listBeanByPatient(String patientId) {
        List<DwsPatientEventInfo> data= dwsPatientEventInfoService.list(
                new QueryWrapper<DwsPatientEventInfo>()
                        .eq("patient_id",patientId)
        );
        return data;
    }

    @Override
    public List<DwsPatientEventInfo> listBeanByPatient(List<String> patientIds) {
        List<DwsPatientEventInfo> data= dwsPatientEventInfoService.list(
                new QueryWrapper<DwsPatientEventInfo>()
                        .in("patient_id",patientIds)
        );
        return data;
    }
}
