package com.xxh.cloud.dw.healthy.data.query.framework.modules.biz.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.xxh.cloud.dw.healthy.data.query.framework.modules.biz.mapper.MySqlOperateMapper;
import com.xxh.cloud.dw.healthy.data.query.framework.modules.biz.models.vos.DwTableColumnConfigBO;
import com.xxh.cloud.dw.healthy.data.query.framework.modules.biz.models.vos.DwTableConfigBO;
import com.xxh.cloud.dw.healthy.data.query.framework.modules.biz.service.DwdTableSchemaQueryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
@DS("wd")
@Service
public class DwdTableSchemaQueryServiceImpl implements DwdTableSchemaQueryService {


    @Autowired
    private MySqlOperateMapper mySqlOperateMapper;

    private String Query_TableColumn_TableSchema_SQL="SELECT table_name, column_name,data_type,column_size,decimal_digits,column_comment FROM information_schema.COLUMNS where table_schema='{}' ";
    private String Query_TableColumn_TableName_SQL="SELECT table_name, column_name,data_type,column_size,decimal_digits,column_comment FROM information_schema.COLUMNS where table_schema='{}' and table_name='{}' ";


    @Override
    public List<DwTableColumnConfigBO> getColumnByTable(String tableSchema, String tableName) {
        String sql= StrUtil.format(Query_TableColumn_TableName_SQL,tableSchema,tableName);
        List<Map<String,Object>> mapList = mySqlOperateMapper.selectList(sql);
        if(CollUtil.isEmpty(mapList)){
            return null;
        }
        List<DwTableColumnConfigBO> data=new ArrayList<>();
        mapList.forEach(map->{
            DwTableColumnConfigBO entity = BeanUtil.fillBeanWithMapIgnoreCase(map, new DwTableColumnConfigBO(), false);
            data.add(entity);
        });
        return data;
    }

    @Override
    public DwTableConfigBO getTableConfig(String tableSchema , String tableName){
        String sql= StrUtil.format(Query_TableColumn_TableName_SQL,tableSchema,tableName);
        List<Map<String,Object>> mapList = mySqlOperateMapper.selectList(sql);
        if(CollUtil.isEmpty(mapList)){
            return null;
        }

        List<DwTableColumnConfigBO> cols=new ArrayList<>();
        mapList.forEach(map->{
            DwTableColumnConfigBO entity = BeanUtil.fillBeanWithMapIgnoreCase(map, new DwTableColumnConfigBO(), false);
            cols.add(entity);
        });

        DwTableConfigBO data=new DwTableConfigBO();
        data.setTable_name(tableName);
        data.setCols(cols);
        return data;
    }

    @Override
    public List<DwTableConfigBO> getTableBySchema(String tableSchema) {
        String sql= StrUtil.format(Query_TableColumn_TableSchema_SQL,tableSchema);
        List<Map<String,Object>> mapList = mySqlOperateMapper.selectList(sql);
        if(CollUtil.isEmpty(mapList)){
            return null;
        }

        Map<String,DwTableConfigBO> dwTableConfigMap=new HashMap<>();
        mapList.forEach(map->{
            DwTableColumnConfigBO entity = BeanUtil.fillBeanWithMapIgnoreCase(map, new DwTableColumnConfigBO(), false);
            DwTableConfigBO tableConfigBO =  dwTableConfigMap.get(entity.getTable_name());
            if(tableConfigBO==null){
                tableConfigBO=new DwTableConfigBO(entity.getTable_name());
                dwTableConfigMap.put(entity.getTable_name(),tableConfigBO);
            }
            tableConfigBO.addCol(entity);
        });

        List<DwTableConfigBO> data=new ArrayList<>();
        dwTableConfigMap.forEach((k,v)->{
            data.add(v);
        });
        return data;
    }


}
